#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif /* HAVE_CONFIG_H */

#include "manconfig.h"

/* Flex emits several functions which might reasonably have various
 * attributes applied and many unused macros; none of these are our problem.
 */
#if GNUC_PREREQ(8,0)
#  pragma GCC diagnostic ignored "-Wsuggest-attribute=malloc"
#endif
#pragma GCC diagnostic ignored "-Wsuggest-attribute=pure"
#pragma GCC diagnostic ignored "-Wunused-macros"

#line 17 "lexgrog.c"

#define  YY_INT_ALIGNED short int

/* A lexical scanner generated by flex */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 6
#define YY_FLEX_SUBMINOR_VERSION 4
#if YY_FLEX_SUBMINOR_VERSION > 0
#define FLEX_BETA
#endif

/* First, we deal with  platform-specific or compiler-specific issues. */

/* begin standard C headers. */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>

/* end standard C headers. */

/* flex integer type definitions */

#ifndef FLEXINT_H
#define FLEXINT_H

/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */

#if defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L

/* C99 says to define __STDC_LIMIT_MACROS before including stdint.h,
 * if you want the limit (max/min) macros for int types. 
 */
#ifndef __STDC_LIMIT_MACROS
#define __STDC_LIMIT_MACROS 1
#endif

#include <inttypes.h>
typedef int8_t flex_int8_t;
typedef uint8_t flex_uint8_t;
typedef int16_t flex_int16_t;
typedef uint16_t flex_uint16_t;
typedef int32_t flex_int32_t;
typedef uint32_t flex_uint32_t;
#else
typedef signed char flex_int8_t;
typedef short int flex_int16_t;
typedef int flex_int32_t;
typedef unsigned char flex_uint8_t; 
typedef unsigned short int flex_uint16_t;
typedef unsigned int flex_uint32_t;

/* Limits of integral types. */
#ifndef INT8_MIN
#define INT8_MIN               (-128)
#endif
#ifndef INT16_MIN
#define INT16_MIN              (-32767-1)
#endif
#ifndef INT32_MIN
#define INT32_MIN              (-2147483647-1)
#endif
#ifndef INT8_MAX
#define INT8_MAX               (127)
#endif
#ifndef INT16_MAX
#define INT16_MAX              (32767)
#endif
#ifndef INT32_MAX
#define INT32_MAX              (2147483647)
#endif
#ifndef UINT8_MAX
#define UINT8_MAX              (255U)
#endif
#ifndef UINT16_MAX
#define UINT16_MAX             (65535U)
#endif
#ifndef UINT32_MAX
#define UINT32_MAX             (4294967295U)
#endif

#ifndef SIZE_MAX
#define SIZE_MAX               (~(size_t)0)
#endif

#endif /* ! C99 */

#endif /* ! FLEXINT_H */

/* begin standard C++ headers. */

/* TODO: this is always defined, so inline it */
#define yyconst const

#if defined(__GNUC__) && __GNUC__ >= 3
#define yynoreturn __attribute__((__noreturn__))
#else
#define yynoreturn
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an
 *   integer in range [0..255] for use as an array index.
 */
#define YY_SC_TO_UI(c) ((YY_CHAR) (c))

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN (yy_start) = 1 + 2 *
/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START (((yy_start) - 1) / 2)
#define YYSTATE YY_START
/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)
/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart( yyin  )
#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#ifndef YY_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k.
 * Moreover, YY_BUF_SIZE is 2*YY_READ_BUF_SIZE in the general case.
 * Ditto for the __ia64__ case accordingly.
 */
#define YY_BUF_SIZE 32768
#else
#define YY_BUF_SIZE 16384
#endif /* __ia64__ */
#endif

/* The state buf must be large enough to hold one state per character in the main buffer.
 */
#define YY_STATE_BUF_SIZE   ((YY_BUF_SIZE + 2) * sizeof(yy_state_type))

#ifndef YY_TYPEDEF_YY_BUFFER_STATE
#define YY_TYPEDEF_YY_BUFFER_STATE
typedef struct yy_buffer_state *YY_BUFFER_STATE;
#endif

#ifndef YY_TYPEDEF_YY_SIZE_T
#define YY_TYPEDEF_YY_SIZE_T
typedef size_t yy_size_t;
#endif

extern int yyleng;

extern FILE *yyin, *yyout;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2
    
    #define YY_LESS_LINENO(n)
    #define YY_LINENO_REWIND_TO(ptr)
    
/* Return all but the first "n" matched characters back to the input stream. */
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		*yy_cp = (yy_hold_char); \
		YY_RESTORE_YY_MORE_OFFSET \
		(yy_c_buf_p) = yy_cp = yy_bp + yyless_macro_arg - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )
#define unput(c) yyunput( c, (yytext_ptr)  )

#ifndef YY_STRUCT_YY_BUFFER_STATE
#define YY_STRUCT_YY_BUFFER_STATE
struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	int yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

    int yy_bs_lineno; /**< The line count. */
    int yy_bs_column; /**< The column count. */

	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;

#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2

	};
#endif /* !YY_STRUCT_YY_BUFFER_STATE */

/* Stack of input buffers. */
static size_t yy_buffer_stack_top = 0; /**< index of top of stack. */
static size_t yy_buffer_stack_max = 0; /**< capacity of stack. */
static YY_BUFFER_STATE * yy_buffer_stack = NULL; /**< Stack as an array. */

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 *
 * Returns the top of the stack, or NULL.
 */
#define YY_CURRENT_BUFFER ( (yy_buffer_stack) \
                          ? (yy_buffer_stack)[(yy_buffer_stack_top)] \
                          : NULL)
/* Same as previous macro, but useful when we know that the buffer stack is not
 * NULL or when we need an lvalue. For internal use only.
 */
#define YY_CURRENT_BUFFER_LVALUE (yy_buffer_stack)[(yy_buffer_stack_top)]

/* yy_hold_char holds the character lost when yytext is formed. */
static char yy_hold_char;
static int yy_n_chars;		/* number of characters read into yy_ch_buf */
int yyleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = NULL;
static int yy_init = 0;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* Flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

void yyrestart ( FILE *input_file  );
void yy_switch_to_buffer ( YY_BUFFER_STATE new_buffer  );
YY_BUFFER_STATE yy_create_buffer ( FILE *file, int size  );
void yy_delete_buffer ( YY_BUFFER_STATE b  );
void yy_flush_buffer ( YY_BUFFER_STATE b  );
void yypush_buffer_state ( YY_BUFFER_STATE new_buffer  );
void yypop_buffer_state ( void );

static void yyensure_buffer_stack ( void );
static void yy_load_buffer_state ( void );
static void yy_init_buffer ( YY_BUFFER_STATE b, FILE *file  );
#define YY_FLUSH_BUFFER yy_flush_buffer( YY_CURRENT_BUFFER )

YY_BUFFER_STATE yy_scan_buffer ( char *base, yy_size_t size  );
YY_BUFFER_STATE yy_scan_string ( const char *yy_str  );
YY_BUFFER_STATE yy_scan_bytes ( const char *bytes, int len  );

void *yyalloc ( yy_size_t  );
void *yyrealloc ( void *, yy_size_t  );
void yyfree ( void *  );

#define yy_new_buffer yy_create_buffer
#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){ \
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer( yyin, YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_is_interactive = is_interactive; \
	}
#define yy_set_bol(at_bol) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){\
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer( yyin, YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = at_bol; \
	}
#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->yy_at_bol)

/* Begin user sect3 */

#define yywrap() (/*CONSTCOND*/1)
#define YY_SKIP_YYWRAP
typedef flex_uint8_t YY_CHAR;

FILE *yyin = NULL, *yyout = NULL;

typedef int yy_state_type;

extern int yylineno;
int yylineno = 1;

extern char *yytext;
#ifdef yytext_ptr
#undef yytext_ptr
#endif
#define yytext_ptr yytext

static yy_state_type yy_get_previous_state ( void );
static yy_state_type yy_try_NUL_trans ( yy_state_type current_state  );
static int yy_get_next_buffer ( void );
static void yynoreturn yy_fatal_error ( const char* msg  );

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	(yytext_ptr) = yy_bp; \
	yyleng = (int) (yy_cp - yy_bp); \
	(yy_hold_char) = *yy_cp; \
	*yy_cp = '\0'; \
	(yy_c_buf_p) = yy_cp;
#define YY_NUM_RULES 141
#define YY_END_OF_BUFFER 142
/* This struct is not used in this scanner,
   but its presence is necessary. */
struct yy_trans_info
	{
	flex_int32_t yy_verify;
	flex_int32_t yy_nxt;
	};
static const flex_int16_t yy_accept[1573] =
    {   0,
        0,    0,    0,    0,   67,   67,   67,   67,    0,    0,
        0,    0,    0,    0,    0,    0,  119,  119,    0,    0,
        0,    0,    0,    0,  126,  126,    8,    8,    0,    0,
        0,    0,    0,    0,    0,    0,  142,  141,   29,   29,
       29,  140,   67,   67,  140,  140,  140,  138,  140,  136,
       83,   67,   67,  140,   83,  106,  106,  106,  101,  106,
      108,  108,  107,  113,  113,  113,  112,  118,  118,  118,
      118,  118,  119,  121,  121,  120,  123,  123,  122,  125,
      125,  124,  126,  126,  140,  137,  140,  140,  140,    7,
       10,    7,    7,    6,    6,    6,    4,   18,   18,   18,

       19,   19,    0,   28,    0,   27,   27,   29,   67,    0,
      138,    0,    0,  139,   67,   67,  139,  135,  139,  139,
      135,   83,   67,    0,    0,  138,    0,  136,   70,   67,
       76,    0,   62,    0,    0,   64,   66,    0,    0,   61,
       63,   61,    0,    0,    0,    0,    0,    0,   67,    0,
       67,   67,  139,  135,   83,   67,    0,   64,    0,  106,
        0,    0,  101,   94,   95,   96,   97,   98,   99,  100,
      108,  107,  113,    0,    0,    0,  112,  112,  118,    0,
        0,    0,  119,  121,  120,  123,  122,  125,  124,  126,
      137,    0,    0,  126,  126,  139,  139,  139,  139,  126,

      137,   54,    0,  126,   39,    7,    0,    9,    0,   10,
        7,    6,    0,    3,    4,    3,    4,    3,   18,    0,
        0,    0,   18,   19,   28,    0,    0,    0,   27,   27,
       27,   27,   27,   27,   27,   27,   27,   27,   57,    0,
        0,   67,    0,    0,   36,   36,   36,   36,   36,   36,
       36,   36,    0,   50,    0,    0,    0,    0,    0,    0,
      130,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,   48,    0,   57,    0,   49,    0,   58,   76,
       72,    0,    0,    0,    0,    0,    0,    0,    0,   75,
       75,   75,    0,    0,    0,    0,    0,    0,   69,    0,

       77,   78,    0,   79,    0,    0,   81,    0,    0,   67,
        0,    0,   36,   36,   36,   36,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
       93,  102,  103,  104,  105,  101,   94,   95,   96,   97,
       98,   99,  100,    0,    0,    0,    0,    0,    0,   60,
        0,  126,   38,   38,  126,   38,   38,   38,   38,   37,
       54,    7,    0,    0,    0,    9,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    7,    5,    3,    3,    4,
        4,    4,    3,    0,    0,    0,    0,    0,   16,    0,

       21,   27,   27,   27,   27,   20,   27,   27,   27,   57,
        0,    0,    0,    0,    0,    0,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   51,   41,    0,    0,    0,
        0,    0,  128,   59,    0,  130,   47,  129,    0,    0,
       30,    0,    0,    0,  127,   34,   53,    0,   35,   33,
       52,   32,    0,    0,    0,   49,   84,   73,   62,   55,

       63,   68,    0,    0,    0,    0,    0,    0,    0,    0,
        0,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   85,    0,   87,   92,   88,   89,   90,
       91,    0,    0,    0,   64,    0,   93,  102,  103,  104,
      105,    0,    0,    0,  116,  114,    0,   38,   38,   38,
       38,   37,   38,   38,    7,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    7,    5,    3,    3,    4,    4,    4,    0,
        3,    3,   12,   14,   13,   15,   11,   17,   21,   25,

       26,   20,   22,   24,   23,   55,    0,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   30,   36,   36,   36,
       36,   34,   36,   36,   35,   33,   36,   32,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   40,  132,  131,   45,
      128,   59,   46,   47,  129,  134,  133,   30,   42,   44,
       31,  127,   34,   34,   53,   43,   35,   33,   52,   32,
        0,   84,   55,   74,    0,   71,   56,   80,   82,   36,

       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   85,   86,   87,   92,   88,   89,   90,
       91,    0,   65,    0,  110,    0,  116,  117,  114,  115,
       38,   38,    7,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    7,    3,    3,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    3,    3,   25,   26,   22,   24,   23,
       56,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       30,   36,   36,   31,   36,   34,   34,   36,   36,   35,
       33,   36,   32,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,  132,  131,   45,  134,  133,
       44,   43,   56,   56,   82,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   86,   65,  109,  110,  111,
      117,  115,    7,    2,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    7,    3,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    1,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    1,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    3,   36,   36,   36,   36,   36,   36,

       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,  109,  111,    7,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    7,    3,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    1,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    1,    1,    4,
        4,    1,    4,    4,    4,    4,    4,    4,    4,    4,

        1,    4,    1,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    1,    1,    0,    0,    1,
        0,    0,    0,    0,    0,    0,    0,    0,    1,    0,
        1,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    3,   36,   36,   36,    7,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    7,    3,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,

        4,    4,    4,    4,    4,    4,    4,    1,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    1,    1,    4,    4,    1,    4,    4,
        4,    4,    4,    4,    4,    4,    1,    4,    1,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    1,    4,    4,    4,    4,    4,    4,    4,    4,
        1,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,

        1,    0,    0,    0,    0,    0,    0,    0,    0,    1,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    3,
        7,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    7,
        3,    3,    4,    4,    1,    0,    1,    0,    1,    0,
        1,    0,    0,    0,    0,    0,    0,    1,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    3,    3,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    8,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    1,    1,    0,
        0,    0,    0,    0,    0,    1,    1,    1,    0,    1,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    0,
        0,    0,    0,    0,    0,    0,    1,    0,    1,    0,
        0,    0,    0,    0,    0,    0,    0,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    0,    0,

        0,    0,    1,    1,    0,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    0,    0,    0,    0,    1,    1,
        1,    1,    1,    1,    0,    0,    0,    0,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        0,    0,    0,    0,    1,    1,    1,    0,    0,    0,
        0,    0,    0,    0,    0,    1,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        1,    0
    } ;

static const YY_CHAR yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    4,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    5,    6,    7,    8,    9,    6,   10,   11,   12,
       13,   14,   15,   16,   17,   18,    1,   19,   20,   21,
       22,   23,   24,   25,   26,   27,   27,    1,    1,    1,
        1,    1,    1,    1,   28,   29,   30,   31,   32,   33,
       34,   35,   36,   37,   38,   39,   40,   41,   42,   43,
       44,   45,   46,   47,   48,   49,   50,   51,   52,   53,
       54,   55,   56,    6,   57,   58,   59,   60,   61,   62,

       63,   64,   65,   66,   67,   68,   69,   70,   71,   72,
       73,   74,   75,   76,   77,   78,   79,   80,   81,   82,
       83,   84,    6,   85,    6,   86,    1,    1,   87,    1,
        1,   88,   89,   90,    1,    1,   91,   92,    1,    1,
       93,    1,   94,   95,   96,   97,    1,    1,   98,    1,
       99,  100,    1,    1,    1,  101,  102,  103,    1,    1,
      104,    1,    1,  105,  106,  107,  108,  109,  110,  111,
        1,    1,  112,  113,  114,  115,  116,  117,  118,  119,
      120,    1,  121,  122,  123,    1,  124,  125,  126,  127,
        1,    1,    1,    1,  128,  129,    1,    1,    1,    1,

        1,    1,    1,  130,    1,    1,    1,  131,  132,    1,
        1,    1,    1,    1,    1,  133,  134,    1,    1,    1,
        1,    1,    1,  135,    1,    1,    1,  136,  137,    1,
      138,    1,    1,    1,  139,  140,    1,    1,  141,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static const YY_CHAR yy_meta[142] =
    {   0,
        1,    2,    3,    4,    2,    1,    5,    1,    1,    1,
        6,    7,    1,    1,    1,    1,    1,    1,    8,    9,
        9,    9,    9,    8,    8,    8,    8,   10,   10,   10,
       10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
       10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
       10,   10,   10,    1,    1,    1,    1,    1,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1
    } ;

static const flex_int16_t yy_base[1757] =
    {   0,
        0,    0,    0,    2,    6,    0,  146,  150,  153,  154,
      234,    0,  375,    0,  152,  513, 6012, 6011,  591,    0,
      732,    0,  873,    0,  157,  166,  161,  174,  176,  177,
        0,    0,  181,  186, 6006, 6005, 6003, 7559, 7559,  206,
     5990, 7559,  516,  523, 1013, 5927, 5916,  191, 5943,    0,
     1066, 1024, 1031, 5931,  512, 7559, 5920, 5891,  202,  522,
     7559, 5898,    0, 7559, 5888,  156,  224, 7559, 5887, 5822,
     5817, 5820,    0, 7559, 5875,    0, 7559, 5866,    0, 7559,
     5865,    0, 1036, 1042, 5864,  534,  216, 5852, 5790,    0,
      551, 5843, 5831, 7559, 5832, 5779, 1054,    0,  546, 5821,

     7559, 5666,  565,  569, 5665,    0, 1120, 1090, 1155, 1171,
      557, 5650, 1099, 7559, 1176, 1187, 1198, 5611, 5610, 5647,
     1252, 1327, 1216, 5656, 5577,  572,  574,    0, 7559, 1026,
        0, 1223, 7559, 1193,  511,  579, 7559, 1046,  519, 5583,
     7559, 7559, 5648,    0, 5647, 5651, 1332, 1054, 1206, 1020,
     1234, 1272, 5654, 1280, 1010, 1359, 1356, 7559, 1044, 7559,
     5576, 1245, 1418, 1018, 1019, 1058, 1085, 1112, 1117, 1132,
     7559,    0, 7559, 5585, 5591, 5590, 1181, 1204, 7559, 5574,
     5579, 5584,    0, 7559,    0, 7559,    0, 7559,    0, 1363,
     1370, 1426, 5644, 1393, 1442, 5645, 1050, 5642, 5589, 1447,

     1451, 1455, 5642, 1227, 7559,    0, 1459, 1503, 5641, 1463,
     5638, 7559, 5626, 5625, 5624, 5623, 1435, 5622,    0, 1276,
     5625, 1437, 1282, 7559, 7559, 5624, 1472, 5623,    0, 1484,
     1490, 5554,  177, 1481, 5552, 1153, 5545, 1476, 1212, 1239,
     1252, 1521, 1552, 1558, 5618, 1563, 1569, 1034, 1100,  169,
     1642, 1717, 1431, 7559, 5616, 1543, 5575, 1576, 5510,  460,
     1472, 1553, 1624, 5480, 1200,    0, 5475, 5487,  508, 1099,
     5485, 1548, 7559, 5536, 1315, 1277,    0, 5534, 1532,    0,
     7559,    0, 5487,  160, 5486, 5461, 5476, 5462, 5469, 7559,
        0,    0, 1582,    0,    0,  983, 5455, 5469, 7559,    0,

     7559, 7559,    0, 7559,    0, 1718, 7559, 1590,    0, 1606,
     1063, 5523, 1601, 5522, 1802, 1877, 5446, 1618, 5448, 5440,
     1041, 5439, 5438, 1586, 1123, 5436, 5451, 1152, 5434, 5449,
     1547, 1610, 1624, 1646, 1653, 1660, 1664, 1670, 1677, 1694,
     1703, 1708, 1710, 5440, 5434, 5431, 5420, 5409, 5408, 1744,
     1748, 1753,    0, 1757, 1764, 5477, 1777, 5470, 5417, 7559,
     1811,    0, 1962, 5470,    0, 1820, 5469,  499,  525,  979,
     1233, 1362, 1941, 1450, 5343, 5424, 5354, 5339,   98, 5357,
     5374, 5350, 1145, 5351, 5359, 5455,    0, 5452, 5451, 5450,
     5449, 1868, 5448, 5410, 5433, 5406, 5431, 5404, 7559, 5403,

        0, 1728, 1752, 1758, 1759, 1780, 1834, 1850, 1854, 1856,
     1254, 5365, 5380, 1312, 5363, 5378, 5441, 1897, 1905, 1151,
     1916, 1967, 1289, 1193, 1901, 1910, 5440, 1990, 1373, 2013,
     1470, 1423, 2008, 1998, 2028, 1179, 1864, 2109, 1574, 1167,
     1625, 1533, 1303, 2052, 5439, 1923,    0, 2160, 5438, 5437,
     2007, 5418, 2020, 5425, 2035, 2044, 1184, 5423, 5422, 2185,
     2236, 2309, 1493, 2391, 2074, 7559, 1980, 1863, 1888, 1940,
     1992, 2031, 2047, 2057, 2079, 2098, 2104, 2111, 2112, 2117,
     2118, 2119, 2123, 2125, 2129, 2173,    0, 2131, 2162, 2163,
        0, 2164, 1519, 5341, 5356,    0, 2168, 7559, 7559, 2169,

     7559, 7559,    0,    0, 5411, 5365, 5364,    0,    0, 5411,
     5405, 5412, 2244, 1339, 2362, 1476, 1059, 1729, 1636, 1683,
     2133, 5384, 2187, 2174, 5304, 2189, 2198, 2239, 2240, 2241,
     2246, 1545, 5302, 5317, 7559, 5323, 2250, 2252, 2254, 2288,
     2289, 5312, 5318, 5313, 2398, 2321, 5312,    0, 2418, 2423,
     5369,    0, 2394,    0,    0, 2472, 5370,    0, 2329, 1614,
     1648, 2369, 1791, 2401, 1797, 1852, 1858, 1877, 2343, 1895,
     1258, 1725, 1536, 5239, 5238, 1693, 5235, 5256, 5273, 5239,
     5275, 5244, 5357,    0, 5354, 5353, 5352, 5351, 2611, 2750,
     5350, 5349, 7559, 7559, 7559, 7559, 7559, 7559,    0,    0,

        0, 2322,    0,    0,    0, 2323, 5299, 2380, 2392,    0,
     5341, 2361, 2431, 2400, 2440, 2454, 2459, 2460, 2464, 2465,
     2466, 2477, 2478, 2482, 2484, 2486, 2488, 2490, 2494, 2500,
     2501, 2502,    0, 2509, 2515, 2516,    0, 2521,    0,    0,
        0, 5294, 1645, 5293, 5268, 5283, 5270, 5278,    0,    0,
     2522, 1815, 1909, 5264, 5279,    0, 2863,    0,    0, 2889,
        0, 1781, 2521,    0, 2523, 1894, 7559,    0,    0,    0,
     2527, 2533, 2547, 2548, 2549,    0,    0, 2553, 2554,    0,
     2555, 2559, 2560, 2561,    0,    0, 2565, 2566,    0, 2570,
     5289, 2571, 2572, 7559, 5288, 7559, 2576, 7559,    0, 2577,

     5252, 2578, 2582, 2583, 2584, 2588, 2589, 1935, 5249, 5263,
     1989, 5246, 5261, 2590, 2594, 2595, 2615, 2617, 2619, 2621,
     2623, 5271, 7559, 5267, 2625, 5255, 2627, 2629, 2631, 2633,
     2639, 2657,    0, 2665, 2644, 5321, 1956, 2669, 1971, 5310,
     1820, 1975, 2221, 2647, 2380, 2614, 2680, 2609, 2696, 2623,
     2603, 2635, 2624, 5280, 5204, 5200, 5182, 1277, 1881, 5201,
     5164, 5175, 5147, 2675, 5145, 5140, 5140, 5273,    0,    0,
        0,    0, 2972, 2734, 2658, 2658, 2651, 2652, 2661, 2760,
     2674, 5149, 1148, 5228, 5158, 5145,  125, 5163, 5180, 5156,
     1993, 5157, 5165, 2955, 2672, 2672, 2665, 2668, 2680, 2988,

     2688, 5138, 1360, 5219, 5149, 5136, 1776, 5154, 5170, 5146,
     2106, 5147, 5155,    0,    0,    0,    0,    0,    0,    0,
     2709, 2139, 5173, 5188, 2264, 5171, 5186,    0, 2713,    0,
        0,    0,    0, 2724, 2725, 2756, 2762, 2763,    0,    0,
     2771, 2778,    0, 2780, 2793, 2798, 2802,    0,    0, 2804,
     2809,    0, 2813,    0,    0, 2819,    0,    0,    0, 2021,
     5194, 3089, 3115, 2047, 2064,    0,    0,    0,    0,    0,
        0,    0, 2820, 2824,    0, 2826, 2830, 2832, 2836, 2838,
     2840, 2842, 2844,    0, 5193, 2846, 7559, 2848, 2850, 2852,
     2854, 2856,    0, 2870, 2763, 2905, 5237, 2931, 2958, 2942,

     3001, 2958, 2963, 5143, 5119, 2399, 5101, 5098, 5107, 5094,
     5112, 2399, 2366, 2623, 5100, 5100, 5114, 5215,    0,    0,
     3198, 3181, 2966, 2975, 2974, 2983, 2994, 3214, 3001, 5091,
     1964, 5171, 5101, 5088, 2160, 5104, 5119, 5094, 2781, 5092,
     5096, 3041, 2978, 3000, 3045, 2992, 3215, 2985, 2995, 2997,
     3000, 2965, 2992, 1979, 3331, 3281, 2381, 2806, 5064, 5063,
     2263, 5058, 5079, 5096, 5060, 5093, 5030, 3206, 2996, 3018,
     3197, 3038, 3357, 3033, 3043, 3166, 3176, 2983, 3171, 2967,
     5135, 3398, 2749, 2808, 5014, 5010, 2847, 5004, 5022, 5033,
     4996, 5032, 5001,    0, 2980, 5063, 3167,    0,    0,    0,

        0,    0,    0,    0, 3202,    0,    0, 3210,    0, 3228,
     3252,    0, 3261, 3265,    0, 3210, 3280, 3212, 3217, 3209,
     3223, 3342, 3174, 5024, 3287, 5007, 4979, 5022, 4996, 4973,
     2989, 4984, 4966, 4962, 4972, 4964, 4986, 5038,    0,    0,
     3440, 3423, 3247, 3259, 3252, 3277, 3287, 3456, 3296, 4910,
     2345, 4991, 4919, 4906, 2508, 4918, 4935, 4907, 3075, 4905,
     4887, 3334, 3273, 3363, 3372, 3357, 3457, 3350, 3360, 3361,
     3362, 3301, 3354, 3238, 3573, 3523, 2753, 3253, 4853, 4846,
     3091, 4841, 4862, 4878, 4840, 4876, 4843, 3448, 3274, 3027,
     3375, 3484, 3395, 4949, 3302, 3398, 3408, 3492, 3421, 3446,

     3576, 3436, 3625, 3442, 3441, 3471, 3460, 3671, 3605, 3670,
     3718, 4912, 4836, 4856, 4813, 2007, 2542, 4830, 4793, 4808,
     4779, 3452, 4747, 4741, 4736, 3507, 3444, 3444, 3502, 3671,
     3495, 4862, 3348, 3519, 3526, 3612, 3527, 3601, 3672, 3562,
     3746, 3596, 3582, 3610, 3598,    0, 3740, 3791, 3795, 4833,
     4756, 4778, 4757, 2612, 2602, 4733, 4696, 4711, 4682, 3653,
     4679, 4671, 4671,    0, 3586, 3645, 3659,    0, 3621, 3684,
     3726, 3794, 4677, 4675, 4672, 4684, 4640, 4658, 3800, 3823,
     3841, 4628, 3861, 4756, 4751, 4747, 3934, 3853, 3777, 3730,
     3814, 3827, 3757, 3885, 3881, 1507, 3454, 1595, 1967, 2759,

     3759, 2702, 2986, 1385, 3676, 2487, 3579, 3899, 3679, 3879,
     3890, 3815, 3966, 3823, 3876, 3936, 3939, 3912, 3869, 3903,
     2165, 4032, 3327, 3822, 2058, 3092, 3750, 1835, 3108, 2777,
     2646, 3779, 1353, 3900, 3995, 3495, 3948, 4021, 3924, 3046,
     3642, 3962, 3965, 4034, 3971, 4041, 4025, 4053, 4081, 4038,
     4031, 4033, 4037, 4728, 4088, 4126, 4130, 1766, 2322, 3658,
     3306, 3908, 3984, 3575, 1810, 3468, 3743, 4098, 2700, 2859,
     3504, 4080, 3510, 4167, 4132, 4065, 3763, 3949, 4083, 4087,
     4174, 4133, 4095, 4188, 3760, 3736, 3892, 3905, 4074, 3629,
     3207, 1523, 2855, 3351, 4024, 4089, 4010, 3349, 3772, 2753,

     4019, 3954, 4228, 4136, 4141, 4722, 4153, 4179, 4168, 4232,
     4194, 4200, 4710, 4604, 4615, 4581, 4549, 3709, 4531, 4525,
     4533, 4519, 4537, 3813, 4129, 3859, 4523, 4522, 4509, 4608,
     7559, 4199, 4222, 4175, 4131, 4485, 4453, 4464, 4274, 4278,
     4291, 4296, 4303, 4307, 4311, 4315, 4319, 4323, 4463, 4545,
        0,    0, 7559, 4301, 4125,    0, 4329, 4338, 4338, 4272,
     4344, 4303, 4307, 4298, 4314, 4381, 4525, 4367, 4170, 4430,
     4254, 4415, 4350, 4388, 4383, 4355, 4177, 4367, 4318, 4313,
     4322, 4273, 4291,    0,    0, 4304, 4315, 4242, 4201, 4172,
     4157, 4185, 4128, 4385, 4407, 4411, 4137, 4211, 4430, 4135,

     4111, 4357, 4353, 4435, 4435,    0, 4451, 4419, 4441, 4038,
     4033, 4027, 4038, 3986, 3997, 4442, 4479, 4488, 3967, 4498,
     4356, 4411, 4019, 4081, 4168, 4009, 4489, 4030, 4427, 4453,
     4505, 4422, 4266, 3916, 3874, 3844, 4528, 4540, 4544, 4550,
     4554, 4571, 4587, 4591, 4595, 4599, 4605, 4606, 4612, 3828,
     4467, 4461, 4618, 4415, 3783, 4613, 4375,    0, 4622, 4475,
     4489, 3702, 3663, 3661, 3648, 3652, 3486, 4623, 4748, 4675,
     4650, 4802, 4701, 4664, 4856, 4908, 3494, 4269, 4343, 4663,
     4490, 4508, 4109, 4368, 4443, 3437, 4962, 4686, 4917, 4702,
     5016, 4708, 5068, 4757, 5122, 4811, 5077, 4857, 3265, 3166,

     4506, 4502, 4974, 4865, 3138, 4717, 5123, 5129, 4722, 5133,
     5137, 4933, 5141, 5174, 4541, 4541, 4547, 4585, 5220, 5264,
     5316, 5360, 5412, 5456, 2913, 2663, 2618, 2473, 5508, 4973,
     5536, 4980, 5535, 4981, 5563, 5017, 5615, 5025, 5643, 5178,
     4545, 4615, 4548, 4645, 4937, 5019, 5094, 4824, 2385, 2367,
     2300, 4636, 4616, 4649, 2264, 5197, 2064, 4754, 4652, 1697,
     1563, 4652, 4824, 1553, 1537, 4762, 4846, 5105, 1499, 4850,
     5206, 7559, 5696, 5707, 5718, 5729, 5740, 5751, 5762, 5773,
     5784, 5795, 5806, 5810, 5821, 5832, 5843, 5854, 5865, 5876,
     5887, 5898, 5909, 5920, 5931, 5942, 5946, 5957, 5968, 5979,

     5990, 5995, 5996, 6001, 6012, 6023, 6034, 6045, 6056, 6067,
     6078, 6089, 6100, 6111, 6122, 6133, 6144, 1225, 6155, 6166,
     6177, 6188, 6199, 6210, 6221, 6232, 1197, 6234, 6245, 6256,
     6267, 6278, 6289, 6300, 6311, 6322, 6333, 6344, 6355, 6366,
     6377, 6388, 6399, 6410, 6421, 6432, 6443, 6454, 1086, 6456,
     6467, 6478, 6489, 6500, 6511, 6522, 6533, 6544, 6555, 6566,
     6577, 6588, 6599, 6610, 6621, 6632, 6643, 6654, 6665, 6676,
     6687, 6698, 6709, 6720, 6731, 6742, 6753, 6764, 6775, 6786,
     6797, 6808, 6819, 6830, 6841, 6852, 6863, 6874, 6885, 6896,
     6907, 6918, 6929, 6940, 6951, 6962, 6973, 6984, 6995, 7006,

     7017, 7028, 7039, 7050, 7061, 7072, 7083, 7094, 7105, 7116,
     7127, 7138, 7149, 7160, 7171, 7182, 7193, 7204, 7215, 7226,
     7237, 7248, 7259, 7270, 7281, 7286, 7296, 7307, 7318, 7329,
     7340, 7351, 7362, 7373, 7384, 7395, 7406, 7417, 1022, 7428,
     7439, 7450, 7461, 7472, 7483, 7490, 7496, 7506,  553, 7511,
      541, 7521, 7532, 7543, 7548,  182
    } ;

static const flex_int16_t yy_def[1757] =
    {   0,
     1573, 1573, 1574, 1574, 1572,    5,    5,    5, 1575, 1575,
     1572,   11, 1572,   13, 1576, 1576, 1577, 1577, 1572,   19,
     1572,   21, 1572,   23, 1578, 1578, 1579, 1579, 1580, 1580,
     1573, 1573, 1581, 1581, 1582, 1582, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1583, 1572, 1572, 1572, 1572, 1572, 1584,
     1572, 1572, 1583, 1572,   51, 1572, 1572, 1572, 1585, 1572,
     1572, 1572, 1586, 1572, 1572, 1572, 1587, 1572, 1572, 1572,
     1572, 1572, 1588, 1572, 1572, 1589, 1572, 1572, 1590, 1572,
     1572, 1591, 1572, 1583, 1572, 1572, 1572, 1572, 1572, 1592,
     1572, 1592, 1592, 1572, 1572, 1572, 1593, 1594, 1572, 1594,

     1572, 1572, 1572, 1572, 1572, 1595, 1595, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1596, 1572, 1572, 1572, 1572,
     1572, 1572, 1583, 1572, 1572, 1572, 1572, 1597, 1572, 1572,
     1598, 1572, 1572, 1599, 1600, 1572, 1572, 1572, 1601, 1572,
     1572, 1572, 1602, 1603, 1604, 1572, 1572, 1572, 1572, 1572,
     1572, 1596, 1572,  121,  122, 1583, 1599, 1572, 1601, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1605, 1572, 1572, 1572, 1572, 1606, 1572, 1572, 1572,
     1572, 1572, 1607, 1572, 1608, 1572, 1609, 1572, 1610, 1572,
     1572, 1572, 1572, 1572, 1611, 1572, 1572, 1572, 1572, 1583,

     1572, 1572, 1572, 1572, 1572, 1612, 1572, 1572, 1572, 1572,
     1612, 1572, 1572, 1613, 1614, 1613, 1614, 1613, 1615, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1616, 1616,
     1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1572, 1572,
     1572, 1572, 1617, 1572, 1617, 1617, 1617, 1617, 1617, 1617,
     1617, 1617, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1618, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1619, 1572, 1572, 1620, 1572, 1572, 1621,
     1572, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1572,
     1623, 1624, 1572, 1625, 1626, 1626, 1626, 1626, 1572, 1627,

     1572, 1572, 1628, 1572, 1629, 1572, 1572, 1572, 1630, 1572,
     1617, 1572, 1617, 1617, 1617, 1617, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1622, 1622, 1622, 1626, 1626, 1626,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1631, 1631, 1632, 1631, 1631, 1631, 1631, 1572,
     1572, 1633, 1572, 1572,  363,  363, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1633, 1634, 1635, 1635, 1636,
     1636, 1636, 1637, 1572, 1572, 1572, 1572, 1572, 1572, 1572,

     1638, 1639, 1639, 1639, 1639, 1639, 1639, 1639, 1639, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1617, 1617, 1617, 1617,
     1617, 1617, 1617, 1617, 1617, 1617, 1617, 1617, 1617, 1617,
     1617, 1617, 1617, 1617, 1617, 1617, 1617, 1617, 1617, 1617,
     1617, 1617, 1617, 1617, 1617, 1617, 1640, 1617, 1617, 1617,
     1641, 1642, 1617, 1617, 1617, 1617, 1617, 1617, 1617, 1617,
     1617,  461, 1617, 1617, 1617, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1643, 1572, 1572, 1572,
     1644, 1572, 1572, 1572, 1572, 1645, 1572, 1572, 1572, 1572,

     1572, 1572, 1646, 1647, 1648, 1572, 1572, 1649, 1650, 1651,
     1652, 1617, 1617, 1617, 1617, 1617, 1617, 1617, 1617, 1617,
     1653, 1617, 1617, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1655, 1572, 1572,  556, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1655, 1656, 1657, 1657, 1658, 1658, 1658, 1572,
     1659, 1659, 1572, 1572, 1572, 1572, 1572, 1572, 1660, 1661,

     1662, 1663, 1664, 1665, 1666, 1572, 1572, 1667, 1667, 1668,
     1667, 1667, 1667, 1667, 1667, 1667, 1667, 1667, 1667, 1667,
     1667, 1667, 1667, 1667, 1667, 1667, 1667, 1667, 1667, 1667,
     1667, 1667, 1669, 1667, 1667, 1667, 1670, 1667, 1671, 1667,
     1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1667, 1673,
     1667, 1674, 1667, 1667, 1667, 1667, 1667, 1667, 1667, 1667,
     1667, 1675, 1667, 1667, 1667, 1676, 1572, 1677, 1678, 1679,
     1572, 1572, 1572, 1572, 1572, 1680, 1681, 1572, 1572, 1682,
     1572, 1572, 1572, 1572, 1683, 1684, 1572, 1572, 1685, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1686, 1667,

     1667, 1667, 1667, 1667, 1667, 1667, 1667, 1687, 1687, 1687,
     1667, 1667, 1667, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1688, 1688, 1689, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1689, 1690, 1691,
     1692, 1693, 1692, 1693, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1692, 1572, 1572, 1572, 1572, 1572, 1572, 1572,

     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1694, 1695, 1696, 1697, 1698, 1699, 1700,
     1572, 1667, 1667, 1667, 1667, 1667, 1667, 1701, 1667, 1667,
     1702, 1703, 1704, 1667, 1667, 1667, 1667, 1667, 1705, 1706,
     1667, 1667, 1707, 1667, 1667, 1667, 1667, 1708, 1709, 1667,
     1667, 1710, 1667, 1667, 1667, 1667, 1667, 1667, 1711, 1712,
     1667, 1667, 1667, 1713, 1714, 1715, 1716, 1717, 1718, 1719,
     1720, 1721, 1572, 1572, 1722, 1667, 1667, 1667, 1667, 1667,
     1667, 1667, 1667, 1667, 1667, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1723, 1572, 1572, 1572, 1572, 1572, 1572, 1572,

     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1723, 1724, 1725,
     1725, 1725, 1725, 1725, 1725, 1725, 1725, 1725, 1725, 1725,
     1725, 1725, 1725, 1725, 1725, 1725, 1725, 1725, 1725, 1725,
     1725, 1725, 1725, 1725, 1725, 1725, 1725, 1725, 1725, 1725,
     1725, 1725, 1725, 1725, 1725, 1725, 1725, 1725, 1725, 1725,
     1725, 1725, 1725, 1725, 1725, 1725, 1725, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1726, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1727, 1667, 1667, 1667, 1728, 1729, 1730,

     1731, 1732, 1733, 1734, 1667, 1667, 1667, 1667, 1667, 1735,
     1667, 1667, 1572, 1572, 1736, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1736, 1737, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,

     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1739, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1740, 1667, 1667, 1735, 1741, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1742, 1743,
     1744, 1572, 1572, 1741, 1745, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,

     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1746, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1739, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1747, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1746, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,

     1572, 1747, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1284, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1748,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1743, 1742,
     1742, 1742, 1743, 1743, 1743, 1744, 1744, 1744, 1572, 1572,
     1745, 1745, 1572, 1572, 1572, 1749, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1750, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1748, 1748, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1742, 1743, 1744, 1572, 1572, 1747, 1572,

     1572, 1572, 1572, 1572, 1572, 1751, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1752, 1753, 1754, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1755, 1572, 1572,
     1750, 1572, 1572, 1572, 1572, 1572, 1753, 1752, 1752, 1752,
     1752, 1753, 1753, 1753, 1753, 1754, 1754, 1754, 1754, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1756, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1752, 1752, 1752,
     1753, 1753, 1753, 1754, 1754, 1754, 1572, 1572, 1572, 1755,
     1572, 1572, 1572, 1572, 1572, 1572, 1752, 1752, 1752, 1752,
     1753, 1753, 1753, 1753, 1754, 1754, 1754, 1754, 1572, 1572,

     1572, 1572, 1572, 1572, 1572, 1469, 1752, 1752, 1472, 1753,
     1753, 1475, 1754, 1754, 1572, 1572, 1572, 1572, 1752, 1469,
     1753, 1472, 1754, 1475, 1572, 1572, 1572, 1572, 1752, 1752,
     1487, 1752, 1753, 1753, 1491, 1753, 1754, 1754, 1495, 1754,
     1572, 1572, 1572, 1572, 1520, 1522, 1524, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572,    0, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,

     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,

     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572
    } ;

static const flex_int16_t yy_nxt[7701] =
    {   0,
     1572, 1572,   40,   41,   40,   41,   42,   43,   44,   45,
       43,   42,   42,   42,   42,   42,   46,   47,   42,   42,
       42,   48,   49,   46,   50,   50,   50,   50,   50,   50,
       50,   50,   50,   50,   50,   50,   50,   50,   50,   50,
       50,   50,   50,   50,   50,   50,   50,   50,   50,   50,
       50,   50,   50,   50,   50,   50,   50,   50,   50,   42,
       51,   42,   42,   42,   50,   50,   50,   50,   50,   50,
       50,   50,   50,   50,   50,   50,   50,   50,   50,   50,
       50,   50,   50,   50,   50,   50,   50,   50,   50,   50,
       42,   42,   42,   42,   42,   42,   42,   42,   42,   42,

       42,   42,   42,   42,   42,   42,   42,   42,   42,   42,
       42,   42,   42,   42,   42,   42,   42,   42,   42,   42,
       42,   42,   42,   42,   42,   42,   42,   42,   42,   42,
       42,   42,   42,   42,   42,   42,   42,   42,   42,   42,
       42,   42,   42,   42,   42,   42,   42,   52,   53,   54,
       52,   52,   53,   54,   52,   69,   57,   57,   83,   84,
       85,   83,   42,   91,   92,   93,   42,   83,   84,   85,
       83, 1572,   86,   87,   58,   58,   91,   92,   93,   95,
       95,   86,   87,   99,  100,  425,   96,   96,   99,  100,
       70, 1480,  126,   97,   97,  126,   71,  574,   72,  575,

       55,   59,   59,  163,   55,  402,  163,  103,  104,  105,
      103,   88,  402,   89,  174,  175,  106,  176,  202,  203,
       88,   70,   89,  107,  959,  178,  960,   71,  178,   72,
      500,  500,   60,   60,   61,   61,   61,   62,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   63,   63,   63,   63,   63,   63,   63,   63,
       63,   63,   63,   63,   63,   63,   63,   63,   63,   63,
       63,   63,   63,   63,   63,   63,   63,   63,   63,   63,
       63,   63,   63,   63,   63,   63,   63,   61,   61,   61,
       61,   61,   63,   63,   63,   63,   63,   63,   63,   63,

       63,   63,   63,   63,   63,   63,   63,   63,   63,   63,
       63,   63,   63,   63,   63,   63,   63,   63,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   64,   64,   64,   65,   64,
       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       64,   66,   64,   67,   67,   67,   67,   67,   67,   67,

       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   64,   64,
       64,   64,   64,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   64,
       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,

       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   69,  109,  110,  110,
      109,  474,  291,  157,  115,  116,  117,  115,  158,  559,
      475,  111,  112,  118,  119,  201,  201,  201,  201,  120,
      121,  164,  165,  166,  167,  168,  169,  170,  220,  221,
     1431,   70,  207,  208,  209,  207,  560,   71,  126,   72,
      559,  126, 1399,  222,  292,  159,  103,  225,  226,  103,
      113,  227,  228,  126,  487,  279,  126,  122,  279,  106,
      279,  296,   70,  279,  297,  488,  107,  560,   71,  298,
       72,   74,   74,   74,   75,   74,   74,   74,   74,   74,

       74,   74,   74,   74,   74,   74,   74,   74,   74,   76,
       76,   76,   76,   76,   76,   76,   76,   76,   76,   76,
       76,   76,   76,   76,   76,   76,   76,   76,   76,   76,
       76,   76,   76,   76,   76,   76,   76,   76,   76,   76,
       76,   76,   76,   76,   74,   74,   74,   74,   74,   76,
       76,   76,   76,   76,   76,   76,   76,   76,   76,   76,
       76,   76,   76,   76,   76,   76,   76,   76,   76,   76,
       76,   76,   76,   76,   76,   74,   74,   74,   74,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,

       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
       74,   74,   77,   77,   77,   78,   77,   77,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   77,   77,   77,   77,   77,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,

       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   77,   77,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   77,   77,   80,   80,   80,   81,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   82,   82,   82,   82,   82,   82,   82,   82,   82,

       82,   82,   82,   82,   82,   82,   82,   82,   82,   82,
       82,   82,   82,   82,   82,   82,   82,   82,   82,   82,
       82,   82,   82,   82,   82,   82,   80,   80,   80,   80,
       80,   82,   82,   82,   82,   82,   82,   82,   82,   82,
       82,   82,   82,   82,   82,   82,   82,   82,   82,   82,
       82,   82,   82,   82,   82,   82,   82,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,

       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   80,   80,   80,  110,  123,  110,  110,  561,  337,
      338,  157,  337,  338,  130,  149,  158,  130,  149,  112,
      130, 1313,  151,  152,  153,  151, 1572,  190,  130,  111,
      190,  118,  119,  194,  195,  196,  194,  293,  154,  561,
      293,  191,  192,  507,  507,  308,  294,  215,  308,  339,
      216, 1572,  339,  324,  309,  311,  512,  112,  129,  129,
      130,  129,  131,  131,  132,  129,  133,  134,  150,  135,
      150,  360,  136,  137,  130,  155,  340,  197,  423,  340,
      193,  103,  104,  105,  103,  301,  198,  130,  199,  217,

      106,  360, 1572,  130,  138,  130,  328,  107,  218,  329,
      240,  475,  360,  341,  330,  239,  341,  130,  342,  139,
      140,  342,  529,  141,  129,  138,  129,  129,  142,  143,
      217,  138,  360,  343,  144,  138,  343,  145,  146,  129,
      704,  129,  147,  130,  129,  138,  148,  138,  230,  129,
      129,  130,  241, 1572,  424,  231,  109,  110,  110,  109,
      232,  489,  489,  490,  233,  234,  235,  425,  236, 1572,
      111,  112,  110,  110,  110,  110,  130,  242,  243,  244,
      242, 1572,  178,  237,  130,  178, 1572,  112,  246,  116,
      247,  246,  112,  535,  535, 1572,  238,  248,  249,  110,

      116,  110,  110,  250,  251,  178,  508,  149,  178,  113,
      149,  955,  408,  410,  112,  408,  410,  115,  116,  117,
      115,  111,  536,  536,  956,  112,  118,  119,  204,  632,
      113,  204,  120,  121,  484,  310,  311,  312,  310,  579,
      580,  252,  281,  281,  281,  281,  281,  281,  281,  281,
      628,  283,  112,  253,  254,  284,  253,  285,  286,  483,
      150,  656,  483,  287,  332,  333,  334,  335,  288,  255,
      122,  289,  562,  313,  152,  314,  313,  611,  220,  221,
      256,  193,  248,  249,  220,  221,  257,  258,  150,  315,
      259, 1572,  260,  222,  261,  610,  262,  263,  264,  222,

      265,  411,  266,  562,  412, 1572,  124,  317,  318,  413,
      319,  267,  320,  268,  414,  269,  410,  415,  270,  410,
      321,  322,  416,  271,  606,  606,  316,  323,  272,  129,
      129,  130,  129,  131,  131,  132,  273,  133,  134,  493,
      274, 1572,  494,  275,  137,  130,  306,  495,  306,  753,
      307,  307,  307,  307,  307,  307,  307,  307,  307, 1353,
      151,  152,  153,  151,  190,  138,  637,  190,  753,  118,
      119,  201,  201,  201,  201, 1572,  154,  906,  191,  192,
      276,  140,  607,  607,  141,  129,  138,  129,  129,  142,
      143, 1353,  138,  563,  352,  144,  138,  352,  145,  146,

      129,  906,  129,  147,  130,  129,  138,  148,  138,  192,
      129,  129,  130,  155,  283,  615,  700,  193,  325,  336,
      285,  326,  336,  981,  563, 1572,  327,  350,  350,  350,
      350,  288,  253,  254,  289,  253,  982,  332,  333,  334,
      335,  391,  351,  354,  355,  356,  354,  193,  194,  195,
      196,  194,  201,  201,  201,  201,  361,  361,  361,  361,
      207,  363,  364,  207,  207,  208,  209,  207,  394,  392,
      395, 1163, 1572,  476,  227,  228,  476,  570, 1572,  396,
      392,  397,  106,  398,  620,  401,  392,  357,  401,  107,
      399,  401,  197,  621,  401, 1572,  358,  989,  359,  662,

      392,  198,  477,  199,  365,  366,  367,  365,  570,  402,
      406,  392,  619, 1353,  478,  406,  400,  392,  403,  402,
      402,  406,  242,  243,  244,  242,  406,  406,  402, 1353,
      368,  369,  406,  279,  403, 1572,  279,  112,  370,  371,
      404,  406,  372,  373,  467,  374,  406,  467,  537,  375,
      703,  537,  406,  418,  243,  419,  418,  406,  406,  110,
      243,  110,  110,  406,  421,  110,  418,  421,  420,  376,
      418,  116,  418,  418,  112,  113, 1572,  467,  468,  420,
      467,  468,  481,  293,  479,  420,  293,  468,  468,  691,
      691,  308,  294,  481,  308,  635,  635,  636,  480,  481,

      309, 1353,  446, 1572,  470,  446,  420,  310,  311,  312,
      310,  538,  112,  481,  538,  722,  722,  422,  471,  467,
      470,  492,  467,  420,  481,  539,  472, 1572,  539, 1570,
      481,  377,  378,  379,  980,  380,  381,  382, 1572,  383,
      983,  384,  385,  426,  254, 1373,  426,  540,  532,  631,
      540,  533,  468,  468,  541,  513,  534,  541,  481,  427,
      150,  336,  468,  468,  336,  337,  737, 1567,  337,  481,
      428,  338,  756,  757,  338,  481,  429,  430,  339,  738,
      431,  339,  432, 1566,  433, 1572,  434,  435,  436,  481,
      437,  633,  438, 1563,  525,  340,  423,  737,  340,  526,

      481,  439,  634,  440,  341,  441,  481,  341,  442,  342,
      738,  343,  342,  443,  343,  856,  856,  706,  444,  129,
      445,  446,  445,  447,  447,  448,  449,  450,  451,  401,
      452, 1572,  401,  453,  454,  446,  307,  307,  307,  307,
      307,  307,  307,  307,  307,  350,  350,  350,  350,  350,
      350,  350,  350,  401,  352,  455,  401,  352,  549,  600,
      601,  549,  600,  601,  707,  354,  355,  356,  354,  192,
      456,  457, 1353,  550,  458,  445,  455,  445,  445,  459,
      460,  602,  455,  510,  602,  461,  455,  417,  462,  463,
      445,  754,  445,  464,  446,  445,  455,  465,  455,  621,

      445,  445,  446,  426,  254,  968,  426,  193,  552,  357,
      705,  551,  361,  361,  361,  361, 1353,  505,  358,  427,
      359,  558,  366,  367,  558,  417,  760, 1562,  552,  514,
      515,  742,  516,  761,  517,  603,  429,  430,  603,  552,
      431, 1353,  518,  519,  433,  747,  434,  435,  436,  520,
      437,  604,  438,  755,  604,  605,  423,  410,  605,  552,
      410,  439,  742,  440,  467,  441, 1572,  467,  442,  589,
      590,  589,  589,  443,  588,  985,  747,  986,  444,  129,
      445,  446,  445,  447,  447,  448,  449,  450,  521,  668,
      452,  748,  668,  522,  454,  446,  511,  749,  418,  110,

      418,  418,  612, 1572,  417,  612,  418,  243,  418,  418,
      739,  426,  254,  420,  426,  455,  750,  421,  110,  418,
      421,  420,  748,  629,  446, 1572,  629,  446,  749,  739,
      523,  457,  420, 1321,  458,  445,  455,  445,  445,  459,
      460,  467,  455,  752,  467,  461,  455,  750,  462,  463,
      445,  420,  445,  464,  446,  445,  455,  465,  455,  420,
      445,  445,  446,  365,  556,  557,  365, 1158,  564, 1572,
      422,  446,  565, 1353,  752,  907,  566,  513,  608,  861,
      861,  467,  567,  425,  467,  446,  667,  895,  568,  368,
      369,  613, 1572,  669,  613,  907,  669,  370,  371,  564,

     1572,  372,  373,  565,  374,  884,  884,  566,  375,  622,
     1572,  896,  622,  567,  613, 1572,  747,  613,  895,  568,
      609,  612, 1572,  505,  612,  614,  614, 1075,  376,  625,
     1572, 1007,  670,  614,  614,  670,  651, 1572,  623,  651,
     1076,  616,  896,  626,  446,  652, 1572,  747,  671,  510,
      624,  671,  446, 1009, 1572,  617,  614,  616,  672,  885,
      885,  672,  627,  618, 1353,  642,  511,  614,  569,  643,
     1107,  644,  645,  627, 1010,  665, 1572,  646,  665,  627,
      673,  804,  647,  673,  666,  648,  627,  964,  965, 1107,
      377,  378,  379,  627,  380,  381,  382,  627,  383,  476,

      384,  385,  476,  627,  627,  674,  653, 1289,  674,  654,
      627, 1572,  675,  676,  655,  675,  676,  627,  677,  678,
      679,  677,  678,  679,  680,  638,  681,  680,  627,  681,
      682, 1289,  686,  682,  627,  686,  630,  630,  630,  630,
      630,  630,  630,  630,  630,  630,  630,  630,  630,  630,
      630,  630,  630,  630,  630,  630,  630,  630,  630,  630,
      630,  630, 1572,  687,  688,  690,  687,  688,  690,  692,
      693, 1353,  692,  693,  683,  714, 1146,  683,  714,  640,
      640,  640,  640,  640,  640,  640,  640, 1572, 1154, 1572,
      716,  642,  684,  716, 1559,  708,  657,  644,  709,  717,

      990,  991,  717,  710,  658,  658,  658,  658,  647,  995,
      995,  648,  658,  658,  658,  658,  658,  658,  658,  658,
      658,  658,  658,  658,  658,  658,  658,  658,  658,  658,
      658,  658,  658,  658,  658,  658,  658,  658, 1572,  684,
      718,  719,  720,  718,  719,  720, 1572,  721,  446,  711,
      721,  537,  712,  538,  537,  539,  538,  713,  539, 1079,
      747, 1080,  446,  659,  659,  659,  659,  659,  659,  659,
      659,  659,  659,  659,  659,  659,  659,  659,  659,  659,
      659,  659,  659,  659,  659,  659,  659,  659,  659,  540,
      541,  747,  540,  541,  659,  659,  659,  659,  659,  659,

      659,  659,  659,  659,  659,  659,  659,  659,  659,  659,
      659,  659,  659,  659,  659,  659,  659,  659,  659,  659,
      660,  446,  729,  602,  693,  729,  602,  693, 1353,  446,
      734,  735,  736,  734,  996,  996,  661,  661,  661,  661,
      661,  661,  661,  661,  661,  661,  661,  661,  661,  661,
      661,  661,  661,  661,  661,  661,  661,  661,  661,  661,
      661,  661,  612,  613, 1572,  612,  613,  661,  661,  661,
      661,  661,  661,  661,  661,  661,  661,  661,  661,  661,
      661,  661,  661,  661,  661,  661,  661,  661,  661,  661,
      661,  661,  661, 1572, 1558,  553, 1118,  614,  553,  727,

      739,  613,  727, 1119,  613,  663,  614,  663, 1221,  664,
      664,  664,  664,  664,  664,  664,  664,  664,  728,  549,
      747, 1222,  549,  740,  731,  350,  731,  731,  743,  751,
     1554,  739,  613,  565,  550,  613, 1150,  830,  701,  732,
      744,  831,  822,  702,  831,  823,  751, 1112,  551,  745,
      824,  747,  565,  746,  825,  613,  904,  826,  613,  743,
      832,  833,  827,  832,  833,  834,  835,  836,  834,  835,
      836,  744,  551,  558,  556,  557,  558, 1032,  622,  837,
      745,  622,  837,  838,  746,  839,  838,  840,  839,  841,
      840,  842,  841, 1353,  842,  843,  741, 1553,  843,  368,

      369,  844,  845,  846,  844,  845,  846,  370,  371, 1113,
      849,  372,  373,  849,  374, 1552,  850,  851,  375,  850,
      851,  847,  853,  651,  665,  853,  651,  665,  671, 1023,
     1024,  671,  652,  666,  672, 1030, 1031,  672,  376,  664,
      664,  664,  664,  664,  664,  664,  664,  664,  673,  674,
      675,  673,  674,  675,  678,  679,  681,  678,  679,  681,
      682,  683,  683,  682,  683,  683,  687,  688,  847,  687,
      688,  690,  692,  693,  690,  692,  693,  874,  876,  878,
      874,  876,  878,  879,  880,  881,  879,  880,  881,  882,
      883,  714,  882,  883,  714,  886,  716,  992,  886,  716,

      377,  378,  379, 1544,  380,  381,  382, 1225,  383, 1226,
      384,  385,  773,  590,  773,  773,  717,  774,  718,  717,
      719,  718,  720,  719,  721,  720,  889,  721,  727,  889,
      891,  727,  729,  891,  892,  729, 1290,  892,  775,  776,
      731,  350,  731,  731,  747,  894,  777,  778,  894,  898,
      779,  780, 1353,  781,  747,  902, 1290,  782,  731,  350,
      731,  731,  903,  899,  747,  783,  734,  735,  736,  734,
      734,  735,  736,  734,  747,  747,  912,  784,  747,  912,
      898,  734,  735,  736,  734,  747,  902,  747,  942,  943,
      944,  945,  946,  903,  899,  747, 1319,  734,  735,  736,

      734,  953,  968,  969,  970,  747, 1353,  971, 1353,  747,
      874,  972, 1318,  874,  997,  979, 1319,  997,  747,  942,
      943,  944,  945,  946,  900,  834,  835,  901,  834,  835,
     1033, 1034,  953,  968,  969,  970, 1318,  747,  971,  785,
      786,  787,  972,  788,  789,  790,  979,  791, 1543,  792,
      793,  590,  590,  590,  590,  900,  794,  836,  901, 1353,
      836,  775,  776,  837,  838, 1353,  837,  838,  747,  777,
      778, 1161,  841,  779,  780,  841,  781,  795,  796,  842,
      782,  844,  842, 1353,  844,  797,  798,  947,  783,  799,
      800,  948,  801, 1542,  845,  949,  802,  845, 1016,  846,

      784,  950,  846,  846,  803,  850,  846,  951,  850,  987,
      851,  913,  914,  851,  853, 1150,  804,  853,  947, 1258,
     1005,  874,  948, 1005,  874,  874,  949,  876,  874, 1016,
      876, 1011,  950,  878, 1011, 1327,  878,  879,  951,  880,
      879,  881,  880,  882,  881,  883,  882,  886,  883, 1013,
      886,  889, 1013, 1014,  889,  891, 1014,  892,  891, 1383,
      892, 1353,  785,  786,  787, 1353,  788,  789,  790, 1160,
      791,  894,  792,  793,  894, 1084, 1085, 1151,  805,  806,
      807, 1259,  808,  809,  810,  984,  811,  952,  812,  813,
      862,  862,  862,  862,  862,  862,  862,  862,  862,  862,

      862,  862,  862,  862,  862,  862,  862,  862,  862,  862,
      862,  862,  862,  862,  862,  862,  863,  863,  863,  863,
      863,  863,  863,  863,  863,  863,  863,  863,  863,  863,
      863,  863,  863,  863,  863,  863,  863,  863,  863,  863,
      863,  863, 1114, 1115, 1152, 1153, 1017,  863,  863,  863,
      863,  863,  863,  863,  863,  863,  863,  863,  863,  863,
      863,  863,  863,  863,  863,  863,  863,  863,  863,  863,
      863,  863,  863,  921,  590,  921,  921, 1017,  922,  738,
     1156, 1005,  795,  796, 1005,  747, 1019, 1157, 1374, 1020,
      797,  798, 1353, 1021,  799,  800, 1062,  801, 1328,  923,

      924,  802,  734,  735,  736,  734, 1063,  925,  926,  803,
      738,  927,  928, 1064,  929,  973,  747, 1019,  930,  974,
     1020,  804, 1065,  975, 1021, 1066,  931, 1062, 1073,  976,
     1091, 1092, 1096, 1101, 1102,  977, 1103, 1063,  932, 1104,
     1106,  747, 1088, 1541, 1064, 1088,  973, 1089, 1129, 1130,
      974, 1105, 1353, 1065,  975, 1068, 1066, 1306, 1145, 1073,
      976, 1091, 1092, 1096, 1101, 1102,  977, 1103, 1105, 1143,
     1104, 1106,  747,  974, 1068,  988, 1093, 1145, 1134, 1129,
     1130, 1139, 1140,  805,  806,  807, 1143,  808,  809,  810,
     1273,  811,  974,  812,  813, 1090, 1178, 1034, 1353, 1094,

      933,  934,  935, 1274,  936,  937,  938, 1093,  939, 1134,
      940,  941, 1139, 1140, 1353,  978,  658,  658,  658,  658,
      658,  658,  658,  658,  658,  658,  658,  658,  658,  658,
      658,  658,  658,  658,  658,  658,  658,  658,  658,  658,
      658,  658,  661,  661,  661,  661,  661,  661,  661,  661,
      661,  661,  661,  661,  661,  661,  661,  661,  661,  661,
      661,  661,  661,  661,  661,  661,  661,  661,  997, 1230,
     1231,  997, 1095,  661,  661,  661,  661,  661,  661,  661,
      661,  661,  661,  661,  661,  661,  661,  661,  661,  661,
      661,  661,  661,  661,  661,  661,  661,  661,  661, 1041,

      590, 1041, 1041, 1005, 1042, 1141, 1005, 1126, 1043, 1044,
     1126, 1166, 1127, 1353, 1166, 1142, 1045, 1046, 1159, 1144,
     1047, 1048, 1155, 1049, 1264, 1043, 1044, 1050, 1131,  417,
      875, 1265,  417, 1045, 1046, 1051, 1141, 1047, 1048, 1169,
     1049, 1067, 1097,  739, 1050, 1068, 1142, 1052,  747, 1069,
     1144, 1132, 1051, 1011, 1098, 1070, 1011, 1017, 1170, 1131,
     1128, 1071, 1013, 1099, 1052, 1013, 1014, 1100, 1518, 1014,
     1169, 1171, 1067, 1097,  739, 1272, 1068, 1208, 1272,  747,
     1069,  734,  735,  736,  734, 1098, 1070, 1172, 1017, 1170,
     1209, 1210, 1071, 1171, 1099, 1110, 1516, 1110, 1100, 1111,

     1111, 1111, 1111, 1111, 1111, 1111, 1111, 1111, 1208, 1053,
     1054, 1055, 1353, 1056, 1057, 1058, 1211, 1059, 1212, 1060,
     1061, 1209, 1210, 1219, 1133, 1237, 1053, 1054, 1055, 1253,
     1056, 1057, 1058, 1353, 1059, 1234, 1060, 1061, 1234, 1372,
     1235, 1072, 1108,  734,  735,  736,  734, 1211, 1253, 1212,
     1109, 1109, 1109, 1109, 1219, 1353, 1237, 1353, 1109, 1109,
     1109, 1109, 1109, 1109, 1109, 1109, 1109, 1109, 1109, 1109,
     1109, 1109, 1109, 1109, 1109, 1109, 1109, 1109, 1109, 1109,
     1109, 1109, 1109, 1109, 1135, 1173, 1174, 1251, 1236, 1260,
     1261, 1214, 1239, 1150, 1238, 1515, 1136, 1242, 1247, 1248,

     1249, 1250, 1252, 1239, 1251, 1137, 1275, 1173, 1174, 1138,
     1214, 1239, 1148, 1317, 1148, 1135, 1149, 1149, 1149, 1149,
     1149, 1149, 1149, 1149, 1149, 1238, 1240, 1136, 1242, 1247,
     1248, 1249, 1250, 1252, 1239, 1276, 1137, 1275, 1131, 1247,
     1138, 1187,  590, 1187, 1187, 1301, 1188, 1247, 1301, 1234,
     1189, 1190, 1234, 1295, 1235, 1151, 1295, 1131, 1191, 1192,
     1353, 1247, 1193, 1194, 1375, 1195, 1276, 1189, 1190, 1196,
     1247, 1247, 1381, 1247, 1353, 1191, 1192, 1197, 1247, 1193,
     1194, 1278, 1195, 1213, 1243, 1234, 1196, 1214, 1234, 1198,
     1235, 1215, 1247, 1282, 1197, 1279, 1244, 1216, 1283, 1241,

     1247, 1353, 1247, 1217, 1247, 1245, 1198, 1302, 1126, 1246,
     1353, 1126, 1278, 1127, 1213, 1243, 1353,  981, 1214, 1247,
     1303, 1356, 1215, 1247, 1282, 1139, 1279, 1244, 1216, 1283,
      982, 1247, 1247, 1304, 1217, 1305, 1245, 1256, 1236, 1256,
     1246, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1247, 1199, 1200, 1201, 1247, 1202, 1203, 1204, 1302, 1205,
     1139, 1206, 1207, 1247, 1304, 1139, 1305, 1139, 1199, 1200,
     1201, 1303, 1202, 1203, 1204, 1322, 1205, 1234, 1206, 1207,
     1234, 1353, 1235, 1218, 1254, 1353, 1418, 1166, 1296, 1297,
     1166, 1139, 1255, 1255, 1255, 1255, 1139, 1139, 1139, 1139,

     1255, 1255, 1255, 1255, 1255, 1255, 1255, 1255, 1255, 1255,
     1255, 1255, 1255, 1255, 1255, 1255, 1255, 1255, 1255, 1255,
     1255, 1255, 1255, 1255, 1255, 1255, 1234, 1139, 1139, 1234,
     1236, 1235, 1189, 1190, 1311, 1353, 1307, 1312, 1139, 1139,
     1191, 1192, 1329, 1139, 1193, 1194, 1166, 1195, 1353, 1166,
     1308, 1196, 1139, 1280, 1324, 1332, 1281, 1324, 1139, 1285,
      417,  875, 1320,  417, 1353, 1311, 1247, 1307, 1312, 1139,
     1139, 1198, 1126, 1126, 1139, 1126, 1126, 1127, 1127, 1236,
      993, 1308, 1353, 1139, 1280, 1353, 1332, 1281, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1247, 1284, 1284,

     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
     1284, 1284, 1284, 1284, 1333, 1128, 1128,  734,  735,  736,
      734, 1129, 1131, 1199, 1200, 1201, 1353, 1202, 1203, 1204,
     1139, 1205, 1353, 1206, 1207, 1189, 1190, 1126, 1316, 1353,
     1126, 1131, 1127, 1191, 1192, 1333, 1353, 1193, 1194, 1371,
     1195,  969, 1129, 1353, 1196, 1353, 1353,  795,  796, 1353,
      990,  991, 1286, 1362, 1309,  797,  798, 1310, 1353,  799,
      800, 1486,  801, 1353, 1198, 1353,  802, 1139,  972, 1325,
     1326, 1485,  969, 1484, 1314,  734,  735,  736,  734, 1367,

     1128, 1341,  735, 1342, 1341, 1309,  804,  968, 1310, 1149,
     1149, 1149, 1149, 1149, 1149, 1149, 1149, 1149, 1139,  972,
     1353, 1353,  795,  796, 1344,  735, 1345, 1344, 1353, 1353,
      797,  798, 1483, 1353,  799,  800, 1366,  801,  968, 1369,
     1370,  802, 1347,  735, 1348, 1347, 1199, 1200, 1201, 1315,
     1202, 1203, 1204,  970, 1205, 1134, 1206, 1207,  985, 1353,
      986,  804,  734,  735,  736,  734,  971, 1162,  805,  806,
      807, 1139,  808,  809,  810, 1353,  811, 1323,  812,  813,
      795,  796, 1353, 1156,  970, 1353, 1134, 1353,  797,  798,
     1157, 1353,  799,  800, 1382,  801, 1353,  971, 1353,  802,

     1126, 1126, 1139, 1126, 1126, 1355, 1355,  803,  979, 1353,
     1130, 1353,  973, 1479, 1353, 1140,  974, 1144, 1353,  804,
      975, 1131, 1477,  805,  806,  807,  976,  808,  809,  810,
     1353,  811,  977,  812,  813,  590,  590,  590,  590,  979,
     1354, 1130, 1353,  973, 1132, 1353, 1140,  974, 1144, 1376,
     1377,  975, 1131, 1128, 1353, 1353, 1467,  976, 1152, 1153,
     1572,  795,  796,  977, 1305, 1356, 1379, 1380, 1353,  797,
      798, 1353, 1353,  799,  800, 1141,  801, 1353, 1142, 1304,
      802,  805,  806,  807, 1368,  808,  809,  810,  803,  811,
     1353,  812,  813, 1135, 1145, 1305, 1301, 1130, 1143, 1301,

      804, 1353,  974, 1139, 1139, 1136, 1141, 1466, 1318, 1142,
     1304, 1139,  978, 1145, 1137, 1143, 1353, 1133, 1138, 1368,
     1301,  974, 1126, 1301, 1135, 1126, 1126, 1355, 1130, 1126,
     1353, 1355, 1318, 1465, 1139, 1139, 1136, 1353, 1353, 1353,
     1353, 1458, 1139, 1353, 1353, 1137, 1148, 1353, 1148, 1138,
     1149, 1149, 1149, 1149, 1149, 1149, 1149, 1149, 1149, 1353,
     1312, 1139,  805,  806,  807, 1139,  808,  809,  810, 1139,
      811, 1353,  812,  813, 1139, 1128, 1307, 1139, 1319, 1128,
     1353, 1301, 1126, 1311, 1301, 1126, 1353, 1355, 1139, 1353,
     1308, 1312, 1139, 1353, 1353, 1353, 1139,  747, 1319, 1324,

     1139, 1353, 1324, 1450, 1353, 1139, 1361, 1307, 1139, 1309,
     1139, 1437, 1310, 1453, 1311,  795,  796, 1379, 1380, 1139,
     1436, 1308, 1139,  797,  798, 1365, 1301,  799,  800, 1301,
      801, 1363, 1353, 1453,  802, 1128, 1353, 1361, 1353, 1353,
     1309, 1139, 1314, 1310, 1149, 1149, 1149, 1149, 1149, 1149,
     1149, 1149, 1149, 1139,  804, 1435, 1365,  795,  796, 1434,
     1376, 1377, 1363, 1433, 1364,  797,  798, 1360, 1432,  799,
      800, 1360,  801, 1353, 1428, 1126,  802, 1454, 1126, 1316,
     1355, 1358, 1361, 1358, 1315, 1359, 1359, 1359, 1359, 1359,
     1359, 1359, 1359, 1359, 1353, 1364,  804, 1454, 1360, 1572,

     1378, 1130, 1360, 1503, 1369, 1370, 1139, 1572, 1572, 1572,
     1572, 1427, 1363, 1361, 1139, 1398,  805,  806,  807, 1316,
      808,  809,  810, 1503,  811, 1364,  812,  813, 1128, 1181,
     1365, 1390, 1130, 1126, 1325, 1326, 1126, 1139, 1127, 1386,
     1378,  747, 1358, 1363, 1358, 1139, 1359, 1359, 1359, 1359,
     1359, 1359, 1359, 1359, 1359, 1390, 1364, 1387,  805,  806,
      807, 1365,  808,  809,  810, 1455,  811, 1408,  812,  813,
     1386, 1388, 1139,  747, 1389, 1344,  735, 1345, 1344, 1394,
      735, 1342, 1394, 1409, 1415, 1380, 1128, 1455, 1387, 1408,
     1426, 1388, 1394,  735, 1342, 1394, 1389, 1394,  735, 1342,

     1394, 1402, 1425, 1139, 1395,  735, 1345, 1395, 1395,  735,
     1345, 1395, 1395,  735, 1345, 1395, 1396,  735, 1348, 1396,
     1396,  735, 1348, 1396, 1396,  735, 1348, 1396,  795,  796,
     1126, 1424, 1402, 1126, 1131, 1127,  797,  798, 1139, 1126,
      799,  800, 1126,  801, 1127, 1126, 1361,  802, 1126, 1403,
     1127, 1421, 1410, 1411, 1422,  803, 1359, 1359, 1359, 1359,
     1359, 1359, 1359, 1359, 1359, 1131, 1464,  804, 1126, 1139,
     1499, 1126, 1423, 1127, 1410, 1411, 1126, 1361, 1420, 1126,
     1403, 1127, 1421, 1400, 1420, 1422, 1394,  735, 1342, 1394,
     1464, 1429, 1401, 1430, 1499, 1404, 1451, 1404, 1128, 1405,

     1405, 1405, 1405, 1405, 1405, 1405, 1405, 1405, 1395,  735,
     1345, 1395, 1396,  735, 1348, 1396,  734,  735,  736,  734,
     1126, 1128, 1429, 1126, 1430, 1127, 1419, 1451, 1418,  805,
      806,  807, 1417,  808,  809,  810, 1572,  811, 1452,  812,
      813, 1572, 1126, 1439, 1500, 1126, 1439, 1127, 1440, 1572,
     1572, 1572, 1572, 1405, 1405, 1405, 1405, 1405, 1405, 1405,
     1405, 1405,  795,  796, 1504, 1416, 1378, 1460, 1500, 1452,
      797,  798, 1414, 1128,  799,  800, 1139,  801,  795,  796,
     1443,  802, 1413, 1443, 1504, 1444,  797,  798, 1461, 1447,
      799,  800, 1447,  801, 1448, 1128, 1441,  802, 1460, 1126,

      747,  804, 1126, 1456, 1127, 1456,  747, 1457, 1457, 1457,
     1457, 1457, 1457, 1457, 1457, 1457, 1572,  804, 1462, 1461,
     1412, 1463, 1481, 1409, 1572, 1572, 1572, 1572, 1482, 1443,
     1501,  747, 1443, 1445, 1444, 1502, 1406,  747, 1462, 1139,
     1505, 1468, 1449, 1463, 1468, 1468, 1440, 1139, 1468, 1398,
     1440, 1468, 1128, 1481, 1468, 1468, 1440, 1397, 1468, 1482,
     1440, 1501, 1505,  805,  806,  807, 1502,  808,  809,  810,
     1139,  811, 1471,  812,  813, 1471, 1393, 1444, 1139,  805,
      806,  807, 1445,  808,  809,  810, 1392,  811, 1471,  812,
      813, 1471, 1471, 1444, 1441, 1471, 1471, 1444, 1441, 1471,

     1474, 1444, 1391, 1474, 1441, 1448, 1474, 1474, 1441, 1474,
     1474, 1448, 1448, 1474, 1385, 1383, 1474, 1469, 1448,  734,
      735,  736,  734, 1126, 1468, 1445, 1126, 1468, 1127, 1440,
     1470, 1457, 1457, 1457, 1457, 1457, 1457, 1457, 1457, 1457,
     1525, 1445, 1548, 1526, 1382, 1445, 1381, 1550, 1527, 1445,
     1375, 1471, 1374, 1449, 1471, 1373, 1444, 1372, 1472, 1449,
     1449, 1371, 1525, 1368, 1548, 1474, 1449, 1526, 1474, 1550,
     1448, 1473, 1527, 1368, 1572, 1475, 1468, 1441, 1367, 1468,
     1366, 1440, 1572, 1572, 1572, 1572, 1528, 1468, 1476, 1489,
     1468, 1489, 1440, 1490, 1490, 1490, 1490, 1490, 1490, 1490,

     1490, 1490, 1471, 1468, 1445, 1471, 1468, 1444, 1440, 1471,
     1528, 1549, 1471, 1556, 1444, 1493, 1572, 1493, 1449, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1438, 1441,
     1555, 1549, 1362, 1442, 1353, 1556, 1438, 1438, 1438, 1438,
     1507, 1442, 1442, 1442, 1442, 1557, 1561, 1551, 1478, 1468,
     1555, 1564, 1468, 1353, 1440, 1445, 1508, 1352, 1471, 1487,
     1350, 1471, 1510, 1444, 1349, 1557, 1561, 1488, 1488, 1488,
     1488, 1551, 1339, 1564, 1338, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,

     1488, 1337, 1441, 1471, 1336, 1335, 1471, 1334, 1444, 1329,
     1328, 1511, 1474, 1491, 1327, 1474, 1323, 1448, 1322, 1321,
     1320, 1492, 1492, 1492, 1492,  734,  735,  736,  734, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492, 1492,
     1492, 1492, 1492, 1492, 1492, 1560, 1445, 1474, 1474, 1568,
     1474, 1474, 1448, 1448, 1317, 1513, 1126, 1495, 1316, 1126,
     1150, 1127,  968, 1306, 1300, 1496, 1496, 1496, 1496, 1560,
     1299, 1568, 1298, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,

     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1474,
     1449, 1514, 1474, 1294, 1448, 1293, 1292, 1291, 1468, 1128,
     1288, 1468, 1497, 1440, 1497, 1565, 1498, 1498, 1498, 1498,
     1498, 1498, 1498, 1498, 1498, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1446, 1569, 1287, 1571, 1438, 1565,
     1258, 1208, 1446, 1446, 1446, 1446, 1438, 1438, 1438, 1438,
     1277, 1271, 1449, 1468, 1270, 1269, 1468, 1569, 1440, 1571,
     1268, 1441, 1267, 1266, 1468, 1126, 1263, 1468, 1126, 1440,
     1127, 1468, 1471, 1262, 1468, 1471, 1440, 1444, 1233, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,

     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1232, 1441, 1471, 1471, 1229,
     1471, 1471, 1444, 1444, 1228, 1227, 1474, 1508, 1128, 1474,
     1442, 1448, 1224, 1198, 1507, 1511, 1223, 1220, 1442, 1442,
     1442, 1442, 1184, 1509, 1509, 1509, 1509, 1509, 1509, 1509,
     1509, 1509, 1509, 1509, 1509, 1509, 1509, 1509, 1509, 1509,
     1509, 1509, 1509, 1509, 1509, 1509, 1509, 1509, 1509, 1471,
     1445, 1510, 1471, 1183, 1444, 1183, 1182, 1181, 1474, 1514,
     1180, 1474, 1179, 1448, 1032, 1177, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1498, 1498, 1498, 1498, 1498,

     1498, 1498, 1498, 1498, 1517, 1446,  734,  735,  736,  734,
      747, 1176, 1175, 1446, 1446, 1446, 1446, 1172, 1165, 1163,
     1162, 1161, 1445, 1474, 1468, 1160, 1474, 1468, 1448, 1440,
     1468, 1449, 1159, 1468, 1471, 1440, 1158, 1471, 1471, 1444,
     1155, 1471, 1474, 1444, 1154, 1474, 1146, 1448, 1125, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1474, 1449, 1441, 1474, 1474,
     1448, 1124, 1474, 1441, 1448, 1123, 1469, 1445, 1122, 1121,
     1120, 1445, 1520, 1117, 1116, 1449, 1472, 1087, 1126, 1519,

     1522, 1126, 1086, 1127, 1475, 1470, 1083, 1126, 1082, 1521,
     1126, 1081, 1127, 1473, 1078, 1052, 1077, 1523, 1074, 1038,
     1037, 1468, 1036, 1035, 1468, 1029, 1440, 1028, 1449, 1027,
     1026, 1025, 1513, 1022, 1529, 1022, 1529, 1524, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1018, 1012, 1008,
     1476, 1128,  996,  996,  995,  995,  993,  992,  989,  988,
     1128,  987,  984,  804,  983,  980,  967,  966,  963,  962,
      961,  958,  932,  957, 1441, 1531,  954,  918,  917,  916,
      915,  911,  910, 1532, 1532, 1532, 1532,  909,  908,  905,
      904, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,

     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1471,  754,  559,
     1471,  897, 1444,  735,  890,  888,  887,  885,  885,  884,
     1533,  884, 1533,  877, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534,  694,  873,  861,  861,  858,  858,  856,
      856,  857,  855,  829,  821,  815,  815,  772,  772,  770,
      770,  768,  767,  766,  765,  764,  763,  762,  759,  758,
     1445, 1535,  556,  553,  730,  726,  725,  724,  723, 1536,
     1536, 1536, 1536,  722,  722,  715, 1572, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,

     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1474,  311,  699, 1474,  698, 1448,  697,
      498,  696,  691,  691, 1572, 1572, 1537, 1572, 1537,  650,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1572,
     1572, 1572,  466, 1572,  607,  607,  606,  606,  598,  597,
      596,  595,  594,  593,  592,  588,  588,  586,  586,  583,
      582,  581,  578,  577,  576,  573, 1449, 1539,  376,  572,
      571,  366,  363,  554,  553, 1540, 1540, 1540, 1540,  355,
      547,  546,  545, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,

     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1468,
      544,  543, 1468,  542, 1440,  536,  536,  535,  535,  531,
      530,  528,  527,  524,  152,  311, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530,  507, 1471,  507,  502, 1471,
      502, 1444,  500,  500,  501,  499,  497,  291,  491,  486,
      485,  482,  473, 1534, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1441, 1545, 1545, 1545, 1545, 1545, 1545, 1545,
     1545, 1545, 1545, 1545, 1545, 1545, 1545, 1545, 1545, 1545,
     1545, 1545, 1545, 1545, 1545, 1545, 1545, 1545, 1545, 1445,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,

     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1474,  469,  466, 1474,
     1572, 1448,  409,  407,  405,  227,  225,  220,  393,  389,
      391,  389,  387, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538,  386,  208,  202,  205,  204,  195,  204,  349,
      348,  347,  346,  345,  344,  331,  152,  305,  303,  300,
      299,  278,  277,  239,  125,  124,  239,  104,  224, 1449,
     1547, 1547, 1547, 1547, 1547, 1547, 1547, 1547, 1547, 1547,
     1547, 1547, 1547, 1547, 1547, 1547, 1547, 1547, 1547, 1547,
     1547, 1547, 1547, 1547, 1547, 1547,   38,   38,   38,   38,

       38,   38,   38,   38,   38,   38,   38,   39,   39,   39,
       39,   39,   39,   39,   39,   39,   39,   39,   56,   56,
       56,   56,   56,   56,   56,   56,   56,   56,   56,   68,
       68,   68,   68,   68,   68,   68,   68,   68,   68,   68,
       73,   73,   73,   73,   73,   73,   73,   73,   73,   73,
       73,   42,   42,   42,   42,   42,   42,   42,   42,   42,
       42,   42,   90,   90,   90,   90,   90,   90,   90,   90,
       90,   90,   90,   94,   94,   94,   94,   94,   94,   94,
       94,   94,   94,   94,   98,   98,   98,   98,   98,   98,
       98,   98,   98,   98,   98,  101,  101,  101,  101,  101,

      101,  101,  101,  101,  101,  101,  114,  114,  114,  114,
      114,  114,  114,  114,  114,  114,  114,  128,  128,  128,
      128,  162,  162,  223,  162,  162,  162,  162,  162,  162,
      162,  162,  172,  213,  212,  211,  172,  172,  172,  172,
      172,  172,  172,  177,  177,  210,  205,  177,  177,  177,
      177,  177,  177,  177,  183,  183,  204,  183,  183,  183,
      183,  183,  183,  183,  183,  185,  200,  188,  186,  185,
      185,  185,  185,  185,  185,  185,  187,  184,  182,  181,
      187,  187,  187,  187,  187,  187,  187,  189,  180,  179,
      173,  189,  189,  189,  189,  189,  189,  189,  206,  206,

      171,  206,  206,  206,  206,  206,  206,  206,  206,  214,
      214,  161,  214,  214,  214,  214,  214,  214,  214,  214,
      219,  219,  160,  219,  219,  219,  219,  219,  219,  219,
      219,  229,  229,  156,  229,  229,  229,  229,  229,  229,
      229,  229,  245,  245,  245,  245,  245,  245,  245,  245,
      245,  245,  245,  128,  128,  128,  128,  280,  280,  127,
      280,  280,  280,  280,  280,  280,  280,  280,  282,  282,
      125,  282,  282,  282,  282,  282,  282,  282,  282,  290,
      290,  124,  290,  290,  290,  290,  290,  290,  290,  290,
      295,  295,  108,  295,  295,  295,  295,  295,  295,  295,

      295,  301, 1572,  301,  301,  302,  302,  304,  102,  102,
      304,  304,  172,   38,   38, 1572,  172,  172,  172,  172,
      172,  172,  172,  177,  177, 1572, 1572,  177,  177,  177,
      177,  177,  177,  177,  183,  183, 1572,  183,  183,  183,
      183,  183,  183,  183,  183,  185, 1572, 1572, 1572,  185,
      185,  185,  185,  185,  185,  185,  187, 1572, 1572, 1572,
      187,  187,  187,  187,  187,  187,  187,  189, 1572, 1572,
     1572,  189,  189,  189,  189,  189,  189,  189,  353,  353,
      353,  353,  353,  353,  353,  353,  353,  353,  353,  362,
      362, 1572,  362,  362,  362,  362,  362,  362,  362,  362,

      388,  388, 1572,  388,  388,  388,  388,  388,  388,  388,
      388,  390,  390, 1572,  390,  390,  390,  390,  390,  390,
      390,  390,  219,  219, 1572,  219,  219,  219,  219,  219,
      219,  219,  219,  229,  229, 1572,  229,  229,  229,  229,
      229,  229,  229,  229,  417,  417,  417,  417,  417,  417,
      417,  417,  417,  417,  417,  290,  290, 1572,  290,  290,
      290,  290,  290,  290,  290,  290,  496,  496, 1572,  496,
      496,  496,  496,  496,  496,  496,  496,  280,  280, 1572,
      280,  280,  280,  280,  280,  280,  280,  280,  498,  498,
     1572,  498,  498,  498,  498,  498,  498,  498,  498,  503,

      503, 1572,  503,  503,  503,  503,  503,  503,  503,  503,
      504,  504, 1572,  504,  504,  504,  504,  504,  504,  504,
      504,  505,  505,  505,  505,  505, 1572,  505,  505,  505,
      505,  505,  506,  506, 1572,  506,  506,  506,  506,  506,
      506,  506,  506,  509,  509,  510,  510,  510,  510, 1572,
      510,  510,  510,  510,  510,  510,  511,  511,  511,  511,
      511, 1572,  511,  511,  511,  511,  511,  548,  548, 1572,
      548,  548,  548,  548,  548,  548,  548,  548,  353,  353,
      353,  353,  353,  353,  353,  353,  353,  353,  353,  555,
      555, 1572,  555,  555,  555,  555,  555,  555,  555,  555,

      584,  584, 1572,  584,  584,  584,  584,  584,  584,  584,
      584,  585,  585, 1572,  585,  585,  585,  585,  585,  585,
      585,  585,  587,  587, 1572,  587,  587,  587,  587,  587,
      587,  587,  587,  591,  591, 1572,  591,  591,  591,  591,
      591,  591,  591,  591,  599,  599, 1572,  599,  599,  599,
      599,  599,  599,  599,  599,  229,  229, 1572,  229,  229,
      229,  229,  229,  229,  229,  229,  639,  639, 1572,  639,
      639,  639,  639,  639,  639,  639,  639,  641,  641, 1572,
      641,  641,  641,  641,  641,  641,  641,  641,  649,  649,
     1572,  649,  649,  649,  649,  649,  649,  649,  649,  685,

      685, 1572,  685,  685,  685,  685,  685,  685,  685,  685,
      689,  689, 1572,  689,  689,  689,  689,  689,  689,  689,
      689,  496,  496, 1572,  496,  496,  496,  496,  496,  496,
      496,  496,  694,  694, 1572,  694,  694,  694,  694,  694,
      694,  694,  694,  695,  695, 1572,  695,  695,  695,  695,
      695,  695,  695,  695,  505,  505,  505,  505,  505,  505,
      505,  505,  505,  505,  505,  304,  304,  510,  510,  510,
      510,  510,  510,  510,  510,  510,  510,  510,  511,  511,
      511,  511,  511,  511,  511,  511,  511,  511,  511,  641,
      641, 1572,  641,  641,  641,  641,  641,  641,  641,  641,

      548,  548, 1572,  548,  548,  548,  548,  548,  548,  548,
      548,  733,  733, 1572,  733,  733,  733,  733,  733,  733,
      733,  733,  584,  584, 1572,  584,  584,  584,  584,  584,
      584,  584,  584,  769,  769, 1572,  769,  769,  769,  769,
      769,  769,  769,  769,  771,  771, 1572,  771,  771,  771,
      771,  771,  771,  771,  771,  814,  814, 1572,  814,  814,
      814,  814,  814,  814,  814,  814,  599,  599, 1572,  599,
      599,  599,  599,  599,  599,  599,  599,  816,  816, 1572,
      816,  816,  816,  816,  816,  816,  816,  816,  817,  817,
     1572,  817,  817,  817,  817,  817,  817,  817,  817,  229,

      229, 1572,  229,  229,  229,  229,  229,  229,  229,  229,
      818,  818, 1572,  818,  818,  818,  818,  818,  818,  818,
      818,  819,  819, 1572,  819,  819,  819,  819,  819,  819,
      819,  819,  820,  820, 1572,  820,  820,  820,  820,  820,
      820,  820,  820,  417,  417, 1572,  417,  417,  417,  417,
      417,  417,  417,  417,  828,  828, 1572,  828,  828,  828,
      828,  828,  828,  828,  828,  848,  848, 1572,  848,  848,
      848,  848,  848,  848,  848,  848,  852,  852, 1572,  852,
      852,  852,  852,  852,  852,  852,  852,  639,  639, 1572,
      639,  639,  639,  639,  639,  639,  639,  639,  854,  854,

     1572,  854,  854,  854,  854,  854,  854,  854,  854,  859,
      859, 1572,  859,  859,  859,  859,  859,  859,  859,  859,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  860,
      860,  864,  864,  864,  864,  864,  864,  864,  864,  864,
      864,  864,  865,  865,  865,  865,  865,  865,  865,  865,
      865,  865,  865,  866,  866, 1572,  866,  866,  866,  866,
      866,  866,  866,  866,  867,  867, 1572,  867,  867,  867,
      867,  867,  867,  867,  867,  868,  868, 1572,  868,  868,
      868,  868,  868,  868,  868,  868,  869,  869, 1572,  869,
      869,  869,  869,  869,  869,  869,  869,  870,  870, 1572,

      870,  870,  870,  870,  870,  870,  870,  870,  871,  871,
     1572,  871,  871,  871,  871,  871,  871,  871,  871,  685,
      685, 1572,  685,  685,  685,  685,  685,  685,  685,  685,
      872,  872, 1572,  872,  872,  872,  872,  872,  872,  872,
      872,  689,  689, 1572,  689,  689,  689,  689,  689,  689,
      689,  689,  875, 1572,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  854,  854, 1572,  854,  854,  854,  854,
      854,  854,  854,  854,  548,  548,  548,  548,  548,  548,
      548,  548,  548,  548,  548,  893,  893, 1572,  893,  893,
      893,  893,  893,  893,  893,  893,  919,  919, 1572,  919,

      919,  919,  919,  919,  919,  919,  919,  769,  769, 1572,
      769,  769,  769,  769,  769,  769,  769,  769,  920,  920,
     1572,  920,  920,  920,  920,  920,  920,  920,  920,  771,
      771, 1572,  771,  771,  771,  771,  771,  771,  771,  771,
      994,  994, 1572,  994,  994,  994,  994,  994,  994,  994,
      994,  814,  814, 1572,  814,  814,  814,  814,  814,  814,
      814,  814,  816,  816, 1572,  816,  816,  816,  816,  816,
      816,  816,  816,  817,  817, 1572,  817,  817,  817,  817,
      817,  817,  817,  817,  818,  818, 1572,  818,  818,  818,
      818,  818,  818,  818,  818,  819,  819, 1572,  819,  819,

      819,  819,  819,  819,  819,  819,  820,  820, 1572,  820,
      820,  820,  820,  820,  820,  820,  820,  828,  828, 1572,
      828,  828,  828,  828,  828,  828,  828,  828,  998,  998,
     1572,  998,  998,  998,  998,  998,  998,  998,  998,  999,
      999, 1572,  999,  999,  999,  999,  999,  999,  999,  999,
     1000, 1000, 1572, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1000, 1001, 1001, 1572, 1001, 1001, 1001, 1001, 1001, 1001,
     1001, 1001, 1002, 1002, 1572, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1003, 1003, 1572, 1003, 1003, 1003, 1003,
     1003, 1003, 1003, 1003,  848,  848, 1572,  848,  848,  848,

      848,  848,  848,  848,  848, 1004, 1004, 1572, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004,  852,  852, 1572,  852,
      852,  852,  852,  852,  852,  852,  852, 1006, 1006, 1572,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,  860,  860,
      860,  860,  860,  860,  860,  860,  860,  860,  860,  864,
      864,  864,  864,  864,  864,  864,  864,  864,  864,  864,
      865,  865,  865,  865,  865,  865,  865,  865,  865,  865,
      865,  866,  866, 1572,  866,  866,  866,  866,  866,  866,
      866,  866,  867,  867, 1572,  867,  867,  867,  867,  867,
      867,  867,  867,  868,  868, 1572,  868,  868,  868,  868,

      868,  868,  868,  868,  869,  869, 1572,  869,  869,  869,
      869,  869,  869,  869,  869,  870,  870, 1572,  870,  870,
      870,  870,  870,  870,  870,  870,  871,  871, 1572,  871,
      871,  871,  871,  871,  871,  871,  871,  872,  872, 1572,
      872,  872,  872,  872,  872,  872,  872,  872,  875, 1572,
      875,  875,  875,  875,  875,  875,  875,  875,  875, 1015,
     1015, 1572, 1015, 1015, 1015, 1015, 1015, 1015, 1015, 1015,
     1039, 1039, 1572, 1039, 1039, 1039, 1039, 1039, 1039, 1039,
     1039, 1040, 1040, 1572, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1147, 1572, 1147, 1147, 1164, 1164, 1572, 1164,

     1164, 1164, 1164, 1164, 1164, 1164, 1164,  998,  998, 1572,
      998,  998,  998,  998,  998,  998,  998,  998,  999,  999,
     1572,  999,  999,  999,  999,  999,  999,  999,  999, 1000,
     1000, 1572, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
     1001, 1001, 1572, 1001, 1001, 1001, 1001, 1001, 1001, 1001,
     1001, 1002, 1002, 1572, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1003, 1003, 1572, 1003, 1003, 1003, 1003, 1003,
     1003, 1003, 1003, 1004, 1004, 1572, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1167, 1167, 1167, 1167, 1167, 1167,
     1167, 1167, 1167, 1167, 1167, 1168, 1168, 1572, 1168, 1168,

     1168, 1168, 1168, 1168, 1168, 1168, 1185, 1185, 1572, 1185,
     1185, 1185, 1185, 1185, 1185, 1185, 1185, 1186, 1186, 1572,
     1186, 1186, 1186, 1186, 1186, 1186, 1186, 1186, 1330, 1330,
     1572, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1331,
     1331, 1572, 1331, 1331, 1331, 1331, 1331, 1331, 1331, 1331,
     1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1340, 1343, 1343, 1343, 1343, 1343, 1343, 1343, 1343, 1343,
     1343, 1343, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346,
     1346, 1346, 1346, 1351, 1351, 1572, 1351, 1351, 1351, 1351,
     1351, 1351, 1351, 1351, 1147, 1572, 1147, 1572, 1147, 1147,

     1357, 1572, 1357, 1572, 1357, 1357, 1384, 1384, 1572, 1384,
     1384, 1384, 1384, 1384, 1384, 1384, 1384, 1407, 1572, 1407,
     1407, 1438, 1438, 1572, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1442, 1442, 1572, 1442, 1442, 1442, 1442, 1442,
     1442, 1442, 1442, 1446, 1446, 1572, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446, 1459, 1572, 1459, 1459,   37, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,

     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572

    } ;

static const flex_int16_t yy_chk[7701] =
    {   0,
        0,    0,    3,    3,    4,    4,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,

        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    7,    7,    7,
        7,    8,    8,    8,    8,   15,    9,   10,   25,   25,
       25,   25,    7,   27,   27,   27,    8,   26,   26,   26,
       26,  250,   25,   25,    9,   10,   28,   28,   28,   29,
       30,   26,   26,   33,   33,  250,   29,   30,   34,   34,
       15, 1756,   48,   29,   30,   48,   15,  379,   15,  379,

        7,    9,   10,   59,    8,  233,   59,   40,   40,   40,
       40,   25,  233,   25,   66,   66,   40,   66,   87,   87,
       26,   15,   26,   40,  787,   67,  787,   15,   67,   15,
      284,  284,    9,   10,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,

       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,

       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,

       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   16,   43,   43,   43,
       43,  260,  135,   55,   44,   44,   44,   44,   55,  368,
      260,   43,   43,   44,   44,   86,   86,   86,   86,   44,
       44,   60,   60,   60,   60,   60,   60,   60,   99,   99,
     1751,   16,   91,   91,   91,   91,  369,   16,  111,   16,
      368,  111, 1749,   99,  135,   55,  103,  103,  103,  103,
       43,  104,  104,  126,  269,  127,  126,   44,  127,  104,
      136,  139,   16,  136,  139,  269,  104,  369,   16,  139,
       16,   19,   19,   19,   19,   19,   19,   19,   19,   19,

       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,

       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,

       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,

       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,

       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   45,   45,   45,   45,  370,  164,
      165,  155,  164,  165,  150,   52,  155,  130,   52,   45,
      130, 1739,   53,   53,   53,   53,  248,   83,  150,   52,
       83,   53,   53,   84,   84,   84,   84,  138,   53,  370,
      138,   83,   83,  296,  296,  148,  138,   97,  148,  166,
       97,  517,  166,  155,  148,  311,  311,   45,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   52,   51,
      130,  197,   51,   51,   51,   53,  167,   84,  248,  167,
       83,  108,  108,  108,  108, 1649,   84,  150,   84,   97,

      108,  197,  249,  113,   51,  150,  159,  108,   97,  159,
      113,  321,  197,  168,  159,  113,  168,  113,  169,   51,
       51,  169,  321,   51,   51,   51,   51,   51,   51,   51,
       97,   51,  197,  170,   51,   51,  170,   51,   51,   51,
      517,   51,   51,   51,   51,   51,   51,   51,  107,   51,
       51,   51,  113,  420,  249,  107,  109,  109,  109,  109,
      107,  270,  270,  270,  107,  107,  107,  420,  107,  440,
      109,  109,  110,  110,  110,  110,  113,  115,  115,  115,
      115,  436,  177,  107,  113,  177,  457,  110,  116,  116,
      116,  116,  115,  325,  325,  424,  107,  116,  116,  117,

      117,  117,  117,  116,  116,  178, 1627,  149,  178,  109,
      149,  783,  236,  239,  117,  236,  239,  123,  123,  123,
      123,  149,  328,  328,  783,  110,  123,  123,  204,  440,
      115,  204,  123,  123, 1618,  151,  151,  151,  151,  383,
      383,  116,  132,  132,  132,  132,  132,  132,  132,  132,
      436,  134,  117,  121,  121,  134,  121,  134,  134,  265,
      149,  457,  265,  134,  162,  162,  162,  162,  134,  121,
      123,  134,  371,  152,  152,  152,  152,  424,  220,  220,
      121,  204,  152,  152,  223,  223,  121,  121,  151,  152,
      121,  423,  121,  220,  121,  423,  121,  121,  121,  223,

      121,  240,  121,  371,  240,  443,  121,  154,  154,  240,
      154,  121,  154,  121,  241,  121,  275,  241,  121,  275,
      154,  154,  241,  121,  411,  411,  152,  154,  121,  122,
      122,  122,  122,  122,  122,  122,  122,  122,  122,  276,
      122,  514,  276,  122,  122,  122,  147,  276,  147,  571,
      147,  147,  147,  147,  147,  147,  147,  147,  147, 1233,
      156,  156,  156,  156,  190,  122,  443,  190,  571,  156,
      156,  191,  191,  191,  191,  429,  156,  758,  190,  190,
      122,  122,  414,  414,  122,  122,  122,  122,  122,  122,
      122, 1204,  122,  372,  194,  122,  122,  194,  122,  122,

      122,  758,  122,  122,  122,  122,  122,  122,  122,  194,
      122,  122,  122,  156,  157,  429,  514,  190,  157,  163,
      157,  157,  163,  803,  372,  432,  157,  192,  192,  192,
      192,  157,  253,  253,  157,  253,  803,  163,  163,  163,
      163,  217,  192,  195,  195,  195,  195,  194,  200,  200,
      200,  200,  201,  201,  201,  201,  202,  202,  202,  202,
      207,  207,  207,  207,  210,  210,  210,  210,  222,  217,
      222, 1233,  431,  261,  227,  227,  261,  374,  516,  222,
      217,  222,  227,  222,  432,  230,  217,  195,  230,  227,
      222,  231,  200,  432,  231,  463,  195, 1204,  195,  463,

      217,  200,  261,  200,  208,  208,  208,  208,  374,  234,
      238,  217,  431, 1196,  261,  234,  222,  217,  231,  230,
      234,  238,  242,  242,  242,  242,  234,  238,  230, 1292,
      208,  208,  234,  279,  231,  442,  279,  242,  208,  208,
      231,  238,  208,  208,  256,  208,  234,  256,  331,  208,
      516,  331,  238,  243,  243,  243,  243,  234,  238,  244,
      244,  244,  244,  234,  246,  246,  246,  246,  243,  208,
      247,  247,  247,  247,  244,  242,  439,  258,  256,  246,
      258,  262,  272,  293,  262,  247,  293,  256,  262,  493,
      493,  308,  293,  272,  308,  442,  442,  442,  262,  272,

      308, 1198,  313,  313,  258,  313,  243,  310,  310,  310,
      310,  332,  244,  272,  332,  532,  532,  246,  258,  318,
      258,  272,  318,  247,  272,  333,  258,  441,  333, 1569,
      272,  208,  208,  208, 1196,  208,  208,  208,  519,  208,
     1198,  208,  208,  251,  251, 1292,  251,  334,  324,  439,
      334,  324,  263,  318,  335,  313,  324,  335,  263,  251,
      310,  336,  318,  263,  336,  337,  560, 1565,  337,  263,
      251,  338,  573,  573,  338,  263,  251,  251,  339,  561,
      251,  339,  251, 1564,  251,  520,  251,  251,  251,  263,
      251,  441,  251, 1561,  318,  340,  251,  560,  340,  318,

      263,  251,  441,  251,  341,  251,  263,  341,  251,  342,
      561,  343,  342,  251,  343,  643,  643,  519,  251,  252,
      252,  252,  252,  252,  252,  252,  252,  252,  252,  402,
      252,  518,  402,  252,  252,  252,  306,  306,  306,  306,
      306,  306,  306,  306,  306,  350,  350,  350,  350,  351,
      351,  351,  351,  403,  352,  252,  403,  352,  354,  404,
      405,  354,  404,  405,  520,  355,  355,  355,  355,  352,
      252,  252, 1258,  354,  252,  252,  252,  252,  252,  252,
      252,  406,  252,  662,  406,  252,  252,  662,  252,  252,
      252,  572,  252,  252,  252,  252,  252,  252,  252,  518,

      252,  252,  252,  315,  315, 1258,  315,  352,  357,  355,
      518,  354,  361,  361,  361,  361, 1265,  652,  355,  315,
      355,  366,  366,  366,  366,  652,  576, 1560,  357,  315,
      315,  563,  315,  576,  315,  407,  315,  315,  407,  357,
      315, 1228,  315,  315,  315,  565,  315,  315,  315,  315,
      315,  408,  315,  572,  408,  409,  315,  410,  409,  357,
      410,  315,  563,  315,  468,  315,  437,  468,  315,  392,
      392,  392,  392,  315,  392,  807,  565,  807,  315,  316,
      316,  316,  316,  316,  316,  316,  316,  316,  316,  469,
      316,  566,  469,  316,  316,  316,  666,  567,  418,  418,

      418,  418,  425,  425,  666,  425,  419,  419,  419,  419,
      741,  426,  426,  418,  426,  316,  568,  421,  421,  421,
      421,  419,  566,  437,  446,  446,  437,  446,  567,  741,
      316,  316,  421, 1265,  316,  316,  316,  316,  316,  316,
      316,  470,  316,  570,  470,  316,  316,  568,  316,  316,
      316,  418,  316,  316,  316,  316,  316,  316,  316,  419,
      316,  316,  316,  363,  363,  363,  363, 1228,  373,  422,
      421,  422,  373, 1199,  570,  759,  373,  446,  422,  653,
      653,  467,  373,  422,  467,  422,  467,  737,  373,  363,
      363,  428,  428,  471,  428,  759,  471,  363,  363,  373,

      434,  363,  363,  373,  363,  708,  708,  373,  363,  433,
      433,  739,  433,  373,  430,  430,  742,  430,  737,  373,
      422,  453,  453,  860,  453,  428,  434,  931,  363,  434,
      435,  860,  472,  434,  428,  472,  455,  455,  433,  455,
      931,  430,  739,  434,  422,  455,  456,  742,  473,  864,
      433,  473,  422,  864,  444,  430,  435,  430,  474,  711,
      711,  474,  435,  430, 1225,  451,  865,  435,  373,  451,
      954,  451,  451,  435,  865,  465,  465,  451,  465,  435,
      475, 1199,  451,  475,  465,  451,  444,  791,  791,  954,
      363,  363,  363,  435,  363,  363,  363,  444,  363,  476,

      363,  363,  476,  444,  435,  477,  456, 1116,  477,  456,
      435,  438,  478,  479,  456,  478,  479,  444,  480,  481,
      482,  480,  481,  482,  483,  444,  484,  483,  444,  484,
      485, 1116,  488,  485,  444,  488,  438,  438,  438,  438,
      438,  438,  438,  438,  438,  438,  438,  438,  438,  438,
      438,  438,  438,  438,  438,  438,  438,  438,  438,  438,
      438,  438,  448,  489,  490,  492,  489,  490,  492,  497,
      500, 1221,  497,  500,  486,  524, 1221,  486,  524,  448,
      448,  448,  448,  448,  448,  448,  448,  460, 1225,  523,
      526,  521,  486,  526, 1557,  521,  460,  521,  521,  527,

      811,  811,  527,  521,  460,  460,  460,  460,  521,  822,
      822,  521,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  461,  486,
      528,  529,  530,  528,  529,  530,  513,  531,  513,  523,
      531,  537,  523,  538,  537,  539,  538,  523,  539,  935,
      743,  935,  513,  461,  461,  461,  461,  461,  461,  461,
      461,  461,  461,  461,  461,  461,  461,  461,  461,  461,
      461,  461,  461,  461,  461,  461,  461,  461,  461,  540,
      541,  743,  540,  541,  461,  461,  461,  461,  461,  461,

      461,  461,  461,  461,  461,  461,  461,  461,  461,  461,
      461,  461,  461,  461,  461,  461,  461,  461,  461,  461,
      462,  513,  546,  602,  606,  546,  602,  606, 1259,  513,
      559,  559,  559,  559,  825,  825,  462,  462,  462,  462,
      462,  462,  462,  462,  462,  462,  462,  462,  462,  462,
      462,  462,  462,  462,  462,  462,  462,  462,  462,  462,
      462,  462,  612,  515,  515,  612,  515,  462,  462,  462,
      462,  462,  462,  462,  462,  462,  462,  462,  462,  462,
      462,  462,  462,  462,  462,  462,  462,  462,  462,  462,
      462,  462,  462,  464, 1555,  553,  961,  515,  553,  545,

      562,  614,  545,  961,  614,  464,  515,  464, 1051,  464,
      464,  464,  464,  464,  464,  464,  464,  464,  545,  549,
      745, 1051,  549,  562,  550,  550,  550,  550,  564,  569,
     1551,  562,  613,  569,  549,  613, 1259,  613,  515,  550,
      564,  615,  608,  515,  615,  608,  569,  957,  553,  564,
      608,  745,  569,  564,  609,  616,  913,  609,  616,  564,
      617,  618,  609,  617,  618,  619,  620,  621,  619,  620,
      621,  564,  549,  556,  556,  556,  556,  913,  622,  623,
      564,  622,  623,  624,  564,  625,  624,  626,  625,  627,
      626,  628,  627, 1206,  628,  629,  562, 1550,  629,  556,

      556,  630,  631,  632,  630,  631,  632,  556,  556,  957,
      634,  556,  556,  634,  556, 1549,  635,  636,  556,  635,
      636,  632,  638,  651,  665,  638,  651,  665,  671,  906,
      906,  671,  651,  665,  672,  912,  912,  672,  556,  663,
      663,  663,  663,  663,  663,  663,  663,  663,  673,  674,
      675,  673,  674,  675,  678,  679,  681,  678,  679,  681,
      682,  683,  684,  682,  683,  684,  687,  688,  632,  687,
      688,  690,  692,  693,  690,  692,  693,  697,  700,  702,
      697,  700,  702,  703,  704,  705,  703,  704,  705,  706,
      707,  714,  706,  707,  714,  715,  716, 1206,  715,  716,

      556,  556,  556, 1528,  556,  556,  556, 1055,  556, 1055,
      556,  556,  589,  589,  589,  589,  717,  589,  718,  717,
      719,  718,  720,  719,  721,  720,  725,  721,  727,  725,
      728,  727,  729,  728,  730,  729, 1117,  730,  589,  589,
      731,  731,  731,  731,  748,  735,  589,  589,  735,  746,
      589,  589, 1231,  589,  750,  751, 1117,  589,  732,  732,
      732,  732,  752,  746,  753,  589,  734,  734,  734,  734,
      738,  738,  738,  738,  744,  748,  764,  589,  744,  764,
      746,  747,  747,  747,  747,  750,  751,  744,  775,  776,
      777,  778,  779,  752,  746,  753, 1155,  749,  749,  749,

      749,  781,  795,  796,  797,  744, 1269,  798, 1202,  744,
      821,  799, 1154,  821,  829,  801, 1155,  829,  744,  775,
      776,  777,  778,  779,  749,  834,  835,  749,  834,  835,
      914,  914,  781,  795,  796,  797, 1154,  749,  798,  589,
      589,  589,  799,  589,  589,  589,  801,  589, 1527,  589,
      589,  590,  590,  590,  590,  749,  590,  836,  749, 1300,
      836,  774,  774,  837,  838, 1200,  837,  838,  749,  774,
      774, 1231,  841,  774,  774,  841,  774,  590,  590,  842,
      774,  844,  842, 1230,  844,  590,  590,  780,  774,  590,
      590,  780,  590, 1526,  845,  780,  590,  845,  895,  846,

      774,  780,  846,  847,  590,  850,  847,  780,  850, 1202,
      851,  764,  764,  851,  853,  983,  590,  853,  780, 1077,
      856,  873,  780,  856,  873,  874,  780,  876,  874,  895,
      876,  877,  780,  878,  877, 1269,  878,  879,  780,  880,
      879,  881,  880,  882,  881,  883,  882,  886,  883,  888,
      886,  889,  888,  890,  889,  891,  890,  892,  891, 1300,
      892, 1293,  774,  774,  774, 1270,  774,  774,  774, 1230,
      774,  894,  774,  774,  894,  939,  939,  983,  590,  590,
      590, 1077,  590,  590,  590, 1200,  590,  780,  590,  590,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,

      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  958,  958,  984,  984,  896,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  773,  773,  773,  773,  896,  773,  898,
      987,  995,  794,  794,  995,  899,  900,  987, 1293,  902,
      794,  794, 1203,  903,  794,  794,  923,  794, 1270,  773,

      773,  794,  901,  901,  901,  901,  924,  773,  773,  794,
      898,  773,  773,  925,  773,  800,  899,  900,  773,  800,
      902,  794,  926,  800,  903,  927,  773,  923,  929,  800,
      943,  944,  946,  948,  949,  800,  950,  924,  773,  951,
      953,  901,  942, 1525,  925,  942,  800,  942,  969,  970,
      800,  952, 1240,  926,  800,  952,  927, 1240,  980,  929,
      800,  943,  944,  946,  948,  949,  800,  950,  952,  978,
      951,  953,  901,  978,  952, 1203,  945,  980,  972,  969,
      970,  974,  975,  794,  794,  794,  978,  794,  794,  794,
     1090,  794,  978,  794,  794,  942, 1031, 1031, 1226,  945,

      773,  773,  773, 1090,  773,  773,  773,  945,  773,  972,
      773,  773,  974,  975, 1229,  800,  862,  862,  862,  862,
      862,  862,  862,  862,  862,  862,  862,  862,  862,  862,
      862,  862,  862,  862,  862,  862,  862,  862,  862,  862,
      862,  862,  863,  863,  863,  863,  863,  863,  863,  863,
      863,  863,  863,  863,  863,  863,  863,  863,  863,  863,
      863,  863,  863,  863,  863,  863,  863,  863,  997, 1059,
     1059,  997,  945,  863,  863,  863,  863,  863,  863,  863,
      863,  863,  863,  863,  863,  863,  863,  863,  863,  863,
      863,  863,  863,  863,  863,  863,  863,  863,  863,  921,

      921,  921,  921, 1005,  921,  976, 1005,  968,  922,  922,
      968, 1008,  968, 1291, 1008,  977,  922,  922, 1229,  979,
      922,  922, 1226,  922, 1081,  921,  921,  922,  971, 1010,
     1010, 1081, 1010,  921,  921,  922,  976,  921,  921, 1016,
      921,  928,  947, 1018,  921,  928,  977,  922, 1019,  928,
      979,  971,  921, 1011,  947,  928, 1011, 1020, 1021,  971,
      968,  928, 1013,  947,  921, 1013, 1014,  947, 1505, 1014,
     1016, 1023,  928,  947, 1018, 1089,  928, 1043, 1089, 1019,
      928, 1017, 1017, 1017, 1017,  947,  928, 1023, 1020, 1021,
     1044, 1045,  928, 1023,  947,  956, 1500,  956,  947,  956,

      956,  956,  956,  956,  956,  956,  956,  956, 1043,  922,
      922,  922, 1261,  922,  922,  922, 1046,  922, 1047,  922,
      922, 1044, 1045, 1049,  971, 1063,  921,  921,  921, 1074,
      921,  921,  921, 1223,  921, 1062,  921,  921, 1062, 1291,
     1062,  928,  955, 1022, 1022, 1022, 1022, 1046, 1074, 1047,
      955,  955,  955,  955, 1049, 1298, 1063, 1294,  955,  955,
      955,  955,  955,  955,  955,  955,  955,  955,  955,  955,
      955,  955,  955,  955,  955,  955,  955,  955,  955,  955,
      955,  955,  955,  955,  973, 1025, 1025, 1072, 1062, 1078,
     1078, 1072, 1095, 1223, 1064, 1499,  973, 1066, 1068, 1069,

     1070, 1071, 1073, 1065, 1072,  973, 1091, 1025, 1025,  973,
     1072, 1095,  982, 1261,  982,  973,  982,  982,  982,  982,
      982,  982,  982,  982,  982, 1064, 1065,  973, 1066, 1068,
     1069, 1070, 1071, 1073, 1065, 1093,  973, 1091, 1133, 1096,
      973, 1041, 1041, 1041, 1041, 1127, 1041, 1097, 1127, 1088,
     1042, 1042, 1088, 1122, 1088, 1223, 1122, 1133, 1042, 1042,
     1197, 1099, 1042, 1042, 1294, 1042, 1093, 1041, 1041, 1042,
     1096, 1102, 1298, 1104, 1266, 1041, 1041, 1042, 1097, 1041,
     1041, 1100, 1041, 1048, 1067, 1092, 1041, 1048, 1092, 1042,
     1092, 1048, 1099, 1105, 1041, 1100, 1067, 1048, 1106, 1065,

     1107, 1236, 1102, 1048, 1104, 1067, 1041, 1128, 1126, 1067,
     1271, 1126, 1100, 1126, 1048, 1067, 1273, 1197, 1048, 1098,
     1128, 1273, 1048, 1098, 1105, 1486, 1100, 1067, 1048, 1106,
     1197, 1107, 1098, 1129, 1048, 1131, 1067, 1076, 1092, 1076,
     1067, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1098, 1042, 1042, 1042, 1098, 1042, 1042, 1042, 1236, 1042,
     1134, 1042, 1042, 1098, 1129, 1135, 1131, 1137, 1041, 1041,
     1041, 1236, 1041, 1041, 1041, 1266, 1041, 1101, 1041, 1041,
     1101, 1264, 1101, 1048, 1075, 1207, 1477, 1165, 1122, 1122,
     1165, 1134, 1075, 1075, 1075, 1075, 1135, 1140, 1137, 1467,

     1075, 1075, 1075, 1075, 1075, 1075, 1075, 1075, 1075, 1075,
     1075, 1075, 1075, 1075, 1075, 1075, 1075, 1075, 1075, 1075,
     1075, 1075, 1075, 1075, 1075, 1075, 1103, 1142, 1140, 1103,
     1101, 1103, 1109, 1109, 1143, 1290, 1138, 1144, 1145, 1136,
     1109, 1109, 1271, 1136, 1109, 1109, 1166, 1109, 1241, 1166,
     1138, 1109, 1136, 1103, 1160, 1169, 1103, 1160, 1142, 1109,
     1167, 1167, 1264, 1167, 1260, 1143, 1103, 1138, 1144, 1145,
     1136, 1109, 1130, 1139, 1136, 1130, 1139, 1130, 1139, 1103,
     1207, 1138, 1205, 1136, 1103, 1209, 1169, 1103, 1110, 1110,
     1110, 1110, 1110, 1110, 1110, 1110, 1110, 1103, 1108, 1108,

     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108, 1108,
     1108, 1108, 1108, 1108, 1170, 1130, 1139, 1171, 1171, 1171,
     1171, 1209, 1241, 1109, 1109, 1109, 1190, 1109, 1109, 1109,
     1466, 1109, 1286, 1109, 1109, 1111, 1111, 1141, 1260, 1267,
     1141, 1241, 1141, 1111, 1111, 1170, 1227, 1111, 1111, 1290,
     1111, 1190, 1209, 1193, 1111, 1201, 1285, 1147, 1147, 1277,
     1205, 1205, 1111, 1277, 1141, 1147, 1147, 1141, 1299, 1147,
     1147, 1465, 1147, 1189, 1111, 1232, 1147, 1141, 1193, 1160,
     1160, 1464, 1190, 1463, 1147, 1172, 1172, 1172, 1172, 1286,

     1141, 1179, 1179, 1179, 1179, 1141, 1147, 1189, 1141, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1141, 1193,
     1191, 1212, 1149, 1149, 1180, 1180, 1180, 1180, 1224, 1214,
     1149, 1149, 1462, 1192, 1149, 1149, 1285, 1149, 1189, 1318,
     1318, 1149, 1181, 1181, 1181, 1181, 1111, 1111, 1111, 1149,
     1111, 1111, 1111, 1191, 1111, 1212, 1111, 1111, 1201, 1188,
     1201, 1149, 1183, 1183, 1183, 1183, 1192, 1232, 1147, 1147,
     1147, 1214, 1147, 1147, 1147, 1219, 1147, 1267, 1147, 1147,
     1188, 1188, 1215, 1227, 1191, 1210, 1212, 1195, 1188, 1188,
     1227, 1194, 1188, 1188, 1299, 1188, 1211, 1192, 1287, 1188,

     1208, 1234, 1214, 1208, 1234, 1208, 1234, 1188, 1195, 1220,
     1210, 1288, 1194, 1455, 1262, 1215, 1194, 1219, 1218, 1188,
     1194, 1211, 1450, 1149, 1149, 1149, 1194, 1149, 1149, 1149,
     1239, 1149, 1194, 1149, 1149, 1187, 1187, 1187, 1187, 1195,
     1187, 1210, 1216, 1194, 1211, 1217, 1215, 1194, 1219, 1324,
     1324, 1194, 1211, 1208, 1237, 1278, 1436, 1194, 1224, 1224,
     1302, 1187, 1187, 1194, 1239, 1302, 1326, 1326, 1242, 1187,
     1187, 1243, 1213, 1187, 1187, 1216, 1187, 1245, 1217, 1237,
     1187, 1188, 1188, 1188, 1287, 1188, 1188, 1188, 1187, 1188,
     1263, 1188, 1188, 1213, 1220, 1239, 1235, 1278, 1218, 1235,

     1187, 1235, 1218, 1242, 1243, 1213, 1216, 1435, 1262, 1217,
     1237, 1245, 1194, 1220, 1213, 1218, 1297, 1211, 1213, 1288,
     1301, 1218, 1238, 1301, 1213, 1238, 1247, 1238, 1278, 1247,
     1295, 1247, 1262, 1434, 1242, 1243, 1213, 1251, 1222, 1252,
     1244, 1428, 1245, 1253, 1250, 1213, 1222, 1246, 1222, 1213,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1248,
     1252, 1244, 1187, 1187, 1187, 1244, 1187, 1187, 1187, 1250,
     1187, 1276, 1187, 1187, 1244, 1238, 1246, 1253, 1263, 1247,
     1289, 1272, 1249, 1251, 1272, 1249, 1272, 1249, 1248, 1279,
     1246, 1252, 1244, 1280, 1255, 1296, 1244, 1426, 1263, 1268,

     1250, 1283, 1268, 1419, 1268, 1244, 1276, 1246, 1253, 1249,
     1279, 1415, 1249, 1423, 1251, 1255, 1255, 1297, 1297, 1248,
     1414, 1246, 1249, 1255, 1255, 1283, 1355, 1255, 1255, 1355,
     1255, 1280, 1256, 1423, 1255, 1249, 1257, 1276, 1275, 1282,
     1249, 1279, 1255, 1249, 1256, 1256, 1256, 1256, 1256, 1256,
     1256, 1256, 1256, 1249, 1255, 1413, 1283, 1257, 1257, 1412,
     1295, 1295, 1280, 1411, 1282, 1257, 1257, 1275, 1410, 1257,
     1257, 1304, 1257, 1274, 1401, 1281, 1257, 1424, 1281, 1296,
     1281, 1274, 1305, 1274, 1257, 1274, 1274, 1274, 1274, 1274,
     1274, 1274, 1274, 1274, 1284, 1282, 1257, 1424, 1275, 1284,

     1296, 1307, 1304, 1483, 1289, 1289, 1308, 1284, 1284, 1284,
     1284, 1400, 1309, 1305, 1281, 1398, 1255, 1255, 1255, 1325,
     1255, 1255, 1255, 1483, 1255, 1311, 1255, 1255, 1281, 1397,
     1312, 1335, 1307, 1310, 1268, 1268, 1310, 1308, 1310, 1332,
     1325, 1393, 1303, 1309, 1303, 1281, 1303, 1303, 1303, 1303,
     1303, 1303, 1303, 1303, 1303, 1335, 1311, 1333, 1257, 1257,
     1257, 1312, 1257, 1257, 1257, 1425, 1257, 1369, 1257, 1257,
     1332, 1334, 1310, 1392, 1334, 1339, 1339, 1339, 1339, 1340,
     1340, 1340, 1340, 1369, 1377, 1377, 1310, 1425, 1333, 1369,
     1391, 1334, 1341, 1341, 1341, 1341, 1334, 1342, 1342, 1342,

     1342, 1360, 1390, 1310, 1343, 1343, 1343, 1343, 1344, 1344,
     1344, 1344, 1345, 1345, 1345, 1345, 1346, 1346, 1346, 1346,
     1347, 1347, 1347, 1347, 1348, 1348, 1348, 1348, 1354, 1354,
     1357, 1389, 1360, 1357, 1362, 1357, 1354, 1354, 1363, 1359,
     1354, 1354, 1359, 1354, 1359, 1361, 1364, 1354, 1361, 1365,
     1361, 1386, 1371, 1371, 1387, 1354, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1362, 1433, 1354, 1368, 1363,
     1478, 1368, 1388, 1368, 1371, 1371, 1457, 1364, 1383, 1457,
     1365, 1457, 1386, 1357, 1382, 1387, 1394, 1394, 1394, 1394,
     1433, 1402, 1359, 1403, 1478, 1366, 1421, 1366, 1361, 1366,

     1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1395, 1395,
     1395, 1395, 1396, 1396, 1396, 1396, 1454, 1454, 1454, 1454,
     1408, 1368, 1402, 1408, 1403, 1408, 1381, 1421, 1380, 1354,
     1354, 1354, 1379, 1354, 1354, 1354, 1399, 1354, 1422, 1354,
     1354, 1399, 1409, 1416, 1479, 1409, 1416, 1409, 1416, 1399,
     1399, 1399, 1399, 1404, 1404, 1404, 1404, 1404, 1404, 1404,
     1404, 1404, 1405, 1405, 1484, 1378, 1376, 1429, 1479, 1422,
     1405, 1405, 1375, 1408, 1405, 1405, 1374, 1405, 1407, 1407,
     1417, 1405, 1373, 1417, 1484, 1417, 1407, 1407, 1430, 1418,
     1407, 1407, 1418, 1407, 1418, 1409, 1416, 1407, 1429, 1420,

     1451, 1405, 1420, 1427, 1420, 1427, 1452, 1427, 1427, 1427,
     1427, 1427, 1427, 1427, 1427, 1427, 1431, 1407, 1432, 1430,
     1372, 1432, 1460, 1370, 1431, 1431, 1431, 1431, 1461, 1437,
     1481, 1451, 1437, 1417, 1437, 1482, 1367, 1452, 1432, 1501,
     1485, 1438, 1418, 1432, 1438, 1439, 1438, 1502, 1439, 1350,
     1439, 1440, 1420, 1460, 1440, 1441, 1440, 1349, 1441, 1461,
     1441, 1481, 1485, 1405, 1405, 1405, 1482, 1405, 1405, 1405,
     1501, 1405, 1442, 1405, 1405, 1442, 1338, 1442, 1502, 1407,
     1407, 1407, 1437, 1407, 1407, 1407, 1337, 1407, 1443, 1407,
     1407, 1443, 1444, 1443, 1438, 1444, 1445, 1444, 1439, 1445,

     1446, 1445, 1336, 1446, 1440, 1446, 1447, 1448, 1441, 1447,
     1448, 1447, 1448, 1449, 1330, 1329, 1449, 1441, 1449, 1453,
     1453, 1453, 1453, 1459, 1468, 1442, 1459, 1468, 1459, 1468,
     1441, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1515, 1443, 1541, 1516, 1328, 1444, 1327, 1543, 1517, 1445,
     1323, 1471, 1322, 1446, 1471, 1321, 1471, 1320, 1445, 1447,
     1448, 1319, 1515, 1317, 1541, 1474, 1449, 1516, 1474, 1543,
     1474, 1445, 1517, 1316, 1480, 1449, 1470, 1468, 1315, 1470,
     1314, 1470, 1480, 1480, 1480, 1480, 1518, 1488, 1449, 1470,
     1488, 1470, 1488, 1470, 1470, 1470, 1470, 1470, 1470, 1470,

     1470, 1470, 1473, 1490, 1471, 1473, 1490, 1473, 1490, 1492,
     1518, 1542, 1492, 1553, 1492, 1473, 1313, 1473, 1474, 1473,
     1473, 1473, 1473, 1473, 1473, 1473, 1473, 1473, 1506, 1470,
     1552, 1542, 1306, 1509, 1254, 1553, 1506, 1506, 1506, 1506,
     1488, 1509, 1509, 1509, 1509, 1554, 1559, 1544, 1453, 1469,
     1552, 1562, 1469, 1186, 1469, 1473, 1490, 1185, 1494, 1469,
     1184, 1494, 1492, 1494, 1182, 1554, 1559, 1469, 1469, 1469,
     1469, 1544, 1178, 1562, 1177, 1469, 1469, 1469, 1469, 1469,
     1469, 1469, 1469, 1469, 1469, 1469, 1469, 1469, 1469, 1469,
     1469, 1469, 1469, 1469, 1469, 1469, 1469, 1469, 1469, 1469,

     1469, 1176, 1469, 1472, 1175, 1174, 1472, 1173, 1472, 1163,
     1162, 1494, 1496, 1472, 1161, 1496, 1159, 1496, 1158, 1157,
     1156, 1472, 1472, 1472, 1472, 1548, 1548, 1548, 1548, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1558, 1472, 1475, 1498, 1566,
     1475, 1498, 1475, 1498, 1153, 1496, 1504, 1475, 1152, 1504,
     1151, 1504, 1150, 1132, 1125, 1475, 1475, 1475, 1475, 1558,
     1124, 1566, 1123, 1475, 1475, 1475, 1475, 1475, 1475, 1475,
     1475, 1475, 1475, 1475, 1475, 1475, 1475, 1475, 1475, 1475,

     1475, 1475, 1475, 1475, 1475, 1475, 1475, 1475, 1475, 1476,
     1475, 1498, 1476, 1121, 1476, 1120, 1119, 1118, 1489, 1504,
     1115, 1489, 1476, 1489, 1476, 1563, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1489, 1489, 1489, 1489, 1489,
     1489, 1489, 1489, 1489, 1512, 1567, 1114, 1570, 1545, 1563,
     1113, 1112, 1512, 1512, 1512, 1512, 1545, 1545, 1545, 1545,
     1094, 1087, 1476, 1487, 1086, 1085, 1487, 1567, 1487, 1570,
     1084, 1489, 1083, 1082, 1530, 1503, 1080, 1530, 1503, 1530,
     1503, 1532, 1534, 1079, 1532, 1534, 1532, 1534, 1061, 1487,
     1487, 1487, 1487, 1487, 1487, 1487, 1487, 1487, 1487, 1487,

     1487, 1487, 1487, 1487, 1487, 1487, 1487, 1487, 1487, 1487,
     1487, 1487, 1487, 1487, 1487, 1060, 1487, 1491, 1536, 1058,
     1491, 1536, 1491, 1536, 1057, 1056, 1538, 1530, 1503, 1538,
     1546, 1538, 1054, 1053, 1532, 1534, 1052, 1050, 1546, 1546,
     1546, 1546, 1038, 1491, 1491, 1491, 1491, 1491, 1491, 1491,
     1491, 1491, 1491, 1491, 1491, 1491, 1491, 1491, 1491, 1491,
     1491, 1491, 1491, 1491, 1491, 1491, 1491, 1491, 1491, 1493,
     1491, 1536, 1493, 1037, 1493, 1036, 1035, 1034, 1497, 1538,
     1033, 1497, 1032, 1497, 1030, 1029, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1497, 1497, 1497, 1497, 1497,

     1497, 1497, 1497, 1497, 1503, 1547, 1568, 1568, 1568, 1568,
     1028, 1027, 1026, 1547, 1547, 1547, 1547, 1024,  996,  993,
      992,  991, 1493, 1495, 1507,  990, 1495, 1507, 1495, 1507,
     1508, 1497,  989, 1508, 1510, 1508,  988, 1510, 1511, 1510,
      986, 1511, 1513, 1511,  985, 1513,  981, 1513,  967, 1495,
     1495, 1495, 1495, 1495, 1495, 1495, 1495, 1495, 1495, 1495,
     1495, 1495, 1495, 1495, 1495, 1495, 1495, 1495, 1495, 1495,
     1495, 1495, 1495, 1495, 1495, 1514, 1495, 1507, 1514, 1540,
     1514,  966, 1540, 1508, 1540,  965, 1507, 1510,  964,  963,
      962, 1511, 1508,  960,  959, 1513, 1510,  941, 1556, 1507,

     1511, 1556,  940, 1556, 1513, 1508,  938, 1571,  937, 1510,
     1571,  936, 1571, 1511,  934,  933,  932, 1513,  930,  918,
      917, 1519,  916,  915, 1519,  911, 1519,  910, 1514,  909,
      908,  907, 1540,  905, 1519,  904, 1519, 1514, 1519, 1519,
     1519, 1519, 1519, 1519, 1519, 1519, 1519,  897,  885,  861,
     1514, 1556,  827,  826,  824,  823,  813,  812,  810,  809,
     1571,  808,  806,  805,  804,  802,  793,  792,  790,  789,
      788,  786,  785,  784, 1519, 1520,  782,  768,  767,  766,
      765,  763,  762, 1520, 1520, 1520, 1520,  761,  760,  757,
      756, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,

     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1521,  755,  754,
     1521,  740, 1521,  736,  726,  724,  722,  713,  712,  710,
     1521,  709, 1521,  701, 1521, 1521, 1521, 1521, 1521, 1521,
     1521, 1521, 1521,  695,  691,  655,  654,  648,  647,  646,
      645,  644,  642,  611,  607,  592,  591,  588,  587,  586,
      585,  583,  582,  581,  580,  579,  578,  577,  575,  574,
     1521, 1522,  557,  551,  547,  544,  543,  542,  536, 1522,
     1522, 1522, 1522,  534,  533,  525,  522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,

     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1523,  512,  511, 1523,  510, 1523,  507,
      506,  505,  495,  494,  459,  458, 1523,  454, 1523,  452,
     1523, 1523, 1523, 1523, 1523, 1523, 1523, 1523, 1523,  450,
      449,  445,  427,  417,  416,  415,  413,  412,  400,  398,
      397,  396,  395,  394,  393,  391,  390,  389,  388,  386,
      385,  384,  382,  381,  380,  378, 1523, 1524,  377,  376,
      375,  367,  364,  359,  358, 1524, 1524, 1524, 1524,  356,
      349,  348,  347, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,

     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1529,
      346,  345, 1529,  344, 1529,  330,  329,  327,  326,  323,
      322,  320,  319,  317,  314,  312, 1529, 1529, 1529, 1529,
     1529, 1529, 1529, 1529, 1529,  298, 1533,  297,  289, 1533,
      288, 1533,  287,  286,  285,  283,  278,  274,  271,  268,
      267,  264,  259, 1533, 1533, 1533, 1533, 1533, 1533, 1533,
     1533, 1533, 1529, 1531, 1531, 1531, 1531, 1531, 1531, 1531,
     1531, 1531, 1531, 1531, 1531, 1531, 1531, 1531, 1531, 1531,
     1531, 1531, 1531, 1531, 1531, 1531, 1531, 1531, 1531, 1533,
     1535, 1535, 1535, 1535, 1535, 1535, 1535, 1535, 1535, 1535,

     1535, 1535, 1535, 1535, 1535, 1535, 1535, 1535, 1535, 1535,
     1535, 1535, 1535, 1535, 1535, 1535, 1537,  257,  255, 1537,
      245, 1537,  237,  235,  232,  228,  226,  221,  218,  216,
      215,  214,  213, 1537, 1537, 1537, 1537, 1537, 1537, 1537,
     1537, 1537,  211,  209,  203,  199,  198,  196,  193,  182,
      181,  180,  176,  175,  174,  161,  153,  146,  145,  143,
      140,  125,  124,  120,  119,  118,  112,  105,  102, 1537,
     1539, 1539, 1539, 1539, 1539, 1539, 1539, 1539, 1539, 1539,
     1539, 1539, 1539, 1539, 1539, 1539, 1539, 1539, 1539, 1539,
     1539, 1539, 1539, 1539, 1539, 1539, 1573, 1573, 1573, 1573,

     1573, 1573, 1573, 1573, 1573, 1573, 1573, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1575, 1575,
     1575, 1575, 1575, 1575, 1575, 1575, 1575, 1575, 1575, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1577, 1577, 1577, 1577, 1577, 1577, 1577, 1577, 1577, 1577,
     1577, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1579, 1579, 1579, 1579, 1579, 1579, 1579, 1579,
     1579, 1579, 1579, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1581, 1581, 1581, 1581, 1581, 1581,
     1581, 1581, 1581, 1581, 1581, 1582, 1582, 1582, 1582, 1582,

     1582, 1582, 1582, 1582, 1582, 1582, 1583, 1583, 1583, 1583,
     1583, 1583, 1583, 1583, 1583, 1583, 1583, 1584, 1584, 1584,
     1584, 1585, 1585,  100, 1585, 1585, 1585, 1585, 1585, 1585,
     1585, 1585, 1586,   96,   95,   93, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1587, 1587,   92,   89, 1587, 1587, 1587,
     1587, 1587, 1587, 1587, 1588, 1588,   88, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1589,   85,   81,   78, 1589,
     1589, 1589, 1589, 1589, 1589, 1589, 1590,   75,   72,   71,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1591,   70,   69,
       65, 1591, 1591, 1591, 1591, 1591, 1591, 1591, 1592, 1592,

       62, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1593,
     1593,   58, 1593, 1593, 1593, 1593, 1593, 1593, 1593, 1593,
     1594, 1594,   57, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1595, 1595,   54, 1595, 1595, 1595, 1595, 1595, 1595,
     1595, 1595, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1597, 1597, 1597, 1597, 1598, 1598,   49,
     1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1599, 1599,
       47, 1599, 1599, 1599, 1599, 1599, 1599, 1599, 1599, 1600,
     1600,   46, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1601, 1601,   41, 1601, 1601, 1601, 1601, 1601, 1601, 1601,

     1601, 1602,   37, 1602, 1602, 1603, 1603, 1604,   36,   35,
     1604, 1604, 1605,   18,   17,    0, 1605, 1605, 1605, 1605,
     1605, 1605, 1605, 1606, 1606,    0,    0, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1607, 1607,    0, 1607, 1607, 1607,
     1607, 1607, 1607, 1607, 1607, 1608,    0,    0,    0, 1608,
     1608, 1608, 1608, 1608, 1608, 1608, 1609,    0,    0,    0,
     1609, 1609, 1609, 1609, 1609, 1609, 1609, 1610,    0,    0,
        0, 1610, 1610, 1610, 1610, 1610, 1610, 1610, 1611, 1611,
     1611, 1611, 1611, 1611, 1611, 1611, 1611, 1611, 1611, 1612,
     1612,    0, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,

     1613, 1613,    0, 1613, 1613, 1613, 1613, 1613, 1613, 1613,
     1613, 1614, 1614,    0, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1614, 1615, 1615,    0, 1615, 1615, 1615, 1615, 1615,
     1615, 1615, 1615, 1616, 1616,    0, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1616, 1617, 1617, 1617, 1617, 1617, 1617,
     1617, 1617, 1617, 1617, 1617, 1619, 1619,    0, 1619, 1619,
     1619, 1619, 1619, 1619, 1619, 1619, 1620, 1620,    0, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1621, 1621,    0,
     1621, 1621, 1621, 1621, 1621, 1621, 1621, 1621, 1622, 1622,
        0, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1623,

     1623,    0, 1623, 1623, 1623, 1623, 1623, 1623, 1623, 1623,
     1624, 1624,    0, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1625, 1625, 1625, 1625, 1625,    0, 1625, 1625, 1625,
     1625, 1625, 1626, 1626,    0, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1628, 1628, 1629, 1629, 1629, 1629,    0,
     1629, 1629, 1629, 1629, 1629, 1629, 1630, 1630, 1630, 1630,
     1630,    0, 1630, 1630, 1630, 1630, 1630, 1631, 1631,    0,
     1631, 1631, 1631, 1631, 1631, 1631, 1631, 1631, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1633,
     1633,    0, 1633, 1633, 1633, 1633, 1633, 1633, 1633, 1633,

     1634, 1634,    0, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1635, 1635,    0, 1635, 1635, 1635, 1635, 1635, 1635,
     1635, 1635, 1636, 1636,    0, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1637, 1637,    0, 1637, 1637, 1637, 1637,
     1637, 1637, 1637, 1637, 1638, 1638,    0, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1639, 1639,    0, 1639, 1639,
     1639, 1639, 1639, 1639, 1639, 1639, 1640, 1640,    0, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1641, 1641,    0,
     1641, 1641, 1641, 1641, 1641, 1641, 1641, 1641, 1642, 1642,
        0, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1643,

     1643,    0, 1643, 1643, 1643, 1643, 1643, 1643, 1643, 1643,
     1644, 1644,    0, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1645, 1645,    0, 1645, 1645, 1645, 1645, 1645, 1645,
     1645, 1645, 1646, 1646,    0, 1646, 1646, 1646, 1646, 1646,
     1646, 1646, 1646, 1647, 1647,    0, 1647, 1647, 1647, 1647,
     1647, 1647, 1647, 1647, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1648, 1648, 1648, 1650, 1650, 1651, 1651, 1651,
     1651, 1651, 1651, 1651, 1651, 1651, 1651, 1651, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1653,
     1653,    0, 1653, 1653, 1653, 1653, 1653, 1653, 1653, 1653,

     1654, 1654,    0, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1655, 1655,    0, 1655, 1655, 1655, 1655, 1655, 1655,
     1655, 1655, 1656, 1656,    0, 1656, 1656, 1656, 1656, 1656,
     1656, 1656, 1656, 1657, 1657,    0, 1657, 1657, 1657, 1657,
     1657, 1657, 1657, 1657, 1658, 1658,    0, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1659, 1659,    0, 1659, 1659,
     1659, 1659, 1659, 1659, 1659, 1659, 1660, 1660,    0, 1660,
     1660, 1660, 1660, 1660, 1660, 1660, 1660, 1661, 1661,    0,
     1661, 1661, 1661, 1661, 1661, 1661, 1661, 1661, 1662, 1662,
        0, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1663,

     1663,    0, 1663, 1663, 1663, 1663, 1663, 1663, 1663, 1663,
     1664, 1664,    0, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1665, 1665,    0, 1665, 1665, 1665, 1665, 1665, 1665,
     1665, 1665, 1666, 1666,    0, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1667, 1667,    0, 1667, 1667, 1667, 1667,
     1667, 1667, 1667, 1667, 1668, 1668,    0, 1668, 1668, 1668,
     1668, 1668, 1668, 1668, 1668, 1669, 1669,    0, 1669, 1669,
     1669, 1669, 1669, 1669, 1669, 1669, 1670, 1670,    0, 1670,
     1670, 1670, 1670, 1670, 1670, 1670, 1670, 1671, 1671,    0,
     1671, 1671, 1671, 1671, 1671, 1671, 1671, 1671, 1672, 1672,

        0, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1673,
     1673,    0, 1673, 1673, 1673, 1673, 1673, 1673, 1673, 1673,
     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1675, 1675, 1675, 1675, 1675, 1675, 1675, 1675, 1675,
     1675, 1675, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676, 1676, 1676, 1677, 1677,    0, 1677, 1677, 1677, 1677,
     1677, 1677, 1677, 1677, 1678, 1678,    0, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1679, 1679,    0, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1680, 1680,    0, 1680,
     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1681, 1681,    0,

     1681, 1681, 1681, 1681, 1681, 1681, 1681, 1681, 1682, 1682,
        0, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1683,
     1683,    0, 1683, 1683, 1683, 1683, 1683, 1683, 1683, 1683,
     1684, 1684,    0, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1685, 1685,    0, 1685, 1685, 1685, 1685, 1685, 1685,
     1685, 1685, 1686,    0, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1687, 1687,    0, 1687, 1687, 1687, 1687,
     1687, 1687, 1687, 1687, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1689, 1689,    0, 1689, 1689,
     1689, 1689, 1689, 1689, 1689, 1689, 1690, 1690,    0, 1690,

     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1691, 1691,    0,
     1691, 1691, 1691, 1691, 1691, 1691, 1691, 1691, 1692, 1692,
        0, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1692, 1693,
     1693,    0, 1693, 1693, 1693, 1693, 1693, 1693, 1693, 1693,
     1694, 1694,    0, 1694, 1694, 1694, 1694, 1694, 1694, 1694,
     1694, 1695, 1695,    0, 1695, 1695, 1695, 1695, 1695, 1695,
     1695, 1695, 1696, 1696,    0, 1696, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1697, 1697,    0, 1697, 1697, 1697, 1697,
     1697, 1697, 1697, 1697, 1698, 1698,    0, 1698, 1698, 1698,
     1698, 1698, 1698, 1698, 1698, 1699, 1699,    0, 1699, 1699,

     1699, 1699, 1699, 1699, 1699, 1699, 1700, 1700,    0, 1700,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1701, 1701,    0,
     1701, 1701, 1701, 1701, 1701, 1701, 1701, 1701, 1702, 1702,
        0, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1703,
     1703,    0, 1703, 1703, 1703, 1703, 1703, 1703, 1703, 1703,
     1704, 1704,    0, 1704, 1704, 1704, 1704, 1704, 1704, 1704,
     1704, 1705, 1705,    0, 1705, 1705, 1705, 1705, 1705, 1705,
     1705, 1705, 1706, 1706,    0, 1706, 1706, 1706, 1706, 1706,
     1706, 1706, 1706, 1707, 1707,    0, 1707, 1707, 1707, 1707,
     1707, 1707, 1707, 1707, 1708, 1708,    0, 1708, 1708, 1708,

     1708, 1708, 1708, 1708, 1708, 1709, 1709,    0, 1709, 1709,
     1709, 1709, 1709, 1709, 1709, 1709, 1710, 1710,    0, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1711, 1711,    0,
     1711, 1711, 1711, 1711, 1711, 1711, 1711, 1711, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1713,
     1713, 1713, 1713, 1713, 1713, 1713, 1713, 1713, 1713, 1713,
     1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1715, 1715,    0, 1715, 1715, 1715, 1715, 1715, 1715,
     1715, 1715, 1716, 1716,    0, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1717, 1717,    0, 1717, 1717, 1717, 1717,

     1717, 1717, 1717, 1717, 1718, 1718,    0, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1719, 1719,    0, 1719, 1719,
     1719, 1719, 1719, 1719, 1719, 1719, 1720, 1720,    0, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1721, 1721,    0,
     1721, 1721, 1721, 1721, 1721, 1721, 1721, 1721, 1722,    0,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1723,
     1723,    0, 1723, 1723, 1723, 1723, 1723, 1723, 1723, 1723,
     1724, 1724,    0, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1725, 1725,    0, 1725, 1725, 1725, 1725, 1725, 1725,
     1725, 1725, 1726,    0, 1726, 1726, 1727, 1727,    0, 1727,

     1727, 1727, 1727, 1727, 1727, 1727, 1727, 1728, 1728,    0,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1729, 1729,
        0, 1729, 1729, 1729, 1729, 1729, 1729, 1729, 1729, 1730,
     1730,    0, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1731, 1731,    0, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
     1731, 1732, 1732,    0, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1733, 1733,    0, 1733, 1733, 1733, 1733, 1733,
     1733, 1733, 1733, 1734, 1734,    0, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1735, 1735, 1735, 1735, 1735, 1735,
     1735, 1735, 1735, 1735, 1735, 1736, 1736,    0, 1736, 1736,

     1736, 1736, 1736, 1736, 1736, 1736, 1737, 1737,    0, 1737,
     1737, 1737, 1737, 1737, 1737, 1737, 1737, 1738, 1738,    0,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1738, 1740, 1740,
        0, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1741,
     1741,    0, 1741, 1741, 1741, 1741, 1741, 1741, 1741, 1741,
     1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1743, 1743, 1743, 1743, 1743, 1743, 1743, 1743, 1743,
     1743, 1743, 1744, 1744, 1744, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1745, 1745,    0, 1745, 1745, 1745, 1745,
     1745, 1745, 1745, 1745, 1746,    0, 1746,    0, 1746, 1746,

     1747,    0, 1747,    0, 1747, 1747, 1748, 1748,    0, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1750,    0, 1750,
     1750, 1752, 1752,    0, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1753, 1753,    0, 1753, 1753, 1753, 1753, 1753,
     1753, 1753, 1753, 1754, 1754,    0, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1755,    0, 1755, 1755, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,

     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572

    } ;

static yy_state_type yy_last_accepting_state;
static char *yy_last_accepting_cpos;

extern int yy_flex_debug;
int yy_flex_debug = 0;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
char *yytext;
#line 1 "lexgrog.l"

#line 19 "lexgrog.l"

/*
 * lexgrog.l: extract 'whatis' info from nroff man / formatted cat pages.
 *
 * Copyright (C) 1994, 1995 Graeme W. Wilford. (Wilf.)
 * Copyright (C) 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010,
 *               2011, 2012 Colin Watson.
 *
 * This file is part of man-db.
 *
 * man-db is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * man-db is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with man-db; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * Wed Oct 12 18:46:11 BST 1994  Wilf. (G.Wilford@ee.surrey.ac.uk)
 *
 * CJW: Detect grap and vgrind. Understand fill requests. Other improvements
 * in the syntax accepted.
 */

#include <sys/stat.h>
#include <errno.h>
#include <stdbool.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

#include "error.h"
#include "xalloc.h"

#include "gettext.h"
#define _(String) gettext (String)

#include "encodings.h"
#include "pipeline.h"
#include "sandbox.h"
#include "security.h"
#include "util.h"

#include "decompress.h"
#include "lexgrog.h"
#include "manconv.h"
#include "manconv_client.h"

#define YY_READ_BUF_SIZE	1024
#define MAX_NAME		8192

/* defines the ordered list of filters detected by lexgrog */
enum {
	TBL_FILTER = 0,	/* tbl */
	EQN_FILTER,	/* eqn */
	PIC_FILTER,	/* pic */
	GRAP_FILTER,	/* grap */
	REF_FILTER,	/* refer */
	VGRIND_FILTER,	/* vgrind */
	MAX_FILTERS	/* delimiter */
};

#define ARRAY_SIZE(array) (sizeof (array) / sizeof ((array)[0]))

extern man_sandbox *sandbox;

struct macro {
	const char *name;
	const char *value;
};

static const struct macro glyphs[] = {
	/* It is vital to keep these in strcmp order (sort -t\" -k2)!  They
	 * will be searched using bsearch.
	 * Data from groff_char(7), although I have omitted some that are
	 * particularly unlikely to be used in NAME sections.
	 */
	{ "'A", "Á" },
	{ "'C", "Ć" },
	{ "'E", "É" },
	{ "'I", "Í" },
	{ "'O", "Ó" },
	{ "'U", "Ú" },
	{ "'Y", "Ý" },
	{ "'a", "á" },
	{ "'c", "ć" },
	{ "'e", "é" },
	{ "'i", "í" },
	{ "'o", "ó" },
	{ "'u", "ú" },
	{ "'y", "ý" },
	{ ",C", "Ç" },
	{ ",c", "ç" },
	{ "-D", "Ð" },
	{ ".i", "ı" },
	{ "/L", "Ł" },
	{ "/O", "Ø" },
	{ "/l", "ł" },
	{ "/o", "ø" },
	{ ":A", "Ä" },
	{ ":E", "Ë" },
	{ ":I", "Ï" },
	{ ":O", "Ö" },
	{ ":U", "Ü" },
	{ ":Y", "Ÿ" },
	{ ":a", "ä" },
	{ ":e", "ë" },
	{ ":i", "ï" },
	{ ":o", "ö" },
	{ ":u", "ü" },
	{ ":y", "ÿ" },
	{ "AE", "Æ" },
	{ "Bq", "„" },
	{ "Fc", "»" },
	{ "Fi", "ffi" },
	{ "Fl", "ffl" },
	{ "Fo", "«" },
	{ "IJ", "Ĳ" },
	{ "OE", "Œ" },
	{ "Sd", "ð" },
	{ "TP", "Þ" },
	{ "Tp", "þ" },
	{ "^A", "Â" },
	{ "^E", "Ê" },
	{ "^I", "Î" },
	{ "^O", "Ô" },
	{ "^U", "Û" },
	{ "^a", "â" },
	{ "^e", "ê" },
	{ "^i", "î" },
	{ "^o", "ô" },
	{ "^u", "û" },
	{ "`A", "À" },
	{ "`E", "È" },
	{ "`I", "Ì" },
	{ "`O", "Ò" },
	{ "`U", "Ù" },
	{ "`a", "à" },
	{ "`e", "è" },
	{ "`i", "ì" },
	{ "`o", "ò" },
	{ "`u", "ù" },
	{ "a\"", "˝" },
	{ "a-", "¯" },
	{ "a.", "˙" },
	{ "a^", "^" },
	{ "aa", "´" },
	{ "ab", "˘" },
	{ "ac", "¸" },
	{ "ad", "¨" },
	{ "ae", "æ" },
	{ "ah", "ˇ" },
	{ "ao", "˚" },
	{ "aq", "'" },
	{ "a~", "~" },
	{ "bq", "‚" },
	{ "cq", "’" },
	{ "dq", "\"" },
	{ "em", "—" },
	{ "en", "–" },
	{ "fc", "›" },
	{ "ff", "ff" },
	{ "fi", "fi" },
	{ "fl", "fl" },
	{ "fo", "‹" },
	{ "ga", "`" },
	{ "ha", "^" },
	{ "ho", "˛" },
	{ "hy", "‐" },
	{ "ij", "ĳ" },
	{ "lq", "“" },
	{ "oA", "Å" },
	{ "oa", "å" },
	{ "oe", "œ" },
	{ "oq", "‘" },
	{ "r!", "¡" },
	{ "r?", "¿" },
	{ "rq", "”" },
	{ "ss", "ß" },
	{ "ti", "~" },
	{ "vS", "Š" },
	{ "vZ", "Ž" },
	{ "vs", "š" },
	{ "vz", "ž" },
	{ "~A", "Ã" },
	{ "~N", "Ñ" },
	{ "~O", "Õ" },
	{ "~a", "ã" },
	{ "~n", "ñ" },
	{ "~o", "õ" }
};

static const struct macro perldocs[] = {
	/* It is vital to keep these in strcmp order (sort -t\" -k2)!  They
	 * will be searched using bsearch.
	 * Data from Pod/Man.pm.
	 */
	{ "--", "-" },
	{ "Aq", "'" },
	{ "C'", "'" },
	{ "C+", "C++" },
	{ "C`", "`" },
	{ "L\"", "\"" },
	{ "PI", "π" },
	{ "R\"", "\"" }
};

static void add_str_to_whatis (const char *string, size_t length);
static void add_char_to_whatis (unsigned char c);
static void add_separator_to_whatis (void);
static void add_wordn_to_whatis (const char *string, size_t length);
static void add_word_to_whatis (const char *string);
static void add_glyph_to_whatis (const char *string, size_t length);
static void add_perldoc_to_whatis (const char *string, size_t length);
static void mdoc_text (const char *string);
static void newline_found (void);

static char newname[MAX_NAME];
static char *p_name;
static const char *fname;
static char filters[MAX_FILTERS];

static bool fill_mode;
static bool waiting_for_quote;

static decompress *decomp;

#define YY_INPUT(buf,result,max_size) { \
	size_t size = max_size; \
	const char *block = decompress_read (decomp, &size); \
	if (block && size != 0) { \
		memcpy (buf, block, size); \
		buf[size] = '\0'; \
		result = size; \
	} else \
		result = YY_NULL; \
}
#define YY_NO_INPUT
#line 2967 "lexgrog.c"

#line 309 "lexgrog.l"
 /* Please add to this list if you know how. */
 /* Note that, since flex only supports UTF-8 by accident, character classes
  * including non-ASCII characters must be written out as (a|b|c|d) rather
  * than [abcd].
  */
 /* ИМЕ also works for mk */
 /* NOME also works for gl, pt */
 /* eptgrv : eqn, pic, tbl, grap, refer, vgrind */
#line 2978 "lexgrog.c"

#define INITIAL 0
#define MAN_PRENAME 1
#define MAN_NAME 2
#define MAN_DESC 3
#define MAN_DESC_AT 4
#define MAN_DESC_BSX 5
#define MAN_DESC_BX 6
#define MAN_DESC_BX_RELEASE 7
#define MAN_DESC_DQ 8
#define MAN_DESC_FX 9
#define MAN_DESC_NX 10
#define MAN_DESC_OX 11
#define CAT_NAME 12
#define CAT_FILE 13
#define MAN_FILE 14
#define CAT_REST 15
#define MAN_REST 16
#define FORCE_EXIT 17

#ifndef YY_NO_UNISTD_H
/* Special case for "unistd.h", since it is non-ANSI. We include it way
 * down here because we want the user's section 1 to have been scanned first.
 * The user has a chance to override it with an option.
 */
#include <unistd.h>
#endif

#ifndef YY_EXTRA_TYPE
#define YY_EXTRA_TYPE void *
#endif

static int yy_init_globals ( void );

/* Accessor methods to globals.
   These are made visible to non-reentrant scanners for convenience. */

int yylex_destroy ( void );

int yyget_debug ( void );

void yyset_debug ( int debug_flag  );

YY_EXTRA_TYPE yyget_extra ( void );

void yyset_extra ( YY_EXTRA_TYPE user_defined  );

FILE *yyget_in ( void );

void yyset_in  ( FILE * _in_str  );

FILE *yyget_out ( void );

void yyset_out  ( FILE * _out_str  );

			int yyget_leng ( void );

char *yyget_text ( void );

int yyget_lineno ( void );

void yyset_lineno ( int _line_number  );

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap ( void );
#else
extern int yywrap ( void );
#endif
#endif

#ifndef YY_NO_UNPUT
    
#endif

#ifndef yytext_ptr
static void yy_flex_strncpy ( char *, const char *, int );
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen ( const char * );
#endif

#ifndef YY_NO_INPUT
#ifdef __cplusplus
static int yyinput ( void );
#else
static int input ( void );
#endif

#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k */
#define YY_READ_BUF_SIZE 16384
#else
#define YY_READ_BUF_SIZE 8192
#endif /* __ia64__ */
#endif

/* Copy whatever the last rule matched to the standard output. */
#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO do { if (fwrite( yytext, (size_t) yyleng, 1, yyout )) {} } while (0)
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( YY_CURRENT_BUFFER_LVALUE->yy_is_interactive ) \
		{ \
		int c = '*'; \
		int n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else \
		{ \
		errno=0; \
		while ( (result = (int) fread(buf, 1, (yy_size_t) max_size, yyin)) == 0 && ferror(yyin)) \
			{ \
			if( errno != EINTR) \
				{ \
				YY_FATAL_ERROR( "input in flex scanner failed" ); \
				break; \
				} \
			errno=0; \
			clearerr(yyin); \
			} \
		}\
\

#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
#endif

/* end tables serialization structures and prototypes */

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL_IS_OURS 1

extern int yylex (void);

#define YY_DECL int yylex (void)
#endif /* !YY_DECL */

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK /*LINTED*/break;
#endif

#define YY_RULE_SETUP \
	YY_USER_ACTION

/** The main scanner function which does all the work.
 */
YY_DECL
{
	yy_state_type yy_current_state;
	char *yy_cp, *yy_bp;
	int yy_act;
    
	if ( !(yy_init) )
		{
		(yy_init) = 1;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! (yy_start) )
			(yy_start) = 1;	/* first start state */

		if ( ! yyin )
			yyin = stdin;

		if ( ! yyout )
			yyout = stdout;

		if ( ! YY_CURRENT_BUFFER ) {
			yyensure_buffer_stack ();
			YY_CURRENT_BUFFER_LVALUE =
				yy_create_buffer( yyin, YY_BUF_SIZE );
		}

		yy_load_buffer_state(  );
		}

	{
#line 360 "lexgrog.l"


 /* begin NAME section processing */
#line 3214 "lexgrog.c"

	while ( /*CONSTCOND*/1 )		/* loops until end-of-file is reached */
		{
		yy_cp = (yy_c_buf_p);

		/* Support of yytext. */
		*yy_cp = (yy_hold_char);

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = (yy_start);
yy_match:
		do
			{
			YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)] ;
			if ( yy_accept[yy_current_state] )
				{
				(yy_last_accepting_state) = yy_current_state;
				(yy_last_accepting_cpos) = yy_cp;
				}
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 1573 )
					yy_c = yy_meta[yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
			++yy_cp;
			}
		while ( yy_current_state != 1572 );
		yy_cp = (yy_last_accepting_cpos);
		yy_current_state = (yy_last_accepting_state);

yy_find_action:
		yy_act = yy_accept[yy_current_state];

		YY_DO_BEFORE_ACTION;

do_action:	/* This label is used only to access EOF actions. */

		switch ( yy_act )
	{ /* beginning of action switch */
			case 0: /* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = (yy_hold_char);
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			goto yy_find_action;

case 1:
/* rule 1 can match eol */
YY_RULE_SETUP
#line 363 "lexgrog.l"
BEGIN (MAN_PRENAME);
	YY_BREAK
case 2:
/* rule 2 can match eol */
YY_RULE_SETUP
#line 364 "lexgrog.l"
BEGIN (CAT_NAME);
	YY_BREAK
/* general text matching */

case 3:
#line 369 "lexgrog.l"
case 4:
#line 370 "lexgrog.l"
case 5:
#line 371 "lexgrog.l"
case 6:
/* rule 6 can match eol */
YY_RULE_SETUP
#line 371 "lexgrog.l"

	YY_BREAK


case 7:
#line 376 "lexgrog.l"
case 8:
#line 377 "lexgrog.l"
case 9:
/* rule 9 can match eol */
#line 378 "lexgrog.l"
case 10:
/* rule 10 can match eol */
YY_RULE_SETUP
#line 378 "lexgrog.l"

	YY_BREAK


case 11:
/* rule 11 can match eol */
YY_RULE_SETUP
#line 382 "lexgrog.l"
filters[TBL_FILTER] = 't';
	YY_BREAK
case 12:
/* rule 12 can match eol */
YY_RULE_SETUP
#line 383 "lexgrog.l"
filters[EQN_FILTER] = 'e';
	YY_BREAK
case 13:
/* rule 13 can match eol */
YY_RULE_SETUP
#line 384 "lexgrog.l"
filters[PIC_FILTER] = 'p';
	YY_BREAK
case 14:
/* rule 14 can match eol */
YY_RULE_SETUP
#line 385 "lexgrog.l"
filters[GRAP_FILTER] = 'g';
	YY_BREAK
case 15:
/* rule 15 can match eol */
#line 387 "lexgrog.l"
case 16:
/* rule 16 can match eol */
YY_RULE_SETUP
#line 387 "lexgrog.l"
filters[REF_FILTER] = 'r';
	YY_BREAK
case 17:
/* rule 17 can match eol */
YY_RULE_SETUP
#line 388 "lexgrog.l"
filters[VGRIND_FILTER] = 'v';
	YY_BREAK

case YY_STATE_EOF(MAN_REST):
#line 390 "lexgrog.l"
{	/* exit */
	*p_name = '\0'; /* terminate the string */
	yyterminate ();
}
	YY_BREAK
case 18:
/* rule 18 can match eol */
YY_RULE_SETUP
#line 394 "lexgrog.l"

	YY_BREAK
/* rules to end NAME section processing */
case 19:
/* rule 19 can match eol */
YY_RULE_SETUP
#line 397 "lexgrog.l"
{	/* forced exit */
	*p_name = '\0'; /* terminate the string */
	yyterminate ();
}
	YY_BREAK
case 20:
/* rule 20 can match eol */
#line 403 "lexgrog.l"
YY_RULE_SETUP
case YY_STATE_EOF(MAN_PRENAME):
#line 403 "lexgrog.l"
{	/* no NAME at all */
	*p_name = '\0';
	BEGIN (MAN_REST);
}
	YY_BREAK
/* need to match whole string so that we beat the following roff catch-all,
    so use yyless to push back the name */

case 21:
/* rule 21 can match eol */
#line 412 "lexgrog.l"
case 22:
/* rule 22 can match eol */
#line 413 "lexgrog.l"
case 23:
/* rule 23 can match eol */
#line 414 "lexgrog.l"
case 24:
/* rule 24 can match eol */
#line 415 "lexgrog.l"
case 25:
/* rule 25 can match eol */
#line 416 "lexgrog.l"
case 26:
/* rule 26 can match eol */
YY_RULE_SETUP
#line 416 "lexgrog.l"
{
		yyless (0);
		BEGIN (MAN_NAME);
	}
	YY_BREAK

/* Skip over initial roff requests in NAME section. The use of yyless here
    is evil. */
case 27:
/* rule 27 can match eol */
YY_RULE_SETUP
#line 424 "lexgrog.l"

	YY_BREAK
case 28:
/* rule 28 can match eol */
YY_RULE_SETUP
#line 426 "lexgrog.l"
yyless (1);
	YY_BREAK
case 29:
/* rule 29 can match eol */
YY_RULE_SETUP
#line 428 "lexgrog.l"
{
	yyless (0);
	BEGIN (MAN_NAME);
}
	YY_BREAK

case 30:
/* rule 30 can match eol */
#line 435 "lexgrog.l"
case 31:
/* rule 31 can match eol */
#line 436 "lexgrog.l"
case 32:
/* rule 32 can match eol */
#line 437 "lexgrog.l"
case 33:
/* rule 33 can match eol */
#line 438 "lexgrog.l"
case 34:
/* rule 34 can match eol */
#line 439 "lexgrog.l"
case 35:
/* rule 35 can match eol */
#line 440 "lexgrog.l"
case 36:
/* rule 36 can match eol */
#line 441 "lexgrog.l"
YY_RULE_SETUP
case YY_STATE_EOF(MAN_NAME):
YY_RULE_SETUP
case YY_STATE_EOF(MAN_DESC):
#line 441 "lexgrog.l"
{	/* terminate the string */
		*p_name = '\0';
		BEGIN (MAN_REST);
	}
	YY_BREAK


case 37:
/* rule 37 can match eol */
#line 449 "lexgrog.l"
case 38:
/* rule 38 can match eol */
#line 450 "lexgrog.l"
case 39:
/* rule 39 can match eol */
YY_RULE_SETUP
#line 450 "lexgrog.l"
{	/* terminate the string */
		*p_name = '\0';
		BEGIN (CAT_REST);
		yyterminate ();
	}
	YY_BREAK

/* ROFF request removal */

/* some include quoting; dealing with this is unpleasant */
case 40:
/* rule 40 can match eol */
YY_RULE_SETUP
#line 460 "lexgrog.l"
{
		newline_found ();
		waiting_for_quote = true;
	}
	YY_BREAK
case 41:
/* rule 41 can match eol */
#line 466 "lexgrog.l"
case 42:
/* rule 42 can match eol */
#line 467 "lexgrog.l"
case 43:
/* rule 43 can match eol */
#line 468 "lexgrog.l"
case 44:
/* rule 44 can match eol */
#line 469 "lexgrog.l"
case 45:
/* rule 45 can match eol */
#line 470 "lexgrog.l"
case 46:
/* rule 46 can match eol */
#line 471 "lexgrog.l"
case 47:
/* rule 47 can match eol */
#line 472 "lexgrog.l"
case 48:
/* rule 48 can match eol */
#line 473 "lexgrog.l"
case 49:
/* rule 49 can match eol */
YY_RULE_SETUP
#line 473 "lexgrog.l"
{	/* per line comments */
		newline_found ();
	}
	YY_BREAK

/* No-op requests */

case 50:
/* rule 50 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
YY_LINENO_REWIND_TO(yy_cp - 1);
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 480 "lexgrog.l"
newline_found ();
	YY_BREAK
case 51:
/* rule 51 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
YY_LINENO_REWIND_TO(yy_cp - 1);
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 481 "lexgrog.l"
newline_found ();
	YY_BREAK

/* Toggle fill mode */

case 52:
/* rule 52 can match eol */
YY_RULE_SETUP
#line 486 "lexgrog.l"
fill_mode = false;
	YY_BREAK
case 53:
/* rule 53 can match eol */
YY_RULE_SETUP
#line 487 "lexgrog.l"
fill_mode = true;
	YY_BREAK

case 54:
/* rule 54 can match eol */
YY_RULE_SETUP
#line 490 "lexgrog.l"
/* strip continuations */
	YY_BREAK
/* convert to DASH */

case 55:
/* rule 55 can match eol */
#line 495 "lexgrog.l"
case 56:
/* rule 56 can match eol */
#line 496 "lexgrog.l"
case 57:
/* rule 57 can match eol */
#line 497 "lexgrog.l"
case 58:
/* rule 58 can match eol */
#line 498 "lexgrog.l"
case 59:
/* rule 59 can match eol */
YY_RULE_SETUP
#line 498 "lexgrog.l"
{
		add_separator_to_whatis ();
		BEGIN (MAN_DESC);
	}
	YY_BREAK

case 60:
/* rule 60 can match eol */
YY_RULE_SETUP
#line 503 "lexgrog.l"
add_separator_to_whatis ();
	YY_BREAK
/* escape sequences and special characters */

case 61:
/* rule 61 can match eol */
YY_RULE_SETUP
#line 507 "lexgrog.l"
add_char_to_whatis ('\\');
	YY_BREAK
case 62:
/* rule 62 can match eol */
YY_RULE_SETUP
#line 508 "lexgrog.l"
add_char_to_whatis ('\'');
	YY_BREAK
case 63:
/* rule 63 can match eol */
YY_RULE_SETUP
#line 509 "lexgrog.l"
add_char_to_whatis ('`');
	YY_BREAK
case 64:
/* rule 64 can match eol */
YY_RULE_SETUP
#line 510 "lexgrog.l"
add_char_to_whatis ('-');
	YY_BREAK
case 65:
/* rule 65 can match eol */
YY_RULE_SETUP
#line 511 "lexgrog.l"
add_char_to_whatis ('-');
	YY_BREAK
case 66:
/* rule 66 can match eol */
YY_RULE_SETUP
#line 512 "lexgrog.l"
add_char_to_whatis ('.');
	YY_BREAK
case 67:
/* rule 67 can match eol */
YY_RULE_SETUP
#line 513 "lexgrog.l"
add_char_to_whatis (' ');
	YY_BREAK
case 68:
/* rule 68 can match eol */
YY_RULE_SETUP
#line 514 "lexgrog.l"
add_char_to_whatis ('_');
	YY_BREAK
case 69:
/* rule 69 can match eol */
YY_RULE_SETUP
#line 515 "lexgrog.l"
add_char_to_whatis ('\t');
	YY_BREAK
case 70:
/* rule 70 can match eol */
YY_RULE_SETUP
#line 517 "lexgrog.l"
/* various useless control chars */
	YY_BREAK
case 71:
/* rule 71 can match eol */
YY_RULE_SETUP
#line 518 "lexgrog.l"
/* various inline functions */
	YY_BREAK
case 72:
/* rule 72 can match eol */
YY_RULE_SETUP
#line 520 "lexgrog.l"
/* interpolate arg */
	YY_BREAK
/* roff named glyphs */
case 73:
/* rule 73 can match eol */
YY_RULE_SETUP
#line 523 "lexgrog.l"
add_glyph_to_whatis (yytext + 2, 2);
	YY_BREAK
/* perldoc strings */
case 74:
/* rule 74 can match eol */
YY_RULE_SETUP
#line 525 "lexgrog.l"
add_perldoc_to_whatis (yytext + 3, 2);
	YY_BREAK
case 75:
/* rule 75 can match eol */
YY_RULE_SETUP
#line 526 "lexgrog.l"
add_perldoc_to_whatis (yytext + 2, 1);
	YY_BREAK
case 76:
/* rule 76 can match eol */
YY_RULE_SETUP
#line 528 "lexgrog.l"
/* comment */
	YY_BREAK
case 77:
/* rule 77 can match eol */
YY_RULE_SETUP
#line 530 "lexgrog.l"
/* font changes */
	YY_BREAK
case 78:
/* rule 78 can match eol */
YY_RULE_SETUP
#line 531 "lexgrog.l"
/* mark input place in register */
	YY_BREAK
case 79:
/* rule 79 can match eol */
YY_RULE_SETUP
#line 533 "lexgrog.l"
/* interpolate number register */
	YY_BREAK
case 80:
/* rule 80 can match eol */
YY_RULE_SETUP
#line 534 "lexgrog.l"
/* overstrike chars */
	YY_BREAK
case 81:
/* rule 81 can match eol */
YY_RULE_SETUP
#line 536 "lexgrog.l"
/* size changes */
	YY_BREAK
case 82:
/* rule 82 can match eol */
YY_RULE_SETUP
#line 537 "lexgrog.l"
/* width of string */
	YY_BREAK
case 83:
/* rule 83 can match eol */
YY_RULE_SETUP
#line 539 "lexgrog.l"
/* catch all */
	YY_BREAK
case 84:
/* rule 84 can match eol */
YY_RULE_SETUP
#line 541 "lexgrog.l"
/* function() in hpux */
	YY_BREAK

/* some people rather ambitiously use non-trivial mdoc macros in NAME
    sections; cope with those that have been seen in the wild, and a few
    more */

case 85:
/* rule 85 can match eol */
YY_RULE_SETUP
#line 548 "lexgrog.l"
BEGIN (MAN_DESC_AT);
	YY_BREAK
case 86:
/* rule 86 can match eol */
YY_RULE_SETUP
#line 549 "lexgrog.l"
BEGIN (MAN_DESC_BSX);
	YY_BREAK
case 87:
/* rule 87 can match eol */
YY_RULE_SETUP
#line 550 "lexgrog.l"
BEGIN (MAN_DESC_BX);
	YY_BREAK
case 88:
/* rule 88 can match eol */
YY_RULE_SETUP
#line 551 "lexgrog.l"
BEGIN (MAN_DESC_FX);
	YY_BREAK
case 89:
/* rule 89 can match eol */
YY_RULE_SETUP
#line 552 "lexgrog.l"
BEGIN (MAN_DESC_NX);
	YY_BREAK
case 90:
/* rule 90 can match eol */
YY_RULE_SETUP
#line 553 "lexgrog.l"
BEGIN (MAN_DESC_OX);
	YY_BREAK
case 91:
/* rule 91 can match eol */
YY_RULE_SETUP
#line 554 "lexgrog.l"
add_word_to_whatis ("UNIX");
	YY_BREAK
case 92:
/* rule 92 can match eol */
YY_RULE_SETUP
#line 556 "lexgrog.l"
{
		add_word_to_whatis ("\"");
		BEGIN (MAN_DESC_DQ);
	}
	YY_BREAK


case 93:
YY_RULE_SETUP
#line 563 "lexgrog.l"
mdoc_text ("Version 32V AT&T UNIX");
	YY_BREAK
case 94:
YY_RULE_SETUP
#line 564 "lexgrog.l"
mdoc_text ("Version 1 AT&T UNIX");
	YY_BREAK
case 95:
YY_RULE_SETUP
#line 565 "lexgrog.l"
mdoc_text ("Version 2 AT&T UNIX");
	YY_BREAK
case 96:
YY_RULE_SETUP
#line 566 "lexgrog.l"
mdoc_text ("Version 3 AT&T UNIX");
	YY_BREAK
case 97:
YY_RULE_SETUP
#line 567 "lexgrog.l"
mdoc_text ("Version 4 AT&T UNIX");
	YY_BREAK
case 98:
YY_RULE_SETUP
#line 568 "lexgrog.l"
mdoc_text ("Version 5 AT&T UNIX");
	YY_BREAK
case 99:
YY_RULE_SETUP
#line 569 "lexgrog.l"
mdoc_text ("Version 6 AT&T UNIX");
	YY_BREAK
case 100:
YY_RULE_SETUP
#line 570 "lexgrog.l"
mdoc_text ("Version 7 AT&T UNIX");
	YY_BREAK
case 101:
YY_RULE_SETUP
#line 571 "lexgrog.l"
mdoc_text ("AT&T System V UNIX");
	YY_BREAK
case 102:
YY_RULE_SETUP
#line 572 "lexgrog.l"
mdoc_text ("AT&T System V.1 UNIX");
	YY_BREAK
case 103:
YY_RULE_SETUP
#line 573 "lexgrog.l"
mdoc_text ("AT&T System V.2 UNIX");
	YY_BREAK
case 104:
YY_RULE_SETUP
#line 574 "lexgrog.l"
mdoc_text ("AT&T System V.3 UNIX");
	YY_BREAK
case 105:
YY_RULE_SETUP
#line 575 "lexgrog.l"
mdoc_text ("AT&T System V.4 UNIX");
	YY_BREAK
case 106:
/* rule 106 can match eol */
YY_RULE_SETUP
#line 576 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("AT&T UNIX");
	}
	YY_BREAK


case 107:
YY_RULE_SETUP
#line 583 "lexgrog.l"
{
		add_word_to_whatis ("BSD/OS");
		add_wordn_to_whatis (yytext, yyleng);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 108:
/* rule 108 can match eol */
YY_RULE_SETUP
#line 588 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("BSD/OS");
	}
	YY_BREAK


case 109:
YY_RULE_SETUP
#line 595 "lexgrog.l"
mdoc_text ("BSD (currently in alpha test)");
	YY_BREAK
case 110:
YY_RULE_SETUP
#line 596 "lexgrog.l"
mdoc_text ("BSD (currently in beta test)");
	YY_BREAK
case 111:
YY_RULE_SETUP
#line 597 "lexgrog.l"
mdoc_text ("BSD (currently under development");
	YY_BREAK
case 112:
YY_RULE_SETUP
#line 598 "lexgrog.l"
{
		add_wordn_to_whatis (yytext, yyleng);
		add_str_to_whatis ("BSD", 3);
		BEGIN (MAN_DESC_BX_RELEASE);
	}
	YY_BREAK
case 113:
/* rule 113 can match eol */
YY_RULE_SETUP
#line 603 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("BSD");
	}
	YY_BREAK


case 114:
YY_RULE_SETUP
#line 610 "lexgrog.l"
{
		add_str_to_whatis ("-Reno", 5);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 115:
YY_RULE_SETUP
#line 614 "lexgrog.l"
{
		add_str_to_whatis ("-Tahoe", 6);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 116:
YY_RULE_SETUP
#line 618 "lexgrog.l"
{
		add_str_to_whatis ("-Lite", 5);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 117:
YY_RULE_SETUP
#line 622 "lexgrog.l"
{
		add_str_to_whatis ("-Lite2", 6);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 118:
/* rule 118 can match eol */
YY_RULE_SETUP
#line 626 "lexgrog.l"
{
		yyless (0);
		BEGIN (MAN_DESC);
	}
	YY_BREAK

case 119:
YY_RULE_SETUP
#line 632 "lexgrog.l"
{
	add_str_to_whatis (yytext, yyleng);
	add_char_to_whatis ('"');
	BEGIN (MAN_DESC);
}
	YY_BREAK

case 120:
YY_RULE_SETUP
#line 639 "lexgrog.l"
{
		add_word_to_whatis ("FreeBSD");
		add_wordn_to_whatis (yytext, yyleng);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 121:
/* rule 121 can match eol */
YY_RULE_SETUP
#line 644 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("FreeBSD");
	}
	YY_BREAK


case 122:
YY_RULE_SETUP
#line 651 "lexgrog.l"
{
		add_word_to_whatis ("NetBSD");
		add_wordn_to_whatis (yytext, yyleng);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 123:
/* rule 123 can match eol */
YY_RULE_SETUP
#line 656 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("NetBSD");
	}
	YY_BREAK


case 124:
YY_RULE_SETUP
#line 663 "lexgrog.l"
{
		add_word_to_whatis ("OpenBSD");
		add_wordn_to_whatis (yytext, yyleng);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 125:
/* rule 125 can match eol */
YY_RULE_SETUP
#line 668 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("OpenBSD");
	}
	YY_BREAK

/* collapse spaces, escaped spaces, tabs, newlines to a single space */
case 126:
/* rule 126 can match eol */
YY_RULE_SETUP
#line 675 "lexgrog.l"
add_char_to_whatis (' ');
	YY_BREAK
/* a ROFF break request, a paragraph request, or an indentation change
    usually means we have multiple whatis definitions, provide a separator
    for later processing */

case 127:
/* rule 127 can match eol */
#line 682 "lexgrog.l"
case 128:
/* rule 128 can match eol */
#line 683 "lexgrog.l"
case 129:
/* rule 129 can match eol */
#line 684 "lexgrog.l"
case 130:
/* rule 130 can match eol */
#line 685 "lexgrog.l"
case 131:
/* rule 131 can match eol */
#line 686 "lexgrog.l"
case 132:
/* rule 132 can match eol */
#line 687 "lexgrog.l"
case 133:
/* rule 133 can match eol */
#line 688 "lexgrog.l"
case 134:
/* rule 134 can match eol */
YY_RULE_SETUP
#line 688 "lexgrog.l"
{
		add_char_to_whatis ((char) 0x11);
		BEGIN (MAN_NAME);
	}
	YY_BREAK

/* any other roff request we don't recognise terminates definitions */
case 135:
/* rule 135 can match eol */
YY_RULE_SETUP
#line 695 "lexgrog.l"
{
	*p_name = '\0';
	BEGIN (MAN_REST);
}
	YY_BREAK
/* pass words as a chunk. speed optimization */
case 136:
YY_RULE_SETUP
#line 701 "lexgrog.l"
add_str_to_whatis (yytext, yyleng);
	YY_BREAK
/* normalise the comma (,) separators */
case 137:
/* rule 137 can match eol */
#line 705 "lexgrog.l"
case 138:
/* rule 138 can match eol */
YY_RULE_SETUP
#line 705 "lexgrog.l"
add_str_to_whatis (", ", 2);
	YY_BREAK
case 139:
/* rule 139 can match eol */
YY_RULE_SETUP
#line 707 "lexgrog.l"
{
	newline_found ();
	add_char_to_whatis (yytext[yyleng - 1]);
}
	YY_BREAK
case 140:
YY_RULE_SETUP
#line 712 "lexgrog.l"
add_char_to_whatis (*yytext);
	YY_BREAK
/* default EOF rule */
case YY_STATE_EOF(INITIAL):
case YY_STATE_EOF(MAN_DESC_AT):
case YY_STATE_EOF(MAN_DESC_BSX):
case YY_STATE_EOF(MAN_DESC_BX):
case YY_STATE_EOF(MAN_DESC_BX_RELEASE):
case YY_STATE_EOF(MAN_DESC_DQ):
case YY_STATE_EOF(MAN_DESC_FX):
case YY_STATE_EOF(MAN_DESC_NX):
case YY_STATE_EOF(MAN_DESC_OX):
case YY_STATE_EOF(CAT_NAME):
case YY_STATE_EOF(CAT_FILE):
case YY_STATE_EOF(MAN_FILE):
case YY_STATE_EOF(CAT_REST):
case YY_STATE_EOF(FORCE_EXIT):
#line 715 "lexgrog.l"
return 1;
	YY_BREAK
case 141:
YY_RULE_SETUP
#line 717 "lexgrog.l"
ECHO;
	YY_BREAK
#line 4158 "lexgrog.c"

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - (yytext_ptr)) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = (yy_hold_char);
		YY_RESTORE_YY_MORE_OFFSET

		if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * yylex().  If so, then we have to assure
			 * consistency between YY_CURRENT_BUFFER and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
			YY_CURRENT_BUFFER_LVALUE->yy_input_file = yyin;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( (yy_c_buf_p) <= &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			(yy_c_buf_p) = (yytext_ptr) + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state(  );

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = (yytext_ptr) + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++(yy_c_buf_p);
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = (yy_last_accepting_cpos);
				yy_current_state = (yy_last_accepting_state);
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer(  ) )
			{
			case EOB_ACT_END_OF_FILE:
				{
				(yy_did_buffer_switch_on_eof) = 0;

				if ( yywrap(  ) )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					(yy_c_buf_p) = (yytext_ptr) + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				(yy_c_buf_p) =
					(yytext_ptr) + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				(yy_c_buf_p) =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)];

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
	} /* end of user's declarations */
} /* end of yylex */

/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */
static int yy_get_next_buffer (void)
{
    	char *dest = YY_CURRENT_BUFFER_LVALUE->yy_ch_buf;
	char *source = (yytext_ptr);
	int number_to_move, i;
	int ret_val;

	if ( (yy_c_buf_p) > &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( YY_CURRENT_BUFFER_LVALUE->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( (yy_c_buf_p) - (yytext_ptr) - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) ((yy_c_buf_p) - (yytext_ptr) - 1);

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars) = 0;

	else
		{
			int num_to_read =
			YY_CURRENT_BUFFER_LVALUE->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = YY_CURRENT_BUFFER_LVALUE;

			int yy_c_buf_p_offset =
				(int) ((yy_c_buf_p) - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					yyrealloc( (void *) b->yy_ch_buf,
							 (yy_size_t) (b->yy_buf_size + 2)  );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = NULL;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			(yy_c_buf_p) = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = YY_CURRENT_BUFFER_LVALUE->yy_buf_size -
						number_to_move - 1;

			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move]),
			(yy_n_chars), num_to_read );

		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	if ( (yy_n_chars) == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart( yyin  );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	if (((yy_n_chars) + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {
		/* Extend the array by 50%, plus the number we really need. */
		int new_size = (yy_n_chars) + number_to_move + ((yy_n_chars) >> 1);
		YY_CURRENT_BUFFER_LVALUE->yy_ch_buf = (char *) yyrealloc(
			(void *) YY_CURRENT_BUFFER_LVALUE->yy_ch_buf, (yy_size_t) new_size  );
		if ( ! YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			YY_FATAL_ERROR( "out of dynamic memory in yy_get_next_buffer()" );
		/* "- 2" to take care of EOB's */
		YY_CURRENT_BUFFER_LVALUE->yy_buf_size = (int) (new_size - 2);
	}

	(yy_n_chars) += number_to_move;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] = YY_END_OF_BUFFER_CHAR;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] = YY_END_OF_BUFFER_CHAR;

	(yytext_ptr) = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[0];

	return ret_val;
}

/* yy_get_previous_state - get the state just before the EOB char was reached */

    static yy_state_type yy_get_previous_state (void)
{
	yy_state_type yy_current_state;
	char *yy_cp;
    
	yy_current_state = (yy_start);

	for ( yy_cp = (yytext_ptr) + YY_MORE_ADJ; yy_cp < (yy_c_buf_p); ++yy_cp )
		{
		YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		if ( yy_accept[yy_current_state] )
			{
			(yy_last_accepting_state) = yy_current_state;
			(yy_last_accepting_cpos) = yy_cp;
			}
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 1573 )
				yy_c = yy_meta[yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
		}

	return yy_current_state;
}

/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */
    static yy_state_type yy_try_NUL_trans  (yy_state_type yy_current_state )
{
	int yy_is_jam;
    	char *yy_cp = (yy_c_buf_p);

	YY_CHAR yy_c = 1;
	if ( yy_accept[yy_current_state] )
		{
		(yy_last_accepting_state) = yy_current_state;
		(yy_last_accepting_cpos) = yy_cp;
		}
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 1573 )
			yy_c = yy_meta[yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
	yy_is_jam = (yy_current_state == 1572);

		return yy_is_jam ? 0 : yy_current_state;
}

#ifndef YY_NO_UNPUT

#endif

#ifndef YY_NO_INPUT
#ifdef __cplusplus
    static int yyinput (void)
#else
    static int input  (void)
#endif

{
	int c;
    
	*(yy_c_buf_p) = (yy_hold_char);

	if ( *(yy_c_buf_p) == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( (yy_c_buf_p) < &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			/* This was really a NUL. */
			*(yy_c_buf_p) = '\0';

		else
			{ /* need more input */
			int offset = (int) ((yy_c_buf_p) - (yytext_ptr));
			++(yy_c_buf_p);

			switch ( yy_get_next_buffer(  ) )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					yyrestart( yyin );

					/*FALLTHROUGH*/

				case EOB_ACT_END_OF_FILE:
					{
					if ( yywrap(  ) )
						return 0;

					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					(yy_c_buf_p) = (yytext_ptr) + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) (yy_c_buf_p);	/* cast for 8-bit char's */
	*(yy_c_buf_p) = '\0';	/* preserve yytext */
	(yy_hold_char) = *++(yy_c_buf_p);

	return c;
}
#endif	/* ifndef YY_NO_INPUT */

/** Immediately switch to a different input stream.
 * @param input_file A readable stream.
 * 
 * @note This function does not reset the start condition to @c INITIAL .
 */
    void yyrestart  (FILE * input_file )
{
    
	if ( ! YY_CURRENT_BUFFER ){
        yyensure_buffer_stack ();
		YY_CURRENT_BUFFER_LVALUE =
            yy_create_buffer( yyin, YY_BUF_SIZE );
	}

	yy_init_buffer( YY_CURRENT_BUFFER, input_file );
	yy_load_buffer_state(  );
}

/** Switch to a different input buffer.
 * @param new_buffer The new input buffer.
 * 
 */
    void yy_switch_to_buffer  (YY_BUFFER_STATE  new_buffer )
{
    
	/* TODO. We should be able to replace this entire function body
	 * with
	 *		yypop_buffer_state();
	 *		yypush_buffer_state(new_buffer);
     */
	yyensure_buffer_stack ();
	if ( YY_CURRENT_BUFFER == new_buffer )
		return;

	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	YY_CURRENT_BUFFER_LVALUE = new_buffer;
	yy_load_buffer_state(  );

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	(yy_did_buffer_switch_on_eof) = 1;
}

static void yy_load_buffer_state  (void)
{
    	(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
	(yytext_ptr) = (yy_c_buf_p) = YY_CURRENT_BUFFER_LVALUE->yy_buf_pos;
	yyin = YY_CURRENT_BUFFER_LVALUE->yy_input_file;
	(yy_hold_char) = *(yy_c_buf_p);
}

/** Allocate and initialize an input buffer state.
 * @param file A readable stream.
 * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
 * 
 * @return the allocated buffer state.
 */
    YY_BUFFER_STATE yy_create_buffer  (FILE * file, int  size )
{
	YY_BUFFER_STATE b;
    
	b = (YY_BUFFER_STATE) yyalloc( sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) yyalloc( (yy_size_t) (b->yy_buf_size + 2)  );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	yy_init_buffer( b, file );

	return b;
}

/** Destroy the buffer.
 * @param b a buffer created with yy_create_buffer()
 * 
 */
    void yy_delete_buffer (YY_BUFFER_STATE  b )
{
    
	if ( ! b )
		return;

	if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */
		YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		yyfree( (void *) b->yy_ch_buf  );

	yyfree( (void *) b  );
}

/* Initializes or reinitializes a buffer.
 * This function is sometimes called more than once on the same buffer,
 * such as during a yyrestart() or at EOF.
 */
    static void yy_init_buffer  (YY_BUFFER_STATE  b, FILE * file )

{
	int oerrno = errno;
    
	yy_flush_buffer( b );

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

    /* If b is the current buffer, then yy_init_buffer was _probably_
     * called from yyrestart() or through yy_get_next_buffer.
     * In that case, we don't want to reset the lineno or column.
     */
    if (b != YY_CURRENT_BUFFER){
        b->yy_bs_lineno = 1;
        b->yy_bs_column = 0;
    }

        b->yy_is_interactive = 0;
    
	errno = oerrno;
}

/** Discard all buffered characters. On the next scan, YY_INPUT will be called.
 * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.
 * 
 */
    void yy_flush_buffer (YY_BUFFER_STATE  b )
{
    	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == YY_CURRENT_BUFFER )
		yy_load_buffer_state(  );
}

/** Pushes the new state onto the stack. The new state becomes
 *  the current state. This function will allocate the stack
 *  if necessary.
 *  @param new_buffer The new state.
 *  
 */
void yypush_buffer_state (YY_BUFFER_STATE new_buffer )
{
    	if (new_buffer == NULL)
		return;

	yyensure_buffer_stack();

	/* This block is copied from yy_switch_to_buffer. */
	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	/* Only push if top exists. Otherwise, replace top. */
	if (YY_CURRENT_BUFFER)
		(yy_buffer_stack_top)++;
	YY_CURRENT_BUFFER_LVALUE = new_buffer;

	/* copied from yy_switch_to_buffer. */
	yy_load_buffer_state(  );
	(yy_did_buffer_switch_on_eof) = 1;
}

/** Removes and deletes the top of the stack, if present.
 *  The next element becomes the new top.
 *  
 */
void yypop_buffer_state (void)
{
    	if (!YY_CURRENT_BUFFER)
		return;

	yy_delete_buffer(YY_CURRENT_BUFFER );
	YY_CURRENT_BUFFER_LVALUE = NULL;
	if ((yy_buffer_stack_top) > 0)
		--(yy_buffer_stack_top);

	if (YY_CURRENT_BUFFER) {
		yy_load_buffer_state(  );
		(yy_did_buffer_switch_on_eof) = 1;
	}
}

/* Allocates the stack if it does not exist.
 *  Guarantees space for at least one push.
 */
static void yyensure_buffer_stack (void)
{
	yy_size_t num_to_alloc;
    
	if (!(yy_buffer_stack)) {

		/* First allocation is just for 2 elements, since we don't know if this
		 * scanner will even need a stack. We use 2 instead of 1 to avoid an
		 * immediate realloc on the next call.
         */
      num_to_alloc = 1; /* After all that talk, this was set to 1 anyways... */
		(yy_buffer_stack) = (struct yy_buffer_state**)yyalloc
								(num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );

		memset((yy_buffer_stack), 0, num_to_alloc * sizeof(struct yy_buffer_state*));

		(yy_buffer_stack_max) = num_to_alloc;
		(yy_buffer_stack_top) = 0;
		return;
	}

	if ((yy_buffer_stack_top) >= ((yy_buffer_stack_max)) - 1){

		/* Increase the buffer to prepare for a possible push. */
		yy_size_t grow_size = 8 /* arbitrary grow size */;

		num_to_alloc = (yy_buffer_stack_max) + grow_size;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyrealloc
								((yy_buffer_stack),
								num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );

		/* zero only the new slots.*/
		memset((yy_buffer_stack) + (yy_buffer_stack_max), 0, grow_size * sizeof(struct yy_buffer_state*));
		(yy_buffer_stack_max) = num_to_alloc;
	}
}

/** Setup the input buffer state to scan directly from a user-specified character buffer.
 * @param base the character buffer
 * @param size the size in bytes of the character buffer
 * 
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE yy_scan_buffer  (char * base, yy_size_t  size )
{
	YY_BUFFER_STATE b;
    
	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return NULL;

	b = (YY_BUFFER_STATE) yyalloc( sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );

	b->yy_buf_size = (int) (size - 2);	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = NULL;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	yy_switch_to_buffer( b  );

	return b;
}

/** Setup the input buffer state to scan a string. The next call to yylex() will
 * scan from a @e copy of @a str.
 * @param yystr a NUL-terminated string to scan
 * 
 * @return the newly allocated buffer state object.
 * @note If you want to scan bytes that may contain NUL values, then use
 *       yy_scan_bytes() instead.
 */
YY_BUFFER_STATE yy_scan_string (const char * yystr )
{
    
	return yy_scan_bytes( yystr, (int) strlen(yystr) );
}

/** Setup the input buffer state to scan the given bytes. The next call to yylex() will
 * scan from a @e copy of @a bytes.
 * @param yybytes the byte buffer to scan
 * @param _yybytes_len the number of bytes in the buffer pointed to by @a bytes.
 * 
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE yy_scan_bytes  (const char * yybytes, int  _yybytes_len )
{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	int i;
    
	/* Get memory for full buffer, including space for trailing EOB's. */
	n = (yy_size_t) (_yybytes_len + 2);
	buf = (char *) yyalloc( n  );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );

	for ( i = 0; i < _yybytes_len; ++i )
		buf[i] = yybytes[i];

	buf[_yybytes_len] = buf[_yybytes_len+1] = YY_END_OF_BUFFER_CHAR;

	b = yy_scan_buffer( buf, n );
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
}

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

static void yynoreturn yy_fatal_error (const char* msg )
{
			fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
}

/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		yytext[yyleng] = (yy_hold_char); \
		(yy_c_buf_p) = yytext + yyless_macro_arg; \
		(yy_hold_char) = *(yy_c_buf_p); \
		*(yy_c_buf_p) = '\0'; \
		yyleng = yyless_macro_arg; \
		} \
	while ( 0 )

/* Accessor  methods (get/set functions) to struct members. */

/** Get the current line number.
 * 
 */
int yyget_lineno  (void)
{
    
    return yylineno;
}

/** Get the input stream.
 * 
 */
FILE *yyget_in  (void)
{
        return yyin;
}

/** Get the output stream.
 * 
 */
FILE *yyget_out  (void)
{
        return yyout;
}

/** Get the length of the current token.
 * 
 */
int yyget_leng  (void)
{
        return yyleng;
}

/** Get the current token.
 * 
 */

char *yyget_text  (void)
{
        return yytext;
}

/** Set the current line number.
 * @param _line_number line number
 * 
 */
void yyset_lineno (int  _line_number )
{
    
    yylineno = _line_number;
}

/** Set the input stream. This does not discard the current
 * input buffer.
 * @param _in_str A readable stream.
 * 
 * @see yy_switch_to_buffer
 */
void yyset_in (FILE *  _in_str )
{
        yyin = _in_str ;
}

void yyset_out (FILE *  _out_str )
{
        yyout = _out_str ;
}

int yyget_debug  (void)
{
        return yy_flex_debug;
}

void yyset_debug (int  _bdebug )
{
        yy_flex_debug = _bdebug ;
}

static int yy_init_globals (void)
{
        /* Initialization is the same as for the non-reentrant scanner.
     * This function is called from yylex_destroy(), so don't allocate here.
     */

    (yy_buffer_stack) = NULL;
    (yy_buffer_stack_top) = 0;
    (yy_buffer_stack_max) = 0;
    (yy_c_buf_p) = NULL;
    (yy_init) = 0;
    (yy_start) = 0;

/* Defined in main.c */
#ifdef YY_STDINIT
    yyin = stdin;
    yyout = stdout;
#else
    yyin = NULL;
    yyout = NULL;
#endif

    /* For future reference: Set errno on error, since we are called by
     * yylex_init()
     */
    return 0;
}

/* yylex_destroy is for both reentrant and non-reentrant scanners. */
int yylex_destroy  (void)
{
    
    /* Pop the buffer stack, destroying each element. */
	while(YY_CURRENT_BUFFER){
		yy_delete_buffer( YY_CURRENT_BUFFER  );
		YY_CURRENT_BUFFER_LVALUE = NULL;
		yypop_buffer_state();
	}

	/* Destroy the stack itself. */
	yyfree((yy_buffer_stack) );
	(yy_buffer_stack) = NULL;

    /* Reset the globals. This is important in a non-reentrant scanner so the next time
     * yylex() is called, initialization will occur. */
    yy_init_globals( );

    return 0;
}

/*
 * Internal utility routines.
 */

#ifndef yytext_ptr
static void yy_flex_strncpy (char* s1, const char * s2, int n )
{
		
	int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (const char * s )
{
	int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
}
#endif

void *yyalloc (yy_size_t  size )
{
			return malloc(size);
}

void *yyrealloc  (void * ptr, yy_size_t  size )
{
		
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return realloc(ptr, size);
}

void yyfree (void * ptr )
{
			free( (char *) ptr );	/* see yyrealloc() for (char *) cast */
}

#define YYTABLES_NAME "yytables"

#line 717 "lexgrog.l"


/* print warning and force scanner to terminate */
static void too_big (void)
{
	/* Even though MAX_NAME is a macro expanding to a constant, we
	 * translate it using ngettext anyway because that will make it
	 * easier to change the macro later.
	 */
	error (0, 0,
	       ngettext ("warning: whatis for %s exceeds %d byte, "
			 "truncating.",
			 "warning: whatis for %s exceeds %d bytes, "
			 "truncating.", MAX_NAME),
	       fname, MAX_NAME);

	BEGIN (FORCE_EXIT);
}

/* append a string to newname if enough room */
static void add_str_to_whatis (const char *string, size_t length)
{
	if (p_name - newname + length >= MAX_NAME)
		too_big ();
	else {
		(void) strncpy (p_name, string, length);
		p_name += length;
	}
}

/* append a char to newname if enough room */
static void add_char_to_whatis (unsigned char c)
{
	if (p_name - newname + 1 >= MAX_NAME)
		too_big ();
	else if (waiting_for_quote && c == '"')
		waiting_for_quote = false;
	else
		*p_name++ = c;
}

/* append the " - " separator to newname, trimming the first space if one's
 * already there
 */
static void add_separator_to_whatis (void)
{
	if (p_name != newname && *(p_name - 1) != ' ')
		add_char_to_whatis (' ');
	add_str_to_whatis ("- ", 2);
}

/* append a word to newname if enough room, ensuring only necessary
   surrounding space */
static void add_wordn_to_whatis (const char *string, size_t length)
{
	if (p_name != newname && *(p_name - 1) != ' ')
		add_char_to_whatis (' ');
	while (length && string[length - 1] == ' ')
		--length;
	if (length)
		add_str_to_whatis (string, length);
}

static void add_word_to_whatis (const char *string)
{
	add_wordn_to_whatis (string, strlen (string));
}

struct compare_macro_key {
	const char *string;
	size_t length;
};

static int compare_macro (const void *left, const void *right)
{
	const struct compare_macro_key *key = left;
	const struct macro *value = right;
	int cmp;

	cmp = strncmp (key->string, value->name, key->length);
	if (cmp)
		return cmp;
	/* equal up to key->length, so value->name must be at least size
	 * key->length + 1
	 */
	else if (value->name[key->length])
		return -1;
	else
		return 0;
}

static void add_macro_to_whatis (const struct macro *macros, size_t n_macros,
				 const char *string, size_t length)
{
	struct compare_macro_key key;
	const struct macro *macro;

	key.string = string;
	key.length = length;
	macro = bsearch (&key, macros, n_macros, sizeof (struct macro),
			 compare_macro);
	if (macro)
		add_str_to_whatis (macro->value, strlen (macro->value));
}

static void add_glyph_to_whatis (const char *string, size_t length)
{
	add_macro_to_whatis (glyphs, ARRAY_SIZE (glyphs), string, length);
}

static void add_perldoc_to_whatis (const char *string, size_t length)
{
	add_macro_to_whatis (perldocs, ARRAY_SIZE (perldocs), string, length);
}

static void mdoc_text (const char *string)
{
	add_word_to_whatis (string);
	BEGIN (MAN_DESC);
}

static void newline_found (void)
{
	/* If we are mid p_name and the last added char was not a space,
	 * best add one.
	 */
	if (p_name != newname && *(p_name - 1) != ' ') {
		if (fill_mode)
			add_char_to_whatis (' ');
		else {
			add_char_to_whatis ((char) 0x11);
			BEGIN (MAN_NAME);
		}
	}
	waiting_for_quote = false;
}

int find_name (const char *file, const char *filename, lexgrog *p_lg,
	       const char *encoding)
{
	int ret = 0;
	decompress *d;
	char *page_encoding = NULL;
	bool run_col = p_lg->type == CATPAGE && *PROG_COL != '\0';

	if (strcmp (file, "-") == 0) {
		d = decompress_fdopen (dup (STDIN_FILENO));
	} else {
		struct stat st;
		int decompress_flags;
		char *lang;

		if (stat (file, &st)) {
			error (0, errno, "%s", file);
			return 0;
		}

		if (S_ISDIR (st.st_mode)) {
			error (0, EISDIR, "%s", file);
			return 0;
		}

		drop_effective_privs ();
		decompress_flags = 0;
		/* If we're looking at a cat page, then we need to run col
		 * over it, which doesn't work conveniently with an
		 * in-process decompressor.
		 */
		if (!run_col)
			decompress_flags |= DECOMPRESS_ALLOW_INPROCESS;
		d = decompress_open (file, decompress_flags);
		if (!d) {
			error (0, errno, _("can't open %s"), file);
			regain_effective_privs ();
			return 0;
		}
		regain_effective_privs ();

		if (!encoding) {
			lang = lang_dir (file);
			page_encoding = get_page_encoding (lang);
			free (lang);
		}
	}
	if (!page_encoding && encoding)
		page_encoding = xstrdup (encoding);
	if (page_encoding) {
		if (decompress_is_pipeline (d))
			add_manconv (decompress_get_pipeline (d),
				     page_encoding, "UTF-8");
		else if (manconv_inprocess (d, page_encoding, "UTF-8") != 0)
			/* manconv should already have written to stderr, so
			 * just return zero (i.e. no result).
			 */
			goto out;
	}
	if (run_col) {
		pipecmd *col_cmd;
		col_cmd = pipecmd_new_args
			(PROG_COL, "-b", "-p", "-x", (void *) 0);
		pipecmd_pre_exec (col_cmd, sandbox_load, sandbox_free,
				  sandbox);
		pipeline_command (decompress_get_pipeline (d), col_cmd);
	}
	decompress_start (d);

	ret = find_name_decompressed (d, filename, p_lg);

out:
	free (page_encoding);
	decompress_free (d);
	return ret;
}

int find_name_decompressed (decompress *d, const char *filename, lexgrog *p_lg)
{
	int ret;

	decomp = d;

	fname = filename;
	*(p_name = newname) = '\0';
	memset (filters, '_', sizeof (filters));

	fill_mode = true;
	waiting_for_quote = false;

	if (p_lg->type == CATPAGE)
		BEGIN (CAT_FILE);
	else
		BEGIN (MAN_FILE);

	drop_effective_privs ();

	yyrestart (NULL);
	ret = yylex ();

	regain_effective_privs ();

	decompress_wait (decomp);

	if (ret)
		return 0;
	else {
		char f_tmp[MAX_FILTERS];
		int j, k;

		/* wipe out any leading or trailing spaces */
		if (*newname) {
			for (p_name = strchr (newname, '\0');
			     *(p_name - 1) == ' ';
			     p_name--);
			if (*p_name == ' ')
				*p_name = '\0';
		}
		for (p_name = newname; *p_name == ' '; p_name++);
		p_lg->whatis = xstrdup (p_name);
		memset (f_tmp, '\0', MAX_FILTERS);
		f_tmp[0] = '-';
		for (j = k = 0; j < MAX_FILTERS; j++)
			if (filters[j] != '_')
				f_tmp[k++] = filters[j];
		p_lg->filters = xstrdup (f_tmp);
		return p_name[0];
	}
}

